;=========================================================;
; Command                                        11/12/03 ;
;---------------------------------------------------------;
; Checks for command.                                     ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

;====================================================;
;  Command.                                          ;
;====================================================;
StartCommand:
	call  cls_text
	call  ReadyPrompt
	call  SetPalette
StartCommand2:
	call  SetPalette  
	call  InitTopBar
DisplayPrompt:
	call  Prompt
	xor   ecx,ecx
	xor   edx,edx
CheckForKey:
	call  GetCommand
	call  ProcessCmd
	hlt
	jmp   CheckForKey
;====================================================;
; Process Command.                                   ;
;====================================================;
ProcessCmd: 
	pushad
	push  es 
	mov   ax,sys_data				
	mov   es,ax
	mov   esi,nextline
	call  print_string
	mov   esi,nextline
	call  print_string
	mov   edi,CommandBuffer 
	call  UpperCase

;====================================================;
;  CLS.            compare command buffer with 'cls' ;                                       
;====================================================; 
	mov   esi,CommandBuffer 
	mov   cx,4					
	mov   edi,cCLS
	repe  cmpsb
	jne   not_cls
	call  clstext
	jmp   ExitFoundCls
not_cls:
;====================================================;
;  MD.            compare command buffer with 'md'   ;
;====================================================; 
	mov   esi,CommandBuffer 
	mov   cx,3					
	mov   edi,cMD
	repe  cmpsb
	jne   not_md
	cmp   [PromptLetter],'C'  
	jne   MdError1
	call  MakeFolderHddFat
	jc    MdError2
	jmp   ExitFound
MdError1:
	mov   esi,MdErrorMessage1
	call  print_string
	jmp   ExitFound
MdError2:
	cmp   ah,1
	je    NextError
	mov   esi,MdErrorMessage2
	call  print_string
	jmp   ExitFound
NextError:
	mov   esi,MdErrorMessage3
	call  print_string
	jmp   ExitFound
not_md:
;====================================================;
;  VER.            compare command buffer with 'ver' ;                                       
;====================================================; 
	mov   esi,CommandBuffer 
	mov   cx,4					
	mov   edi,cVER
	repe  cmpsb
	jne   not_ver
	call  PrintVer
	jmp   ExitFound
not_ver:
;====================================================;
;  TIME.          compare command buffer with 'time' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,5					
	mov   edi,cTIME
	repe  cmpsb
	jne   not_time
	call  print_time
	mov   esi,nextline
	call  print_string
	jmp   ExitFound
not_time:
;====================================================;
;  DATE.          compare command buffer with 'date' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,5					
	mov   edi,cDATE
	repe  cmpsb
	jne   not_date
	call  print_date
	mov   esi,nextline
	call  print_string
	jmp   ExitFound
not_date:

;====================================================;
;  HELP.          compare command buffer with 'help' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,5					
	mov   edi,cHELP
	repe  cmpsb
	jne   not_help
	mov   esi,HelpMsg
	call  print_string
	mov   esi,nextline
	call  print_string
	jmp   ExitFound
not_help:
;====================================================;
;  CD.              compare command buffer with 'cd' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,3					
	mov   edi,cCD
	repe  cmpsb
	jne   not_cd
	cmp   [PromptLetter],'A'			
	jne   TryHddDirChange
	call  FindDirA
	jc    CdErrorInvalidDir
	jmp   ExitFound
TryHddDirChange:
	cmp   [PromptLetter],'C'  
	jne   CdErrorD
	call  FindDirC
	jc    CdErrorInvalidDir
	jmp   ExitFound
CdErrorInvalidDir:
	mov   esi,InvalidDirMeg
	call  print_string
	jmp   ExitFound
CdErrorD:
	mov   esi,CdErrorMessage
	call  print_string
	jmp   ExitFound
not_cd:
;====================================================;
;  Dir.            compare command buffer with 'DIR' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,4					
	mov   edi,cDIR
	repe  cmpsb
	jne   not_dir
	cmp   [PromptLetter],'A'
	jne   DirHdd 
	cmp   [RootYesNoA],0 
	je    NotAfolder 
	call  DirFolderCommand
	jc    @f
	call  Fdd_motor_off 
	jmp   ExitFound
NotAfolder:
	call  DirCommand 
	jc    @f
	call  UsedSectors 
	call  Fdd_motor_off 
	jmp   ExitFound
@@:
	call  Fdd_motor_off 
	cmp   ah,2
	jne   FdErrorCli
	mov   esi,FloppyErrorMsgFAT12
	call  print_string
	jmp   DirEnd
FdErrorCli:
	mov   esi,FloppyErrorMsg
	call  print_string
	jmp   DirEnd
 ;----------------------------------------------------;
 ; DirHdd.                                            ;
 ;----------------------------------------------------;
DirHdd:
	cmp   [PromptLetter],'C'
	jne   DirCd
	call  LoadMBR 
	call  ReadOneSector
	cmp   [RootYesNoC],0 
	je    NotCfolder 
	call  DirFolderCommandC
	jmp   DirEnd
NotCfolder:
	call  DirPrintFileHdd
	jmp   DirEnd
DirCd:
	mov   esi,nextline
	call  print_string
	call  PrintCdDir
	call  ReadCdDir
	jnc   DirEnd
	mov   esi,CdDvdError
	call  print_string
DirEnd:
	jmp   ExitFound
not_dir:
;====================================================;
;  A:\.             compare command buffer with 'A:' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,3					
	mov   edi,cAdir
	repe  cmpsb
	jne   not_Adir
	mov   [PromptLetter],'A'
	jmp   ExitFound
not_Adir:
;====================================================;
;  C:\.             compare command buffer with 'C:' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,3					
	mov   edi,cCdir
	repe  cmpsb
	jne   not_Cdir
	cmp   byte[MBRloadRun],1
	je    MBRloadRunDone
	call  LoadMBR
	jc    ErrorNoFatFileSys
MBRloadRunDone:
	cmp   byte[FatID],0xff
	je    ErrorNoFatFileSys
	mov   [PromptLetter],'C'
	jmp   ExitFound
ErrorNoFatFileSys:
	mov   esi,MesNoFatFileSys
	call  print_string
	jmp   ExitFound
CdirError:
	mov   esi,NoDriveMes
	call  print_string
	jmp   ExitFound
not_Cdir:
;====================================================;
;  D:\.             compare command buffer with 'D:' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,3					
	mov   edi,cDdir
	repe  cmpsb
	jne   not_Ddir
	cmp   word[CdPort1],0
	je    DdirError
	mov   [PromptLetter],'D'
	jmp   ExitFound
DdirError:
	mov   esi,NoDriveMes
	call  print_string
	jmp   ExitFound
not_Ddir:
;====================================================;
;  SysInfo.    compare command buffer with 'SYSINFO' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,8
	mov   edi,cSYSINFO
	repe  cmpsb
	jne   not_SysInfo
;RAM
	mov   esi,RamMsg
	call  print_string
	mov   eax,dword[TotalMemoryMB]
	cmp   eax,0
	je    ExitNoRam
	call  ConverHexToDec
	mov   esi,numbuff
@@:
	lodsb
	cmp   al,'0'
	jne   NoStrip
	jmp   @b
NoStrip:
	dec   esi
	call  print_string
	mov   esi,RamSizeMsg
	call  print_string
	mov   esi,nextline
	call  print_string
;DRIVES
ExitNoRam:
	mov   esi,HdDriveMsg
	call  print_string
	mov   al,byte[HdDrive1]
	call  write_hex8
	mov   esi,nextline
	call  print_string
	mov   esi,HdPortMsg
	call  print_string
	xor   eax,eax
	mov   ax,word[HdPort1]
	call  write_hex16
	mov   esi,nextline
	call  print_string 
	mov   esi,CdDriveMsg
	call  print_string
	mov   al,byte[CdDrive1]
	call  write_hex8
	mov   esi,nextline
	call  print_string
	mov   esi,CdPortMsg
	call  print_string
	mov   ax,word[CdPort1]
	call  write_hex16
	mov   esi,nextline
	call  print_string
;LBA
	cmp   word[LBAtest],1
	je    LbaYes
	mov   esi,LbaNoMsg
	call  print_string
	jmp   LBAend
LbaYes:
	mov   esi,LbaYesMsg
	call  print_string
LBAend:
;VESA2
	cmp   byte[NoVesa],1
	je    NoVesaLable
	mov   esi,VesaYesMsg
	call  print_string
	jmp   @f
NoVesaLable:
	mov   esi,VesaNoMsg
	call  print_string
@@:
       jmp   ExitFound
not_SysInfo:

;====================================================;
;  TestIT.        compare command buffer with 'TEST' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,5
	mov   edi,cTEST
	repe  cmpsb
	jne   not_Test
       ; mov   eax,OffsetDma2Buffer
       ; call  write_hex32
;------------------
; Put any code you want to test from CLI here
;------------------
	jmp   ExitFound
not_Test:
;====================================================;
;  BIOS.          compare command buffer with 'BIOS' ;
;====================================================;
	mov   esi,CommandBuffer
	mov   cx,4
	mov   edi,cBIOS
	repe  cmpsb
	jne   not_Bios
	mov   eax,FddReadB
	mov   [FddRead],eax
	mov   eax,FddWriteB
	mov   [FddWrite],eax
	mov   [MissChangTest],1
	mov   esi,BiosSetMsg
	call  print_string
	jmp   ExitFound
not_Bios:
;====================================================;
;  PMode.        compare command buffer with 'PMODE' ;
;====================================================;
	mov   esi,CommandBuffer
	mov   cx,5
	mov   edi,cPMODE
	repe  cmpsb
	jne   not_Pmode
	mov   eax,FddReadPM
	mov   [FddRead],eax
	mov   eax,FddWritePM
	mov   [FddWrite],eax
	mov   [MissChangTest],0
	mov   esi,PmodeSetMsg
	call  print_string
	jmp   ExitFound
not_Pmode:
;====================================================;
;  Cd2.            compare command buffer with 'CD2' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,4					
	mov   edi,cCD2
	repe  cmpsb
	jne   not_2Cd
	cmp   word[CdPort2],0
	je    NoCd2Lable
	mov   dx,word[CdPort2]
	mov   word[port],dx
	mov   al,byte[CdDrive2]
	mov   byte[drive],al 
	mov   esi,Cd2YesMsg
	call  print_string
	jmp   @f
NoCd2Lable:
	mov   esi,Cd2NoMsg
	call  print_string
@@:
	jmp   ExitFound
not_2Cd:
	jmp   not_run
FindProgA:
@@:
	call  Fdd_motor_off
	mov   esi,dword[ImageLoadAddrVar]
	add   esi,2
	cmp   dword[ds:esi],'DEX2'
	je    ItsaDexProgFDD
	add   esi,3
	cmp   dword[ds:esi],'DEX2'
	jne   NotaDexProg
ItsaDexProgFDD:
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  dword[ImageLoadAddrVar]				       
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	mov   [keybuffer],0			       
	call  SetPalette
	call  InitTopBar
	jmp   ExitFound
NotRun:
	call  Fdd_motor_off
	jmp   not_run
;====================================================;
; Run program from C:\                               ;
;====================================================;
RunHdd:
	cmp   [PromptLetter],'C'			
	jne   RunCd
	mov   al,0
	call  RunCommand
	jc    NotRun
FindProgC:
	call  LoadMBR 
	call  ReadOneSector
	mov   edi,RootConvertedFileName
	mov   edx,dword[ImageLoadAddrVar] 
	call  RunCommandHdd
	jnc   @f					 
	mov   esi,BadCommand		       ;MoreErrorMsg
	call  print_string				 
	jmp   ExitFound
@@:
	mov   esi,dword[ImageLoadAddrVar]
	add   esi,2
	cmp   dword[ds:esi],'DEX2'
	je    ItsaDexProgHdd
	add   esi,3
	cmp   dword[ds:esi],'DEX2'
	jne   NotaDexProg
ItsaDexProgHdd:
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  dword[ImageLoadAddrVar]				      
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	mov   [keybuffer],0			       
	call  SetPalette
	call  InitTopBar
	jmp   ExitFound
;====================================================;
; Run program from D:\                               ;
;====================================================;
RunCd:							
	mov   byte [command],Atapi_Packet_Command
	mov   eax,dword[ImageLoadAddrVar]
	mov   dword[LoadAdress],eax 
	call  Get_file_on_cd_info 
	jnc   @f
	mov   [Timer],15 
	mov   [TimerOn],1			       
	call  WaitTimer 			       
	call  Get_file_on_cd_info 
	jnc   @f
	mov   [Timer],20 
	mov   [TimerOn],1				
	call  WaitTimer 
	call  Get_file_on_cd_info 
	jnc   @f
	mov   [Timer],30 
	mov   [TimerOn],1				
	call  WaitTimer 				
	call  Get_file_on_cd_info 
	jc    printvCdbad
@@:  
	mov   ecx,dword[FileSizeBytes]			
	shr   ecx,11
	add   ecx,1
	mov   word[counter],cx
	call  Read_cd
	jc    printvCdbad 
	mov   [Timer],10				
	mov   [TimerOn],1				
	call  WaitTimer 				
	mov   esi,dword[ImageLoadAddrVar] 
	add   esi,2
	cmp   dword[ds:esi],'DEX2'
	je    ItsaDexProg   
	add   esi,3
	cmp   dword[ds:esi],'DEX2'
	jne   NotaDexProg
ItsaDexProg:  
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   esi,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  dword[ImageLoadAddrVar] 
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	mov   [keybuffer],0				     
	call  SetPalette
	call  InitTopBar
	jmp   ExitFound
printvCdbad:
	cmp   ah,2
	jne   @f
	mov   esi,BadCommand
	call  print_string
	jmp   ExitFound
@@:
	mov   esi,CdDvdError
	call  print_string
	jmp   ExitFound
NotaDexProg:
	mov   esi,NotaDexProgMes
	call  print_string
	jmp   ExitFound      
not_run:
;====================================================;
; Del.           compare command buffer with 'del'   ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,4				       
	mov   edi,cDEL
	repe  cmpsb
	jne   not_del
	jmp   OverDelMessage

DelMessage1   db 'Are you sure you want delete ',0
DelMessage2   db ' Y/N ?.',13,0
DelMessage3   db 'You can not delete a file from CD/DVD ;-).',13,0
OverDelMessage:
	cmp   [PromptLetter],'A'
	je    DeleteStart
	cmp   [PromptLetter],'C'
	je    DeleteStart
	mov   esi,DelMessage3 
	call  print_string 
	jmp   ExitFound
DeleteStart:
	mov   esi,DelMessage1
	call  print_string
	mov   esi,CommandBuffer
	add   esi,4
	call  print_string
	mov   esi,DelMessage2
	call  print_string
DelMessageLoop:        
	call  WaitForKeyPressInt46OOH
	cmp   al,'y'
	je    DoDeleteFile
	cmp   al,'Y'
	je    DoDeleteFile
	cmp   al,'n'
	je    ExitFound
	cmp   al,'N'
	je    ExitFound
	jmp   DelMessageLoop
DoDeleteFile:  
	mov   esi,CommandBuffer
	add   esi,4
	call  DeleteCLI
	jc    NotDelError
	call  Fdd_motor_off
	jmp   ExitFound
NotDelError:
	call  Fdd_motor_off
	mov   esi,MoreErrorMsg
	call  print_string
	jmp   ExitFound
not_del:
;====================================================;
; Ramdisk.     compare command buffer with 'ramdisk' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,7				       
	mov   edi,cRAMDISK
	repe  cmpsb
	jne   not_ramdisk
	jmp   OverRDMessage

RamdiskMes1   db 'Do want to run the file in ramdisk ? ',0
RamdiskMes2   db ' Y/N ?.',13,0

OverRDMessage:
	mov   esi,RamdiskMes1
	call  print_string
	mov   esi,RamdiskMes2
	call  print_string
RDMessageLoop:	      
	call  WaitForKeyPressInt46OOH
	cmp   al,'y'
	je    DoRunFile
	cmp   al,'Y'
	je    DoRunFile
	cmp   al,'n'
	je    ExitFound
	cmp   al,'N'
	je    ExitFound
	jmp   RDMessageLoop
DoRunFile: 
	mov   esi,0xb00000
	add   esi,2
	cmp   dword[ds:esi],'DEX2'
	je    ItsaDexProgRD   
	add   esi,3
	cmp   dword[ds:esi],'DEX2'
	jne   NotaDexProgRD
ItsaDexProgRD:
	mov   esi,0xb00000
	mov   edi,dword[ImageLoadAddrVar] 
	mov   ecx,0x100000/4
	cld
	rep   movsd
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  dword[ImageLoadAddrVar]				    
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	mov   [keybuffer],0			       
	call  SetPalette
	call  InitTopBar
	jmp   ExitFound
NotaDexProgRD:
	mov   esi,NotaDexProgMes
	call  print_string
	jmp   ExitFound      
not_ramdisk:
;====================================================;
;  Reboot.      compare command buffer with 'reboot' ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,7				       
	mov   edi,cREBOOT
	repe  cmpsb
	jne   not_reboot
	jmp   DoIt
	
RebootMessage	db 'Press a (any) key to reboot . . . ',0

DoIt:
	mov   esi,RebootMessage
	call  print_string
	call  WaitForKeyPressInt46OOH
	call  RebootSystem
    
not_reboot:
;====================================================;
;  Exit.        compare command buffer with 'EXIT'   ;
;====================================================;
	mov   esi,CommandBuffer 
	mov   cx,5				       
	mov   edi,cEXIT
	repe  cmpsb
	jne   not_exit
	jmp   ExitDoIt
	
ExitMessage	db 'Press a (any) key to exit to DOS . . . ',0

ExitDoIt:
	mov   esi,ExitMessage
	call  print_string
	call  WaitForKeyPressInt46OOH
; Need to check here if started from DOS, and if so, exit to DOS, else reboot
	call  ExitDOS
not_exit:
;====================================================;
;  Check for file.                                   ;
;====================================================;
	cmp   [PromptLetter],'A'
	jne   HddTRY
	mov   al,0 
	call  FindProg
	call  RunCommand2 
	jc    ExitNotFound1
	jmp   FindProgA
HddTRY:
	cmp   [PromptLetter],'C' 
	jne   CdTRY
	mov   al,0
	call  FindProg
	jmp   FindProgC
CdTRY:
	mov   al,0
	call  FindProgCd
	mov   esi,RootConvertedFileName
	mov   edi,dword[ImageLoadAddrVar] 
	mov   ecx,[FindProgCount]
	mov   [CdCount],3
TryCdAgain:
	call  CdfileLoad
	jc    NoVesaTwoa
	mov   esi,dword[ImageLoadAddrVar]
	add   esi,2
	cmp   dword[ds:esi],'DEX2'
	je    ItsaDexProgCD
	add   esi,3
	cmp   dword[ds:esi],'DEX2'
	jne   NotaDexProg
ItsaDexProgCD:
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  dword[ImageLoadAddrVar]				     
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	mov   [keybuffer],0			       
	call  SetPalette
	call  InitTopBar
	jmp   ExitFoundCls  
NoVesaTwoa:
	dec   [CdCount]
	cmp   [CdCount],1
	jb    ExitNotFound
	jmp   TryCdAgain
;====================================================;
;  Exit no command or file found.                    ;
;====================================================;
ExitNotFound1:
	call  Fdd_motor_off
ExitNotFound:
	mov   esi,BadCommand
	call  print_string
;====================================================;
;  Exit  command or file found.                      ;
;====================================================;
ExitFound:
	cmp   [screen_y],4
	jne   ExitFound1
	cmp   [screen_x],0
	je    ExitFoundCls
ExitFound1:
	mov   esi,nextline
	call  print_string
ExitFoundCls:	      
	call  Prompt
	pop   es
	popad
	ret

