;=========================================================;
; CommandLineCalls                               11/12/03 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

;====================================================;
; Test floppy.                                       ;
;====================================================;
TestFloppy:
	pushad
	push es
	mov   [FddErrCount],0
TryReadFloppyAgainTest:
	mov   cl,1
	mov   ch,0
	mov   dh,0
	mov   dl,0x00
	call  [FddRead]
	jnc   TestFloppyOK
	inc   [FddErrCount]
	cmp   [FddErrCount],4
	je    TestFloppyErrorMssage1
	pushad
	call  FddRecalibrate
	popad
	jmp   TryReadFloppyAgainTest
TestFloppyOK:
	mov   cx,512	    
	mov   ax,sys_data  
	mov   ds,ax
	mov   es,ax  
	mov   esi,OffsetDma2Buffer 
	mov   edi,BpbFat12
	rep   movsb
	mov   edi,bpbNumberOfFATs
	cmp   byte[es:edi],2
	jne   TestFloppyErrorMssage2
TestFloppySucess:
	pop   es
	popad
	clc
	ret
TestFloppyErrorMssage1:
	mov   [ErrorCode],1
	jmp   TestFloppyError
TestFloppyErrorMssage2:
	mov   [ErrorCode],2
TestFloppyError:
	pop   es
	popad
	stc
	ret

;====================================================;
; ConverHexToDec.                                    ;
;====================================================;
ConverHexToDec:
	pushad
	push  es
	push  ds
	call  HexToAsciiHex32eax
	call  hexbin
	call  bindec
	pop   ds
	pop   es
	popad
	ret

;====================================================;
; Get Command.                                       ;
;====================================================;

GetCommand:
	mov   dx,CmdSize				     
	mov   edi,CommandBuffer
	call  GetString
	ret

;=========================================================;
; Get String                                     11/12/03 ;
;---------------------------------------------------------;
; Get string from user, the received string is            ;
; written to buffer                                       ;
; at    ES:EDI, buffer size should be in DX.              ;
;                                                         ;                                                             
;=========================================================;
GetString:
	pushad
	push  es
	mov   ax,sys_data				 
	mov   es,ax    
	mov   edi,CommandBuffer
	mov   ecx,0
	cmp   dx,1					 
	jbe   EmptyBuffer 
	dec   dx					 
@@:
	call  WaitForKeyPress
	mov   al,[keybuffer]
	mov   ah,[ScanCode]
	mov   [ScanCode],0
	mov   [keybuffer],0
	cmp   al,13					 
	jz    Exit
	cmp   ah,0x4d
	jne   La1
	cmp   [CliBuffcount],0
	jbe   @b
	cmp   cx,[CliBuffcount]
	jae    @b
	mov   esi,CommandBuffer2
	push  eax
	xor   eax,eax
	add   ax,cx
	add   esi,eax
	pop   eax
	lodsb
	jmp   AddToBuffer
La1:
	cmp   ah,0x4b
	je    La2
	cmp   al, 0
	je    @b
	cmp   al, 8					 
	jne    AddToBuffer
La2:
	jcxz  @b					 
	cmp   [screen_x],0
	je    @b
	dec   cx
	dec   edi
	dec   [screen_x]
	mov   al,' '
	call  print_char
	dec   [screen_x]
	call  set_cursor_pos
	jmp   @b
AddToBuffer:
	cmp   cx,dx					 
	jae   @b
AddToBuffer1:					       
	stosb
	inc   cx
	call  PrintCharCursorPos
	jmp   @b
Exit:
	mov   byte [es:edi],0				  
EmptyBuffer:
	mov   [craicount],cx
	mov   [CliBuffcount],cx
	mov   edi,CommandBuffer2
	mov   esi,CommandBuffer
	mov   cx,128
	rep   movsb
	pop   es
	popad
	ret

;====================================================;
;  Data.                                             ;
;====================================================; 
CLIModID       db  'DEX4UIDE',0
craicount      dw  0
CliBuffcount   dw  0
CdCount        db  0
CmdSize =      0x80
CommandBuffer:	times  128  db 0
CommandBuffer2: times  128  db 0
;===========;
; commands. ;
;===========; 
cCLS	       db 'CLS',0
cVER	       db 'VER',0
cTIME	       db 'TIME',0
cDATE	       db 'DATE',0
cDIR	       db 'DIR',0
cAdir	       db 'A:',0
cCdir	       db 'C:',0
cDdir	       db 'D:',0
cHELP	       db 'HELP',0
cDEL	       db 'DEL ',0
cCD2	       db 'CD2',0
cSYSINFO       db 'SYSINFO',0
cMORE	       db 'MORE ',0
cBIOS	       db 'BIOS',0
cPMODE	       db 'PMODE',0
cREBOOT        db 'REBOOT',0
cEXIT	       db 'EXIT',0
cTEST	       db 'TEST',0
cRAMDISK       db 'RAMDISK',0
cCD	       db 'CD ',0
cMD	       db 'MD ',0
