;=========================================================;
; Del command                                    00/00/05 ;
;---------------------------------------------------------;
; Delete functions for deleting file on floppy.           ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ; DeleteCLI.                                         ;
 ;----------------------------------------------------;
DeleteCLI:
	cmp   [PromptLetter],'A'
	jne   GiveCaTry
	call  Delete
	jc    DeleteCLIerror
	jmp   DeleteCLIexit
GiveCaTry:
	cmp   [PromptLetter],'C'
	jne   DeleteCLIerror
	call  DeleteHdd
	jc    DeleteCLIerror
	jmp   DeleteCLIexit
DeleteCLIexit:
	clc 
	ret
DeleteCLIerror:
	stc
	ret
 ;----------------------------------------------------;
 ; DelCommand.                                        ;
 ;----------------------------------------------------;
Delete:
	pushad				  
	push  es 
	push  ds
	mov   [ErrorCode],0
	mov   dword[NameOfFileToMake],esi
	mov   [FileLoadCountUP],dword 0
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	call  DirFillRootUSB 
	jc    DelCommandError
	mov   esi,dword[NameOfFileToMake]
	push  eax
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	cmp   [RootYesNoA],0
	je    @f
	mov   [RootDirBufferVar],0x100000
@@:
	pop   eax
	mov   [ErrorCode],0x06
	call  FindFileName
	jc    DelCommandError
	push  eax
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	pop   eax
	mov   [ErrorCode],0x07
	mov   esi,dword[RootFileAddress]
	mov   al,byte[ds:esi+0xb]
	cmp   al,0
	je    @f
	cmp   al,0x20
	je    @f
	;
	;cmp   al,0x10
	;je    @f
	;
	jmp   DelCommandError
@@:
	mov   esi,dword[RootFileAddress]
	mov   ax,word[ds:esi+1Ah]		       
	mov   word [StartclusterDel],ax
	call   ReleaseClusterChain
	mov   esi,dword[RootFileAddress]
	mov   byte[ds:esi],0xe5
	call  DirFatRootUpdate
	jc    DelCommandError
	mov   ax,[FirstFolderClusterAfdd]
	mov   [StartCluster],ax
	mov   dword[LoadFileFromAddress],0x100000
	call  WriteSectors
	jc    DelCommandError
DelCommandSucsess:
	pop   ds
	pop   es
	popad
	clc 
	ret  

DelCommandError:
	call  Fdd_motor_off
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCode]
	stc
	ret


 ;----------------------------------------------------;
 ; DeleteSave.                                        ;
 ;----------------------------------------------------;
DeleteSave:
	pushad				  
	push  es 
	push  ds
	mov   [SizeOfFileToDelete],ebx
	mov   [ErrorCode],0
	mov   dword[NameOfFileToMake],esi
	mov   dword[FileSizeInBytes],eax
	call  GetFileSizeInSectors
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	call  DirFillRootUSB 
	jc    DelSaveCommandError
	call  UsedSectorsFddWrite
	mov   [ErrorCode],5
	xor   eax,eax
	mov   ax,word[FreeSectors]
	add   eax,[SizeOfFileToDelete]
	cmp   [FileSizeInSectors],eax
	ja    DelSaveCommandError
	mov   [ErrorCode],0
	mov   esi,dword[NameOfFileToMake]
	mov   [ErrorCode],0x00
	call  FindFileName
	jc    DelSaveCommandSucsess   
	mov   [ErrorCode],0x07
	mov   esi,dword[RootFileAddress]
	mov   al,byte[ds:esi+0xb]
	cmp   al,0
	je    @f
	cmp   al,0x20
	je    @f
	jmp   DelSaveCommandError
@@:
	mov   esi,dword[RootFileAddress]
	mov   ax,word[ds:esi+1Ah]		       
	mov   word [StartclusterDel],ax
	call   ReleaseClusterChain
	mov   esi,dword[RootFileAddress]
	mov   byte[ds:esi],0xe5
	call  DirFatRootUpdate
	jc    DelSaveCommandError
	;call  Fdd_motor_off
DelSaveCommandSucsess:
	pop   ds
	pop   es
	popad
	clc 
	ret  

DelSaveCommandError:
	call  Fdd_motor_off
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCode]
	stc
	ret

 ;----------------------------------------------------;
 ; Open.                                              ;
 ;----------------------------------------------------;
Open:
	pushad				  
	push  es 
	push  ds
	mov   [ErrorCode],0
	mov   dword[NameOfFileToMake],esi
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	call  DirFillRootUSB   
	jc    OpenError
	mov   esi,dword[NameOfFileToMake]
	mov   [ErrorCode],0x06
	call  FindFileName
	jc    OpenError
OpenSucsess:
	pop   ds
	pop   es
	popad
	clc 
	ret  

OpenError:
	call  Fdd_motor_off
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCode]
	stc
	ret

 ;----------------------------------------------------;
 ; DeleteHdd.                                         ;
 ;----------------------------------------------------;
DeleteHdd:
	pushad				  
	push  es 
	push  ds
	mov   [ErrorCodeFat16],0		    ; Make sure the var is 0.
	mov   dword[NameOfFileToMakeFat16],esi	    ; ESI should point to name of file, save it.
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	mov   edi,RootDirBufferHdd		    ; Load root buffer into edi.
	mov   [RootDirBufferVarC],edi		    ; Store it.
	call  LoadMBR				    ; Make sure MBR has bean loaded.
	jc    DeleteHddError			    ; If we have a error jump exit, set error flag.
	call  ReadOneSector			    ; Load FAT and ROOT dir.       
	jc    DeleteHddError			    ; If we have a error jump exit,set error flag
	mov   [ErrorCodeFat16],32
	cmp   byte[FatID],16
	jne   DeleteHddError
	mov   esi,dword[NameOfFileToMakeFat16]
	mov   [ErrorCodeFat16],0x06
	mov   edi,RootDirBufferHdd		    ; Load root buffer into edi.
	mov   [RootDirBufferVarC],edi		    ; Store it.
	cmp   [RootYesNoC],0			    ; Check if we are writing to root dir.
	je    WriteFileRootDirDeleteHdd 	    ; Miss next bit if we are.
	mov   [RootDirBufferVarC],0x110000
WriteFileRootDirDeleteHdd:
	call  FindFileNameFat16
	jc    DeleteHddError
	mov   edi,RootDirBufferHdd		    ; Load root buffer into edi.
	mov   [RootDirBufferVarC],edi		    ; Store it.
	mov   [ErrorCodeFat16],0x07
	mov   esi,dword[RootFileAddressFat16] 
	mov   al,byte[ds:esi+0xb]
	cmp   al,0
	je    @f
	cmp   al,0x20
	je    @f
	cmp   al,3
	je    @f
	jmp   DelCommandError
@@:
	mov   esi,dword[RootFileAddressFat16]
	mov   ax,word[ds:esi+1Ah]		       
	mov   word [StartclusterDelFat16],ax
	call  ReleaseClusterChainFat16
	mov   esi,dword[RootFileAddressFat16]
	mov   byte[ds:esi],0xe5
	call  DirFatRootUpdateFat16		    ; If not errors write new root and fat to hdd.
	jc    DeleteHddError
	cmp   [RootYesNoC],0			    ; Check if we are writing to root dir.
	je    DeleteHddSucsess
	mov   ax,[FirstFolderClusterA]		    ; Put the folders cluster in AX
	mov   [FileCluster],ax			    ; Put AX into the FileCluster var
	mov   [LoadFileFromAddressFat16],0x110000   ; Uses the folders dir buffer.
	call  WriteFat16			    ; Write file to Hdd
	jc    DeleteHddError
DeleteHddSucsess:
	pop   ds
	pop   es
	popad
	clc 
	ret  


DeleteHddError:
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCodeFat16]
	stc
	ret

;====================================================;
; Data.                                              ;
;====================================================;
StartclusterDel      dw  0
SizeOfFileToDelete   dd  0