;=========================================================;
; Run command                                    11/12/03 ;
;---------------------------------------------------------;
;                                                         ;
; Run functions for finding & running programs.           ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ; RunCommand.                                        ;
 ;----------------------------------------------------;
RunCommand:
	pushad				  
	push  es
	push  ds 
 ;----------------------------------------------------;
 ; Convert command line Name to root name.            ;
 ;----------------------------------------------------;
	mov   ax,sys_data				
	mov   es,ax
	mov   esi,CommandBuffer 			
	mov   edi,RootConvertedFileName
	add   esi,4
	mov   cx,8
ConvertCliFileName:
	cmp   byte [ds:esi],'.'
	je    @f
	cld
	movsb 
	dec   cx
	jnz  ConvertCliFileName
	jmp   FinConertCliFname
@@:
	mov   al,0x20
	cld
	rep   stosb
FinConertCliFname:
	cmp   byte [ds:esi],'.'
	jne   @f
	inc   esi
@@:
	mov   cx,6
	cld
	rep   movsb
     
	mov   edi,RootConvertedFileName
	add   edi,8
	cmp   word[es:edi],'DE'
	je    @f
	cmp   word[es:edi],'BI'
	je    @f
ConvertCliFileNameError:
	pop   ds
	pop   es
	popad
	stc
	ret  
 ;----------------------------------------------------;
 ; OK.                                                ;
 ;----------------------------------------------------;      
@@: 
	pop   ds
	pop   es
	popad
	clc
	ret  

RunCommand2:   
	pushad				  
	push  es
	push  ds
	mov   [FileLoadCount],0
	mov   [FddSectorsLoadedCount],0 		
	call  DirFillRootUSB			     
	jc    ErrorFloppy
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	cmp   [RootYesNoA],0
	je    @f
	mov   [RootDirBufferVar],0x100000
@@:
	xor   ecx, ecx
	mov   ax,[bpbRootEntries]			
	mov   cx, 32					
	mul   cx					
	div   word [bpbBytesPerSector]			
	mov   [RootSize],ax				
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	mov   dx,ax	
	xor   ax,ax			
	mov   al, byte [bpbNumberOfFATs]		
	mul   word [bpbSectorsPerFAT]			
	add   ax, word [bpbReservedSectors]		
	mov   [RootStart],ax				
	mov   [RootStartDx],dx 
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSize]				
	add   ax,cx					
	mov   [DataStart],ax				
	mov   ax,sys_data				
	mov   es,ax
	mov   ds,ax
	mov   edi,[RootDirBufferVar]
	mov   esi,RootConvertedFileName
	mov   dx,[bpbRootEntries]
 ;----------------------------------------------------;
 ; FindName.                                          ;
 ;----------------------------------------------------;
FindName:
	mov   cx,11
FindNameCycleFL:
	cmp   byte [es:edi],ch
	je    FindNameFailedFL				 
	pushad					       
	repe  cmpsb
	popad					       
	je    FindNameFoundFL
	add   edi, 32
	dec   dx
	jnz   FindNameCycleFL				 
FindNameFailedFL:
	jmp   ErrorFind
FindNameFoundFL:
	mov   dx,word[es:edi+1Ah]			
	mov   word [cluster],dx 			
 ;----------------------------------------------------;
 ; What fat is it.                                    ;
 ;----------------------------------------------------;
	xor   eax,eax
	mov   ax,word [bpbSectorsPerFAT]		
	shl   eax,9					
	shr   eax,1					
	cmp   eax,4086					 
	jae   LoadImageFat16				
 ;----------------------------------------------------;
 ; Fat12.                                             ;
 ;----------------------------------------------------;
LoadImageFat12:
	mov   ax,[cluster]				
	mov   [FloppyTest],0				
ReadNextCluster:
	call  ClusterLBA				
	call  ReadSectors				
	jc    ErrorFloppy				
 ;----------------------------------------------------;
 ; compute next cluster.                              ;
 ;----------------------------------------------------;
	mov   ax,word[cluster]				
	mov   cx,ax					
	mov   dx,ax					
	shr   dx,0x0001 				
	add   cx,dx					
	mov   esi,BpbFat12				
	add   esi,512	
	add   esi,ecx					
	mov   dx,word [ds:esi]				
	test  ax,0x0001
	jnz   OddCluster	  
EvenCluster: 
	and   dx,0000111111111111b			
	jmp   Done
OddCluster:
	shr   dx,0x0004 				
Done:
	mov   word [cluster],dx 			
	cmp   dx,0x0FF0 				
	jb    LoadImageFat12
	jmp   ExitSucsess
 ;----------------------------------------------------;
 ; Fat16.                                             ;
 ;----------------------------------------------------;
LoadImageFat16:
	mov   ax,[cluster]				
	mov   [FloppyTest],0				
	
ReadNextClusterFat16:					
	call  ClusterLBA				
	mov   [clusterSPC],ax				
	xor   ecx,ecx					
	mov   cl,byte [bpbSectorsPerCluster]		
ReadNextClusterFat16loop:
	push  ecx					
	mov   [FloppyTest],0				
	call  ReadSectors				
	jc    ErrorFloppyPop				
	inc   [clusterSPC]					      
	mov   ax,[clusterSPC]				
	pop   ecx					
	loop  ReadNextClusterFat16loop			
 ;----------------------------------------------------;
 ; compute next cluster.                              ;
 ;----------------------------------------------------;
	xor   ecx,ecx
	xor   eax,eax
	mov   ax,word[cluster]				
	mov   cx,ax					
	add   ecx,eax					
	mov   esi,Fat					
	add   esi,ecx					
	mov   dx,word [ds:esi]				
	mov   word [cluster],dx 			
	cmp   dx,0xFFF0 				
	jb    LoadImageFat16
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
ExitSucsess:
	mov   ebx,[FddSectorsLoadedCount] 
	pop   ds
	pop   es
	popad
	clc
	ret
 ;----------------------------------------------------;
 ; ErrorFind.                                         ;
 ;----------------------------------------------------;        
ErrorFind:
	pop   ds
	pop   es
	popad
	stc
	ret
 ;----------------------------------------------------;
 ; ErrorFloppy.                                       ;
 ;----------------------------------------------------; 
ErrorFloppyPop:
	pop   ecx 
ErrorFloppy:
	pop   ds
	pop   es
	popad
	stc
	ret

 ;----------------------------------------------------;
 ; ReadSectors.                                       ;
 ;----------------------------------------------------;
ReadSectors:
	pushad
	push  es
	push  ds
	call  LBAcHs
TryReadFloppyAgain:  
	push  ax 
	mov   ch,byte [absoluteTrack]			
	mov   cl,byte [absoluteSector]			
	mov   dh,byte [absoluteHead]			
	mov   dl,byte [bsDriveNumber]			
	pop   ax  
	call  [FddRead]
	jnc   FloppyReadOK
 ;----------------------------------------------------;
 ; Try Reading floppy 3 time.                         ;
 ;----------------------------------------------------;
	inc   [FloppyTest]
	cmp   [FloppyTest],4
	jae    @f
	call  FddRecalibrate
	jmp   TryReadFloppyAgain
 ;----------------------------------------------------;
 ; Move data from DMA buffer, to image address.       ;
 ;----------------------------------------------------;
FloppyReadOK:
	mov   cx,512	    
	mov   ax,sys_data  
	mov   ds,ax
	mov   es,ax  
	mov   esi,OffsetDma2Buffer 
	mov   edi,dword[ImageLoadAddrVar] ;ImageLoadAddr
	add   edi,[FileLoadCount]
	rep   movsb
	add   [FileLoadCount],512
	add   [FddSectorsLoadedCount],1 
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
	pop   ds
	pop   es
	popad
	clc
	ret 

 ;----------------------------------------------------;
 ; Error.                                             ;
 ;----------------------------------------------------;
@@:
	mov   esi,FloppyErrorMsg
	call  print_string
	pop   ds
	pop   es
	popad
	stc
	ret 
       
 ;----------------------------------------------------;
 ; LBAcHs.                                            ;
 ;----------------------------------------------------;
LBAcHs:
	div   word [bpbSectorsPerTrack] 		
	inc   dl					
	mov   byte [absoluteSector],dl
	xor   dx,dx					
	div   word [bpbHeadsPerCylinder]		
	mov   byte [absoluteHead],dl
	mov   byte [absoluteTrack],al
	ret

 ;----------------------------------------------------;
 ; ClusterLBA.                                        ;
 ;----------------------------------------------------;
ClusterLBA:
	sub   ax,2					
	xor   ecx,ecx					
	mov   cl,byte [bpbSectorsPerCluster]		
	mul   cx					
	add   ax, word [DataStart]			
	ret	


 ;----------------------------------------------------;
 ; FindProg.                                          ;
 ;----------------------------------------------------;
FindProg:
	pushad				  
	push  es
	push  ds 
	xor   ecx,ecx
 ;----------------------------------------------------;
 ; Convert command line Name to root name.            ;
 ;----------------------------------------------------;
	mov   ax,sys_data				
	mov   es,ax
	mov   esi,CommandBuffer 			
	mov   edi,RootConvertedFileName
	mov   cx,8
ConvertCliFileNameFP:
	cmp   byte [ds:esi],' '
	je    @f
	cmp   byte [ds:esi],'.'
	je    @f
	cmp   byte [ds:esi],0
	je    @f
	cld
	movsb 
	dec   cx
	jnz  ConvertCliFileNameFP
	jmp   FinConertCliFnameFP
@@:
	mov   al,0x20
	cld
	rep   stosb
FinConertCliFnameFP:
	mov   edi,RootConvertedFileName
	add   edi,8
	mov   dword[es:edi],'DEX '
ConvertCliFileNameErrorFP:
	pop   ds
	pop   es
	popad
	ret					

 ;----------------------------------------------------;
 ; FindProgCd.                                        ;
 ;----------------------------------------------------;
FindProgCd:
	pushad				  
	push  es
	push  ds 
 ;----------------------------------------------------;
 ; Convert command line Name to root name.            ;
 ;----------------------------------------------------;
	mov   ax,sys_data				
	mov   es,ax
	mov   [FindProgCount],0
	mov   esi,CommandBuffer 			
	mov   edi,RootConvertedFileName
	;add   esi,4
	mov   cx,8
ConvertCliFileNameFP2:
	cmp   byte [ds:esi],' '
	je    @f
	cmp   byte [ds:esi],'.'
	je    @f
	cmp   byte [ds:esi],0
	je    @f
	cld
	movsb 
	dec   cx
	inc   [FindProgCount]
	jnz   ConvertCliFileNameFP2
@@:
	mov   dword[es:edi],'.DEX'
	add   [FindProgCount],4
ConvertCliFileNameErrorFP2:
	pop   ds
	pop   es
	popad
	ret		

 ;----------------------------------------------------;
 ; ConvertCliFolderName.                              ;
 ;----------------------------------------------------;
ConvertCliFolderName:
	pushad				  
	push  es
	push  ds 
 ;----------------------------------------------------;
 ; Convert command line Name to root folder name.     ;
 ;----------------------------------------------------;
	mov   ax,sys_data				
	mov   es,ax
	mov   ds,ax
	mov   esi,CommandBuffer
	mov   edi,RootConvertedFileName
	add   esi,3
	mov   cx,8
	cmp   byte [ds:esi],'/'
	je    @f
	cmp   byte [ds:esi],'\'
	jne   ConvertCliFolderNameError
@@:
	inc   esi
ConvertCliFolderNameLoop:
	cld
	cmp   byte [ds:esi],0
	je    @f
	movsb 
	dec   cx
	jnz   ConvertCliFolderNameLoop
	jmp   ConvertCliFolderNameOK
@@:
	mov   al,0x20
	cld
	rep   stosb
ConvertCliFolderNameOK:
	mov   cx,3
	mov   al,0x20
	cld
	rep   stosb
	mov   al,0
	cld
	stosb
	pop   ds
	pop   es
	popad
	clc
	ret  

ConvertCliFolderNameError:
	pop   ds
	pop   es
	popad
	stc
	ret  


 ;----------------------------------------------------;
 ; FindDirA                                           ;
 ;----------------------------------------------------;
FindDirA:
	pushad				  
	push  es
	push  ds 
	mov   ax,sys_data				
	mov   es,ax
	mov   esi,CommandBuffer
	cmp   byte [ds:esi+3],'/'
	je    @f
	cmp   byte [ds:esi+3],'\'
	jne   FindDirAerror
@@:
	cmp   byte [ds:esi+4],0
	je    BackToRootA
	cmp   byte [ds:esi+4],' '
	je    BackToRootA
	call  ConvertCliFolderName
	jc    FindDirAerror
	mov   edi,0x100000		    ; load address
	mov   esi,RootConvertedFileName     ; name of folder
	call  FloppyfolderLoad
	jc    FindDirAerror
	mov   [RootYesNoA],1
	mov   edi,FolderNameA
	mov   al,0
	mov   cx,12
	rep   stosb
	mov   edi,FolderNameA
	mov   esi,RootConvertedFileName
	mov   cx,8
	xor   eax,eax
FolerNameLoop:
	lodsb
	cmp   al,' '
	je    FindDirAok
	stosb
	dec   cx
	jnz   FolerNameLoop
FindDirAok:
	mov   al,0
	stosb
	pop   ds
	pop   es
	popad
	clc
	ret  

BackToRootA: 
	mov   [RootYesNoA],0
	pop   ds
	pop   es
	popad
	clc
	ret  

FindDirAerror: 
	pop   ds
	pop   es
	popad
	stc
	ret  


 ;----------------------------------------------------;
 ; FindDirC                                           ;
 ;----------------------------------------------------;
FindDirC:
	pushad				  
	push  es
	push  ds 
	mov   ax,18h   ;sys_data
	mov   es,ax
	mov   esi,CommandBuffer 
	cmp   byte [ds:esi+3],'/'
	je    @f
	cmp   byte [ds:esi+3],'\'
	jne   FindDirCerror
@@:
	cmp   byte [ds:esi+4],0
	je    BackToRootC
	cmp   byte [ds:esi+4],' '
	je    BackToRootC
	call  ConvertCliFolderName
	jc    FindDirCerror
	call  LoadMBR 

	call  ReadOneSector
@@:
	mov   edx,0x110000		    ; load address
	mov   edi,RootConvertedFileName     ; name of folder
	call  LoadFolderHdd
	jc    FindDirCerror
	mov   [RootYesNoC],1
	mov   edi,FolderNameC
	mov   al,0
	mov   cx,12
	rep   stosb
	mov   edi,FolderNameC
	mov   esi,RootConvertedFileName
	mov   cx,8
	xor   eax,eax
FolderNameLoop1:
	lodsb
	cmp   al,' '
	je    FindDirCok
	stosb
	dec   cx
	jnz   FolderNameLoop1
FindDirCok:
	mov   al,0
	stosb
	pop   ds
	pop   es
	popad
	clc
	ret  

BackToRootC: 
	mov   [RootYesNoC],0
	pop   ds
	pop   es
	popad
	clc
	ret  

FindDirCerror: 
	pop   ds
	pop   es
	popad
	stc
	ret 

 ;----------------------------------------------------;
 ; DATA.                                              ;
 ;----------------------------------------------------;

RootYesNoA		db 0
RootYesNoC		db 0
FindProgCount		dd 0
ModLoadLow		db 0
FddSectorsLoadedCount	dd 0
RootStart		dw 0
RootStartDx		dw 0
DataStart		dw 0
cluster 		dw 0
clusterSPC		dw 0
absoluteSector		db 0
absoluteHead		db 0
absoluteTrack		db 0
RootSize		dw 0
FileLoadCount		dd 0
CxCount 		dd 0
RootConvertedFileName	rb 16
FolderNameA		rb 16
FolderNameC		rb 16
