;=========================================================;
; Ata_Atapi32                                    11/12/03 ;
;---------------------------------------------------------;
; ATA/ATAPI functions.                                    ;                          
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 Atapi_Packet_Command  = 0xA0 

 ;----------------------------------------------------;
 ; Send Atapi Packet                                  ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;   Input:                                           ;
 ;          esi, points to 12 byte command packet.    ;
 ;  Output:                                           ;
 ;          none                                      ;
 ;                                             (100%) ;
 ;....................................................;
Send_Atapi_Packet:
	pushad						
	xor   al,al					
	mov   dx,1				       
	add   dx,word [port]				
	out   dx,al					
	mov   al,1					
	mov   dx,2					
	add   dx,word [port]				
	out   dx,al					
	mov   al,1					
	mov   dx,3					
	add   dx,word [port]			       
	out   dx,al					
	xor   al,al					
	mov   dx,4					
	add   dx,word [port]				
	mov   al,byte[LoByte]					    
	out   dx,al				       
	xor   al,al					
	mov   al,byte[HiByte]					    
	mov   dx,5					
	add   dx,word [port]			       
	out   dx,al					
	mov   dx,0x7					
	add   dx,word [port]				
	mov   cx,0xffff 				
StatusReg1_1:				       
	in    al,dx					
	and   al,0x80					
	jz    WriteCommand1_1				
	loop  StatusReg1_1				
	jmp   DeviceBusy_1				
WriteCommand1_1:			       
	mov   dx,0x6						
	add   dx,word [port]				
	mov   al,byte [drive]				
	or    al,0xef					
	out   dx,al					
       ;mov   cx,0xffff                                 
       ;mov   dx,0x7                                    
       ;add   dx,word [port]                            
StatusReg2_1:				       
       ;in    al,dx                                     
       ;and   al,0x80                                  
       ;jz    WriteCommand2_1                           
       ;loop  StatusReg2_1                              
	jmp   WriteCommand2_1
DeviceBusy_1:						
	stc						
	popad
	ret				      

;====================================================;
; Write Command                                      ;
;====================================================; 
WriteCommand2_1:
	call  Small_Delay1
	mov   dx,0x7						
	add   dx,word [port]				
	mov   al,byte [command] 			
	out   dx,al					
	mov   cx,0xffff 				
	mov   dx,0x7					
	add   dx,word [port]				
StatusReg3_1:				      
	in    al,dx					
	test  al,0x80					
	jnz   DrqErrorCheck1_1				
	test  al,0x01					
	jnz   error_1					    
	test  al,0x08					
	jnz   WriteCommandPacket1_1			 
DrqErrorCheck1_1:					
	loop  StatusReg3_1				
	jmp   DeviceBusy_1  
			    
;====================================================;
; Write Command Packet                               ;
;====================================================; 
WriteCommandPacket1_1:
	xor   dx,dx 
	mov   dx,0x00						     
	add   dx,word [port]			       
	mov   esi,packet				
	xor   cx,cx					 
	mov   cx,6				       
WritePacket1_1: 			       
	lodsw						
	out   dx,ax					
	loop  WritePacket1_1				
	call  Small_Delay1				
	mov   cx,0xffff 				
	mov   dx,0x7					
	add   dx,word [port]				
StatusReg4_1:				      
	in    al,dx					
	test  al,0x80					
	jnz   DrqErrorCheck2_11 			
	test  al,0x1					
	jnz   error_1					
	test  al,08h				       
	jnz   Send_Packet_ok				
DrqErrorCheck2_11:
	loop  StatusReg4_1	 
	stc					       
	popad						
	ret
Send_Packet_ok: 					
	clc					       
	popad						
	ret

;====================================================;
; Drq Error Check                                    ;
;====================================================; 
DrqErrorCheck2_1:
	push  ecx					
	mov   ecx,0xffff				
BusyDelay_1:						
	nop						
	nop						
	nop						
	nop						
	nop						
	nop						
	nop						
	nop						
	loop  BusyDelay_1				
	pop   ecx				       
	loop  StatusReg4_1				
	jmp   DeviceBusy_1				
error_1:
	popad 
	stc						
	ret

 ;----------------------------------------------------;
 ; Read write toc                                     ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;   Input:                                           ;
 ;          edi, points to 804 byte buffer.           ;
 ;  Output:                                           ;
 ;          toc info                                  ;
 ;                                             (100%) ;
 ;....................................................;
Read_write_toc:
	pushad						
	push  es					
	mov   ax,sys_data				
	mov   es,ax					
	mov   edi,TOC_Data_Buffer			
loc_Read_Data_reg_1b:
	mov   dx, 0					 
	add   dx, word[port]				
	in    ax,dx					
	mov   word[TOC_Data_Buffer],ax			
	xchg  ah,al					
	mov   cx,ax					
	shr   cx,1					
	inc   edi					
	inc   edi					
loc_Read_Data_reg_1c:
	in    ax,dx					
	stosw						
	loop  loc_Read_Data_reg_1c			
	mov   dx,0x7					
	add   dx,word [port]				
	mov   cx,0xffff 				
do_some_loops:	
	in    al,dx					
	test  al,0x80					
	jnz   do_some_loops_loops			
	test  al,0x1					
	jnz   error_readtoc				
	clc						
	jmp   read_toc_ok				
do_some_loops_loops:					
	loop  do_some_loops				
error_readtoc:
	stc						
read_toc_ok:
	pop   es					
	popad						
	ret   

;====================================================;
; get the reg hex                                    ;
;====================================================;
get_the_reg_hex:
	mov   esi,TOC_Data_Buffer
	add   esi,4
	add   esi,2
	add   esi,8
	xor   ecx,ecx
	mov   cx,1
please:
	lodsw			    
	call  write_hex32
	loop  please
	ret
;====================================================;
; Wait unit ready                                    ;
;====================================================;
Wait_unit_ready:
	call  Clear_atapi_packet
	mov   byte[packet+0],0x0
	call  Send_Atapi_Packet
Clear_status:
	xor   ecx,ecx
	mov   cx,0xffff
	mov   dx,0x7
	add   dx,word[port]
loc_read_status_reg_4w:
	in    al,dx
	test  al,0x80					  
	jnz   pass_drq_err_check_2w
	test  al,0x40					 
	jz    pass_drq_err_check_2w			  
	test  al,0x01
	jnz   loc_ata_ide_io_error_w
	clc
	jmp   lets_go_by
pass_drq_err_check_2w:
	loop loc_read_status_reg_4w
loc_ata_ide_io_error_w:
	stc
lets_go_by:
	ret

;====================================================;
; WaitUnitReadyNoWait                                ;
;====================================================;
WaitUnitReadyNoWait:
	pushad
	call  Clear_atapi_packet
	mov   byte[packet+0],0x0
	call  Send_Atapi_Packet
	mov   dx,0x7
	add   dx,word[port]
	in    al,dx
	test  al,0x80					  
	jnz   pass_drq_err_check_2wNoW
	test  al,0x40					 
	jz    pass_drq_err_check_2wNoW			     
	test  al,0x01
	jnz   loc_ata_ide_io_error_wNoW
	clc
	jmp   lets_go_byNow
pass_drq_err_check_2wNoW:
loc_ata_ide_io_error_wNoW:
	popad
	stc
	ret
lets_go_byNow:
	popad
	clc
	ret

;====================================================;
; Play cd                                            ;
;====================================================;
Play_cd:
	pushad
	mov   byte[command],0xA0
	call  Small_Delay1
	call  Wait_unit_ready
	call  Small_Delay1
	call  Wait_unit_ready
	jc    Unit_not_ready_play
	call  Clear_atapi_packet
	mov   ax,10*60*75
	mov   byte[packet+8],al
	mov   byte[packet+7],ah
	mov   byte[packet+0],0x45
	call  Send_Atapi_Packet
	popad
	ret
Unit_not_ready_play:
	popad
	stc
	ret

;====================================================;
; PlayAll                                            ;
;====================================================; 
PlayAll:
	mov   byte[command],0xA0
	call  Small_Delay1
	call  Wait_unit_ready
	call  Small_Delay1
	call  Wait_unit_ready
	jc    Unit_not_ready_playALL
	call  Clear_atapi_packet
	push  ebx
	mov   ebx,dword[track_start2]
	call  Mirror_ebx
	mov   dword[packet+2],ebx
	mov   ebx,dword[track_length2]
	call  Mirror_ebx
	mov   dword[packet+6],ebx
	pop   ebx
	mov   byte[packet+0],0xA5
	call  Send_Atapi_Packet
	ret
Unit_not_ready_playALL:
	stc
	ret

;====================================================;
; Play cd+                                           ;
;====================================================;   
Play_cdog:
	mov   byte[command],0xA0
	call  Small_Delay1
	call  Wait_unit_ready
	call  Small_Delay1
	call  Wait_unit_ready
	jc    Unit_not_ready_playdog
	call  Clear_atapi_packet
	push  ebx
	mov   ebx,dword[track_start]
	call  Mirror_ebx
	mov   dword[packet+2],ebx
	pop   ebx
	mov   eax,dword[track_length]
	mov   byte[packet+8],al
	mov   byte[packet+7],ah
	mov   byte[packet+0],0x45
	call  Send_Atapi_Packet
	ret
Unit_not_ready_playdog:
	stc
	ret

;====================================================;
; Read disk                                          ;
;====================================================;     
Read_disk:
       ;push  ebx
	call  Small_Delay1
	call  Wait_unit_ready
	call  Small_Delay1
	call  Wait_unit_ready
	jc    Unit_not_ready_Read_disk
       ;pop   ebx
	call  Read_disk_packet
	call  Send_Atapi_Packet
	call  Read_atapi_bufferx
	ret
Unit_not_ready_Read_disk:
       ;pop   ebx
	stc
	ret   

;====================================================;
; Read disk packet                                   ;
;====================================================;
Read_disk_packet:
       ;call  Clear_atapi_packet
	mov   byte[packet+0],0x28
	mov   ebx,dword[SectorAdress]
	call  Mirror_ebx
	mov   dword[packet+2],ebx
	mov   ax,001
	mov   byte[packet+8],al
	mov   byte[packet+7],ah
	mov   byte[LoByte],48		    
	mov   byte[HiByte],20 
	ret

;====================================================;
; Read disk info                                     ;
;====================================================;
Read_disk_info:
	mov   ebx,16
	mov   dword[SectorAdress],ebx
	call  Read_disk
	ret

;====================================================;
; Read cd                                            ;
;====================================================;
Read_cd:
	call  Small_Delay1
	call  Wait_unit_ready
	call  Small_Delay1
	call  Wait_unit_ready
	jc    Unit_not_ready_Rcd
	call  Small_Delay1
NextSectorLoop:
	mov   byte[LoopCounter],5
SectorLoop:	   
	call  Read_disk_packet
	call  Send_Atapi_Packet
	call  Read_atapi_bufferx
	jnc   Success 
	sub   byte[LoopCounter],1
	cmp   byte[LoopCounter],0
	jne   SectorLoop  
	jmp   Unit_not_ready_Rcd
Success:
	add   dword[SectorAdress],1
	add   dword[LoadAdress],2048
	sub   word[counter],1
	cmp   word[counter],0
	jne   NextSectorLoop
	mov   ah,0
	clc
	ret
Unit_not_ready_Rcd:
	mov   ah,1
	stc
	ret  
 
;====================================================;
; Read atapi bufferx                                 ;
;====================================================;
Read_atapi_bufferx:
	pushad						
	push  es					
	mov   ax,sys_data				
	mov   es,ax					
	mov   edi,dword[LoadAdress]	    
	mov   ecx,2048
	xor   al,al
	rep   stosb
	mov   edi,dword[LoadAdress]	     
	mov   dx, 0					 
	add   dx, word[port]				
	mov   ecx,1024
	cli
Read_atapi_bufferx_loop:
	in    ax,dx
	stosw
	loop  Read_atapi_bufferx_loop
	sti					  
	mov   dx,0x7					
	add   dx,word [port]				
	mov   cx,0xffff 				
do_rab_some_loops:  
	in    al,dx					
	test  al,0x80					
	jnz   do_some_loops_loops_rbx			   
	test  al,0x1					
	jnz   error_read_bufferx			
	clc						
	jmp   read_bufferx_ok				
do_some_loops_loops_rbx:				  
	loop  do_rab_some_loops 			
error_read_bufferx:
	stc						
read_bufferx_ok:
	pop   es					
	popad						
	ret 

;====================================================;
; Get file on cd info                                ;
;====================================================;
Get_file_on_cd_info:
	call  Read_toc
	jc    Toc_error
	call  Read_disk_info
	mov   esi,dword[LoadAdress]	    
	mov   ebx,dword[ds:esi+140]
	mov   dword[SectorAdress],ebx
	call  Read_disk
	jc    Toc_error 
	xor   eax,eax
	mov   dword[RootDirSector],eax	      
	mov   esi,dword[LoadAdress]	   
	xor   ecx,ecx
	mov   ecx,1
GetOtherPathName:
	mov   bl,byte[ds:esi] 
	cmp   bl,0
	je    PathNameDone 
	cmp   bl,1
	jne   NotRootDir
	mov   eax,dword[ds:esi+2]
	mov   dword[RootDirSector],eax	      
NotRootDir:
	mov   bl,byte[ds:esi]
	mov   dl,bl
	movzx edx,dl
	add   esi,edx
	add   esi,8
	and   edx,1
	add   esi,edx
	jmp   GetOtherPathName	   
PathNameDone:
	mov   ebx,dword[RootDirSector]
	mov   dword[SectorAdress],ebx		
	call  Read_disk
	jc    Toc_error
 ;---------------------------------;
 ; Scan for filename               ;
 ;---------------------------------;
	mov   esi,dword[LoadAdress]		
	xor   ecx,ecx
	mov   ecx,1
GetOtherFileName:
	mov   al,1
	mov   bl,byte[ds:esi]
	cmp   bl,0
	je    Toc_NoFileError
	mov   bl,byte[ds:esi]
	mov   dl,bl
	mov   ebx,dword[ds:esi+2]			
	mov   ebx,dword[ds:esi+10]			
	mov   bl,byte[ds:esi+25]		 
	shr   bl,1
	and   bl,1					
	mov   bl,byte[ds:esi+32]			
	push  es
	mov   ax,sys_data				
	mov   es,ax					
	mov   edi,TmpFileName1
	xor   al,al
	mov   byte[es:edi],al
	push  esi
	push  edi
	push  ecx
	push  edx
	mov   dl,byte[ds:esi+32]
	mov   byte[CdNameLen],dl
	sub   [CdNameLen],2
	xor   cl,cl
	add   esi,33
CopyMoreTmpName:
	mov   al,byte[ds:esi]
	cmp   al,0
	je    EndOfTmpNameCopy
	cmp   al,1
	je    EndOfTmpNameCopy
	cmp   al,';'
	je    EndOfTmpNameCopy
	mov   byte[es:edi],al
	xor   al,al
	mov   byte[es:edi+1],al
	inc   esi
	inc   edi
	inc   cl
	cmp   cl,dl
	jae   EndOfTmpNameCopy
	jmp   CopyMoreTmpName
EndOfTmpNameCopy:
	pop   edx
	pop   ecx
	pop   edi
	pop   esi
	pop   es
	cmp   byte[CliOrUser],1
	jne   @f
	call  CompearStringUser 
	jc    NotThisFile
	jmp   WeHaveIt
@@:
	call  Compear_String 
	jc    NotThisFile
WeHaveIt:	 
	mov   ebx,dword[ds:esi+2]
	mov   ecx,dword[ds:esi+10]
	mov   dword[SectorAdress],ebx
	mov   dword[FileSizeBytes],ecx
	clc
	jmp   Toc_error1	  
NotThisFile:
	movzx edx,dl
	add   esi,edx
	and   edx,1
	add   esi,edx
	jmp   GetOtherFileName
Toc_NoFileError:
	mov   ah,2
	stc 
	jmp   @f	
Toc_error:
	mov   ah,1
	stc 
	jmp   @f					  
Toc_error1:
	mov   ah,0
@@:
	ret

;====================================================;
; Read toc                                           ;
;====================================================;
Read_toc:
	call  Small_Delay1
	call  Wait_unit_ready
	call  Small_Delay1
	call  Wait_unit_ready
	pushad
	jc    Unit_not_ready_a
	call  Small_Delay1
	call  Clear_atapi_packet
	mov   ax,804 
	mov   byte[packet+8],al
	mov   byte[packet+7],ah 
	mov   byte[packet+0],0x43
	mov   byte[LoByte],04		       
	mov   byte[HiByte],08		       
	call  Send_Atapi_Packet
	jc    Unit_not_ready_a
	call  Read_write_toc
	jc    Unit_not_ready_a
Unit_is_ready_a:
	popad
	clc
	ret
Unit_not_ready_a:
	popad
	stc
	ret   

;====================================================;
; Get track info                                     ;
;====================================================; 
Get_track_info:
	call  Read_toc
	jc    Read_toc_error
	call  Small_Delay1
Get_track_info1:
	pushad
	xor   edx,edx
	mov   esi,TOC_Data_Buffer
	add   esi,3
	lodsb
	;inc  al
	;dec   al
	mov   cl,al
	mov   [NumberOfTracks],al
	movzx ecx,cl
	mov   esi,TOC_Data_Buffer
	add   esi,4
Gettrackinfo:
	push  ecx
	inc   edx
	mov   bl,byte[ds:esi+2]
	cmp   bl,byte[track_num]
	jne   NoNotThisTrack
	mov   ebx,dword[ds:esi+4]
	call  Mirror_ebx 
	mov   dword[track_start],ebx
	mov   ebx,dword[ds:esi+4+8]
	call  Mirror_ebx
	mov   [track_length3],ebx
	mov   eax,dword[track_start]
	sub   ebx,eax
	and   ebx,0xffff
	mov   dword[track_length],ebx
	mov   bl,byte[ds:esi+1]
	and   bl,0x0f
	and   bl,4
	shr   bl,2
	mov   byte[track_type],bl
NoNotThisTrack:
	add   esi,8
	pop   ecx
	dec   ecx
	cmp   ecx,0
	jne   Gettrackinfo
	popad
	clc
	ret
Read_toc_error:
	stc
	ret  

;====================================================;
; PlayTrack                                          ;
;====================================================;   
PlayTrack:
	pushad
	push  es
	mov   byte[command],0xA0
	mov   [track_num],al
	call  Get_track_info
	jc    PlayTrackError
	call  Play_cdog
	pop   es
	popad
	mov  al,[NumberOfTracks]
	clc
	ret

	PlayTrackError:
	pop   es
	popad
	stc
	ret

;====================================================;
; TrackInFo                                          ;
;====================================================;   
TrackInFo:
	pushad
	push  es
	mov   byte[command],0xA0
	mov   [track_num],1
	call  Get_track_info
	jc    TrackInFoError
	pop   es
	popad
	mov  al,[NumberOfTracks]
	mov  bl,byte[track_type]
	clc
	ret

TrackInFoError:
	pop   es
	popad
	stc
	ret

;====================================================;
; PlayWithTrack                                      ;
;====================================================;   
PlayAllTracks:
	pushad
	push  es
	mov   byte[command],0xA0
	mov   [track_num],1
	call  Get_track_info
	jc    PlayAllTracksError
	mov   ecx,dword[track_start]
	mov   [FirstTrack],ecx
	mov   cl,[NumberOfTracks]
	mov   [track_num],cl
	call  Get_track_info1
	mov   eax,[FirstTrack]
	mov   [track_start2],eax
	mov   ecx,dword[track_length3]
	sub   ecx,eax
       ;and   ecx,0xffff ;;;;;
	mov   dword[track_length2],ecx
	call  PlayAll
	pop   es
	popad
	mov  al,[NumberOfTracks]
	clc
	ret

PlayAllTracksError:
	pop   es
	popad
	stc
	ret

;====================================================;
; Clear atapi packet                                 ;
;====================================================;
Clear_atapi_packet:
	pushad
	mov   byte[packet+0],0x00
	mov   byte[packet+1],0x00
	mov   byte[packet+2],0x00
	mov   byte[packet+3],0x00
	mov   byte[packet+4],0x00
	mov   byte[packet+5],0x00
	mov   byte[packet+6],0x00
	mov   byte[packet+7],0x00
	mov   byte[packet+8],0x00
	mov   byte[packet+9],0x00
	mov   byte[packet+10],0x00
	mov   byte[packet+11],0x00
	popad
	ret

;====================================================;
; Stop cd                                            ;
;====================================================;
Stop_cd:
	push  edi
	call  Clear_atapi_packet
	mov   byte[packet+4],0x0
	mov   byte[packet+1],0x1
	mov   byte[packet+0],0x1b
	call  Send_Atapi_Packet
	pop   edi
	ret   

;====================================================;
; Pause cd                                           ;
;====================================================;
Pause_cd:
	pushad
	call  Clear_atapi_packet
	mov   byte[packet+8],0x0	       
	mov   byte[packet+0],0x4b
	call  Send_Atapi_Packet
	popad
	ret   

;====================================================;
; Start cd                                           ;
;====================================================;
Start_cd:
	push  edi
	call  Clear_atapi_packet
	mov   byte[packet+4],0x1
	mov   byte[packet+1],0x1
	mov   byte[packet+0],0x1b
	call  Send_Atapi_Packet
	pop   edi
	ret   

;====================================================;
; Eject cd                                           ;
;====================================================;
Eject_cd:
	push  edi
	pushad
	mov   byte[command],0xA0
	call  Clear_atapi_packet
	mov   byte[packet+4],0x2
	mov   byte[packet+1],0x1
	mov   byte[packet+0],0x1b
	call  Send_Atapi_Packet
	popad
	pop   edi
	ret   

;====================================================;
; Close cd                                           ;
;====================================================;
Close_cd:
	push  edi
	pushad
	mov   byte[command],0xA0
	call  Clear_atapi_packet
	mov   byte[packet+0],0x1b 
	mov   byte[packet+1],0x1
	mov   byte[packet+4],0x3
	call  Send_Atapi_Packet
	popad
	pop   edi
	ret
 
;====================================================;
; Small Delay                                        ;
;====================================================;
Small_Delay1:
	push  cx
	mov   cx,0xffff
BusyDelay3a11:					
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	loop  BusyDelay3a11
	pop   cx
	ret  

;====================================================;
; Mirror ebx                                         ;
;====================================================;
Mirror_ebx:
	push  edi
	push  es
	mov   ax,sys_data				
	mov   es,ax					
	mov   edi,Ebx_buffer
	mov   byte[es:edi+3],bl
	shr   ebx,8
	mov   byte[es:edi+2],bl
	shr   ebx,8
	mov   byte[es:edi+1],bl
	shr   ebx,8
	mov   byte[es:edi+0],bl
	mov   ebx,dword[Ebx_buffer]
	pop   es
	pop   edi
	ret

;====================================================;
; Read disk                                          ;
;====================================================;     
ReadSubChannal:
	push  es
	pushad
	xor   ecx,ecx
	mov   [stateus],0xff
	call  Small_Delay1
	call  Wait_unit_ready
	call  Small_Delay1
	call  Wait_unit_ready
	jc    ReadSubChannalNotReady
	call  Small_Delay1
	call  Clear_atapi_packet
	mov   byte[packet+8],0x16
	mov   byte[packet+7],0x00
	mov   byte[packet+1],0x00
	mov   byte[packet+2],0x40
	mov   byte[packet+3],0x01
	mov   byte[packet+0],0x42
	mov   byte[LoByte],0xff 		 
	mov   byte[HiByte],0xff 		 
	call  Send_Atapi_Packet
	jc    ReadSubChannalNotReady
	call  ReadSubChannalWrite
	jc    ReadSubChannalNotReady
ReadSubChannalready:
	mov   ax,sys_data				
	mov   es,ax					
	mov   edi,SubBuffer
	add   edi,1
	mov   al,byte[es:edi]
	add   edi,5
	mov   ah,byte[es:edi]
	mov   [status1],ax
	popad
	pop   es
	mov   ax,[status1]
	clc
	ret
ReadSubChannalNotReady:
	popad
	pop es
	stc
	ret   

;====================================================;
; ReadSubChannalWrite                                ;
;====================================================;  
ReadSubChannalWrite:						 
	pushad						
	push  es  
	xor   ecx,ecx					   
	mov   ax,0x18				   
	mov   es,ax					
	mov   edi,SubBuffer			 
;loc_Read_Data_reg_1b:
	mov   cx,8
	mov   dx, 0					 
	add   dx, word[port]				
       ; in    ax,dx                                     
       ; mov   word[SubBuffer],ax                  
       ; xchg  ah,al                                     
       ; mov   cx,ax                                     
	;shr   cx,1                                      
	;inc   edi                                       
	;inc   edi                                       
ReadSubChannalWriteLoop:
	in    ax,dx					
	stosw						
	loop  ReadSubChannalWriteLoop  
	mov   dx,0x7					
	add   dx,word [port]				
	mov   cx,0xffff 				
ReadSubChannalWritedo_some_loops:  
	in    al,dx					
	test  al,0x80					
	jnz   do_some_loops_loopssc			  
	test  al,0x1					
	jnz   ErrorReadSubChannal			      
	clc						
	jmp   ReadSubChannalread_toc_ok 			      
do_some_loops_loopssc:					  
	loop  ReadSubChannalWritedo_some_loops				   
ErrorReadSubChannal:
	stc						
ReadSubChannalread_toc_ok:
	pop   es					
	popad						
	ret   

;====================================================;
; Data                                               ;
;====================================================;
LoByte: 	   db 0
HiByte: 	   db 0
CliOrUser	   db 0
SectorAdress:	   dd 0
LoadAdress:	   dd 0
FileSizeBytes:	   dd 0
counter:	   dw 0
LoopCounter:	   db 0

track_type:	   db 0
track_num	   db 0
stateus 	   db 0
track_start:	   dd 0
track_length:	   dd 0
Ebx_buffer:	   dd 0
NumberOfTracks	   db 0
FirstTrack	   dd 0
track_start2:	   dd 0
track_length2:	   dd 0
track_length3	   dd 0
testebx_buffer:    dd 0
status1 	   dw 0
RootDirSector:	   dd 0
TmpFileName1:	   du 64
		   db 0x0d,0
TmpFileName2:	   du 64

packet:
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0
		   db 0x0

SubBuffer:	   rb 1250 
				    
TOC_Data_Buffer:   rb 806
TOC_Data_Buffer1:  rb 806
		  
DiskBuffer:	   rb 2048  
DiskBuffer1:	   rb 2048  
			   



	      

