;=========================================================;
; DMA                                            11/12/03 ;
;---------------------------------------------------------;
; by Ontanu Bogdan Valenti.                               ;
;                                                         ;
; Sets up DMA read/write for floppy.                      ;                          
;=========================================================;

;====================================================;
;  Setup_DMA2_Read.                                  ;
;====================================================;
Setup_DMA2_Read:		     
;====================================================;
; mask channel 2.                                    ;
;====================================================;     
	mov	eax,4
	add	eax,2
	out	0Ah,al
;====================================================;
; clear pointers                                     ;
;====================================================;           
	xor	eax,eax
	out	0Ch,al						    
;====================================================;
; setup mode of operation                            ;
;====================================================; 
	mov	al,44h						    
	add	al,2						    
	out	0Bh,al
;====================================================;
; set page low register                              ;
;====================================================;                                               
	mov	edx,081h
	mov	eax,OffsetDma2Buffer 
	add	eax,[BaseAddOn] 				    
	shr	eax,16
	out	dx,al
;====================================================;
; setup offset addr                                  ;
;====================================================;                                                 
	mov	edx,04
	mov	eax,OffsetDma2Buffer 
	add	eax,[BaseAddOn] 				    
	and	eax,0FFFFh
	out	dx,al						    
	mov	al,ah
	out	dx,al
;====================================================;
; setup length                                       ;
;====================================================;                                                      
	mov	eax,512
	dec	eax						    
	mov	edx,05
	out	dx,al						    
	mov	al,ah
	out	dx,al						    
;====================================================;
; unmask channel 2                                   ;
;====================================================;  
	mov	al,2
	out	0Ah,al						    
	ret


Setup_DMA2_Write:
;====================================================;
; mask channel 2                                     ;
;====================================================;                   
	mov	eax,4
	add	eax,2
	out	0Ah,al
;====================================================;
; clear pointers                                     ;
;====================================================;               
	xor	eax,eax
	out	0Ch,al						    
;====================================================;
; setup mode of operation                            ;
;====================================================;  
	mov	al,48h						    
	add	al,2						    
	out	0Bh,al						    
;====================================================;
; set page low register                              ;
;====================================================;  
	mov	edx,081h
	mov	eax,OffsetDma2Buffer1
	add	eax,[BaseAddOn] 				    
	shr	eax,16
	and	eax,3
	out	dx,al 
;====================================================;
; setup offset addr                                  ;
;====================================================;                                                
	mov	edx,04
	mov	eax,OffsetDma2Buffer1
	add	eax,[BaseAddOn] 				    
	and	eax,0FFFFh
	out	dx,al						    
	mov	al,ah
	out	dx,al
;====================================================;
; setup length                                       ;
;====================================================;                                                      
	mov	eax,512
	dec	eax						    
	mov	edx,05
	out	dx,al						    
	mov	al,ah
	out	dx,al						    
;====================================================;
;  unmask channel 2                                  ;
;====================================================; 
	mov	al,2
	out	0Ah,al						    
	ret

