;=========================================================;
; AutoDex                                        11/12/06 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
ConfigFileBuff = 0x400000-0x10000
LoadConfigFile:
	cmp   dword[TotalMemoryMB],8
	jb    NoRamDetected
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load main files.                                                                 ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	cmp   [PromptLetter],'A'
	jne   TryHdd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from Fdd.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  LoadConfigFdd
	jc    nofile
	jmp   LoadingFinished
TryHdd:
	cmp   [PromptLetter],'C'
	jne   TryCD
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from Hdd.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  LoadConfigHdd
	jc    nofile
	jmp   LoadingFinished
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from CD.                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TryCD:
	cmp   [PromptLetter],'D'
	jne   nofile
	call  LoadConfigCD
	jc    nofile
LoadingFinished:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main loop.                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov   [BFPointer],ConfigFileBuff
CommandsLoop:
	mov   esi,[BFPointer]
	cmp   byte[esi],13	   ; check for a ret
	jne   No_Ret
	inc   esi		   ; inc past
	mov   [BFPointer],esi
	jmp   CommandsLoop	   ; in case of more then one
No_Ret:
	cmp   byte[esi],10	   ; check for line feed
	jne   Commands
	inc   esi		   ; inc past
	mov   [BFPointer],esi
	jmp   CommandsLoop	   ; in case of more then one
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Commands.                                                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Commands:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test for 'END'                                                                   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov   esi,[BFPointer]	   ; Check for 'end'
	mov   ecx,3		   ; Number of letters to check
	mov   edi,cEND1
	repe  cmpsb
	je    ExitHere		   ; it's a match / jump to exit
	mov   esi,[BFPointer]	   ; Check for 'END'
	mov   ecx,3
	mov   edi,cEND
	repe  cmpsb
	je    ExitHere
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test for 'LOAD'                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov   esi,[BFPointer]	   ; Check for 'load'
	mov   ecx,4
	mov   edi,cLOAD
	repe  cmpsb
	je    ItIsLOAD
	mov   esi,[BFPointer]	   ; Check for 'LOAD'
	mov   ecx,4
	mov   edi,cLOAD1
	repe  cmpsb
	je    ItIsLOAD

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test for 'GUI'                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov   esi,[BFPointer]	   ; Check for 'load'
	mov   ecx,3
	mov   edi,cGUI
	repe  cmpsb
	je    ItIsGUI
	mov   esi,[BFPointer]	   ; Check for 'LOAD'
	mov   ecx,3
	mov   edi,cGUI1
	repe  cmpsb
	je    ItIsGUI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Print Bad Command                                                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
not_Command:
	mov   esi,BadCommand666    ; *****needs to end program*****
	call  print_string
	jmp   ExitHere
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load file error                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
nofile:
load_error:
	mov   esi,LError	  ; error loading file
	call  print_string	  ; print message
	jmp   ExitHere

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load file error                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
nofile1:
	mov   esi,LError1	  ; error loading file
	call  print_string	  ; print message
	mov   [Exit?],1
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; No Ram Detected                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
NoRamDetected:
	mov   esi,NoRamDetectErr  ; error loading file
	call  print_string	  ; print message
	jmp   ExitHere
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Exit..                                                                           ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ExitHere:
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; GUI..                                                                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ItIsGUI:
	pushad
	call  GuiYes
	popad
	cmp   [Exit?],0
	je    CommandsLoop
	jmp   ExitHere

GuiYes:
	cmp   byte[NoVesa],1
	je    NoVesaTwoGui
	mov   [GuiStartup],1
NoVesaTwoGui:
	mov   esi,[BFPointer]
	add   esi,3
	cmp   byte[ds:esi],' '
	jne   SetPointerGUILoop
	inc   esi
SetPointerGUILoop:
	mov   ecx,24
SetPointerGUILoop1:
	cmp   byte[ds:esi],13	      ; check for a ret
	je    TryNextChar
	cmp   byte[ds:esi],10
	je    TryNextCharGUI
	inc   esi
	loop  SetPointerGUILoop1
	mov   [Exit?],1
	ret

TryNextCharGUI:
	inc   esi
	mov   [BFPointer],esi
	mov   [Exit?],0
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LOAD..                                                                           ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ItIsLOAD:
	pushad
	call  Loader
	popad
	cmp   [Exit?],0
	je    CommandsLoop
	jmp   ExitHere
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LOAD..                                                                           ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Loader:
	mov   esi,[BFPointer]
	mov   edi,CommandBuffer2
	mov   ecx,127
	cld
	rep   movsb
	mov   al,0
	stosb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load main files.                                                                 ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	cmp   [PromptLetter],'A'
	jne   TryHddLoad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from Fdd.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  LoadLoadFdd
	jc    nofile1
	jmp   LoadingFileFinished
TryHddLoad:
	cmp   [PromptLetter],'C'
	jne   TryCDLoad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from Hdd.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  LoadLoadHdd
	jc    nofile1
	jmp   LoadingFileFinished
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Module  file from CD.                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TryCDLoad:
	cmp   [PromptLetter],'D'
	jne   nofile1
	call  LoadLoadCD
	jc    nofile1
LoadingFileFinished:
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  dword[ImageLoadAddrVar]				       
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	mov   [keybuffer],0
	mov   esi,[BFPointer]
	add   esi,4
	cmp   byte[ds:esi],' '
	jne   SetPointerLoop
	inc   esi
SetPointerLoop:
	mov   ecx,24
SetPointerLoop1:
	cmp   byte[ds:esi],13	      ; check for a ret
	je    TryNextChar
	cmp   byte[ds:esi],10
	je    TryNextChar
	inc   esi
	loop  SetPointerLoop1
	mov   [Exit?],1
	ret
TryNextChar:
	inc   esi
	mov   [BFPointer],esi
	mov   [Exit?],0
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LoadModFdd.                                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LoadConfigFdd:
	pushad
	mov   esi,FileName1
	mov   edi,ConfigFileBuff
	call  FloppyfileLoad
	jc    FddErr
	popad
	clc
	ret
FddErr:
	popad
	stc
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LoadModFdd.                                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LoadConfigHdd:
	pushad
	mov   edi,FileName1
	mov   edx,ConfigFileBuff
	call  RunCommandHdd
	jc    FddErr
	popad
	clc
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LoadModCD.                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LoadConfigCD:
	pushad
	mov   ecx,11
	mov   esi,FileName1
	mov   edi,ConfigFileBuff
	call  CdfileLoad
	jc    FddErr
	popad
	clc
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LoadLoadFdd.                                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LoadLoadFdd:
	pushad
	mov   esi,FileName2
	mov   edi,dword[ImageLoadAddrVar]
	call  FloppyfileLoad
	jc    FddErr
	popad
	clc
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LoadLoadFdd.                                                                     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LoadLoadHdd:
	pushad
	mov   edi,FileName2
	mov   edx,dword[ImageLoadAddrVar]
	call  RunCommandHdd
	jc    FddErr
	popad
	clc
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; LoadLoadCD.                                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LoadLoadCD:
	pushad
	mov   ecx,8
	mov   esi,FileName2
	mov   edi,dword[ImageLoadAddrVar]
	call  CdfileLoad
	jc    FddErr
	popad
	clc
	ret
 ;----------------------------------------------------;
 ; Data.                                              ;
 ;----------------------------------------------------;
GuiStartup	db	  0
Exit?		db	  0
NextLine	db	  13,0
BadCommand666	db	  "Error, unkown command in startup.bat",13,13,0
LError		db	  "Error, No startup.bat file found",13,13,0
LError1 	db	  "Error, Loading file",13,13,0
NoRamDetectErr	db	  "Error, Can not detect ram size or bellow 8MB ",13,13,0
FileName1	db	  'STARTUP.BAT',0
FileName2	db	  'LOAD.DEX',0
BFPointer	dd	  0
Hz		dw	  0
 ;---------------;
 ; Commands.     ;
 ;---------------;
cLOAD		db 'LOAD ',0
cLOAD1		db 'load ',0
cGUI		db 'GUI ',0
cGUI1		db 'gui ',0
cEND		db 'END ',0
cEND1		db 'end ',0
;ConfigFileBuff:   times 8192 db ?  ;8kb Basic language file buffer

