;=========================================================;
; Fat12                                          11/12/06 ;
;---------------------------------------------------------;
; Checks for command.                                     ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

;====================================================;
; UpdateClusterChain.                                ;
;====================================================;
UpdateClusterChain:
	pushad
	push  es
	push  ds
	mov   ax,18h 
	mov   ds,ax				
	mov   es,ax
	mov   ax,[FileCluster]
	cmp   [FileSizeInSectors],1
	jbe   EndOfFile
	mov   ecx,dword[FileSizeInSectors]
	dec   ecx
@@:
	push  ecx
 ;----------------------------------------------------;
 ; UpdateNextClusterInChain.                          ;
 ;----------------------------------------------------;
	call  GetNextTwoClusters
	jc    UpdateClusterChainError
	mov   ax,[ClusterOne]
	mov   bx,[ClusterTwo]
	call  UpdateClusterValue
	pop   ecx
	loop  @b
	mov   ax,[ClusterTwo]
 ;----------------------------------------------------;
 ; EndOfFile.                                         ;
 ;----------------------------------------------------;
EndOfFile:
	mov   bx,0x0fff
	call  UpdateClusterValue
	pop   ds
	pop   es
	popad
	clc 
	ret

UpdateClusterChainError:
	pop   ds
	pop   es
	popad
	stc
	ret
;====================================================;
; GetNextCluster.                                    ;
;====================================================;
GetNextCluster:
	pushad
	mov   [MaxClusters],1534
	mov   esi,BpbFat12
	add   esi,515
	mov   [ClusterCount],2
	mov   cx,[MaxClusters]					      
GetNextClusterLoop:
	lodsw
	and   ax,0x0FFF
	jz    FoundFreeCluster
	inc   [ClusterCount] 
	dec   esi
	lodsw
	shr   ax,4	 
	or    ax,ax
	jz    FoundFreeCluster
	inc   [ClusterCount]
	loop  GetNextClusterLoop
 ;----------------------------------------------------;
 ; NoMoreFreeClusters.                                ;
 ;----------------------------------------------------;
	popad
	stc
	ret

 ;----------------------------------------------------;
 ; FoundFreeCluster.                                  ;
 ;----------------------------------------------------;
FoundFreeCluster:
	popad
	clc 
	ret

;====================================================;
; GetNextTwoCluster.                                 ;
;====================================================;
GetNextTwoClusters:
	pushad
	mov   [MaxClusters],1534
	mov   esi,BpbFat12
	add   esi,515
	mov   [Clusterloop],0
	mov   [ClusterCount],2
	mov   cx,[MaxClusters]					      
GetNextTwoClusterLoop:
	lodsw
	and   ax,0x0FFF
	jz    FoundFreeClusterTwoA
	inc   [ClusterCount] 
	dec   esi
GetNextTwoOdd:
	lodsw
	shr   ax,4	 
	or    ax,ax
	jz    FoundFreeClusterTwoB
	inc   [ClusterCount]
	loop  GetNextTwoClusterLoop
 ;----------------------------------------------------;
 ; NoMoreFreeClustersTwo.                             ;
 ;----------------------------------------------------;
	mov   [ErrorCode],5
	popad
	stc
	ret

 ;----------------------------------------------------;
 ; FoundFreeClusterTwoA.                              ;
 ;----------------------------------------------------;
FoundFreeClusterTwoA:
	dec   esi
	cmp   [Clusterloop],1
	je    @f
	mov   ax,[ClusterCount]
	mov   [ClusterOne],ax
	mov   [Clusterloop],1
	inc   [ClusterCount]
	jmp   GetNextTwoOdd
@@:
	mov   ax,[ClusterCount]
	mov   [ClusterTwo],ax
	popad
	clc 
	ret
 ;----------------------------------------------------;
 ; FoundFreeClusterTwoB.                              ;
 ;----------------------------------------------------;
FoundFreeClusterTwoB:
	cmp   [Clusterloop],1
	je    @f
	mov   ax,[ClusterCount]
	mov   [ClusterOne],ax
	mov   [Clusterloop],1
	inc   [ClusterCount]
	jmp   GetNextTwoClusterLoop
@@:
	mov   ax,[ClusterCount]
	mov   [ClusterTwo],ax
	popad
	clc 
	ret

;====================================================;
; GetNextTwoCluster.                                 ;
;====================================================;
FindFileName:
       pushad 
       mov   dword[RootFileAddress],0	  
       mov   dword[NameOfFileToLoad],esi
       call  ConevertFileName
       mov   edi,NameOfFileToLoadBuffer
       call  UpperCase
       mov   edi, [RootDirBufferVar] ;RootDirBuffer
       mov   esi,NameOfFileToLoadBuffer 
       mov   dx,[bpbRootEntries]
       cmp   [RootYesNoA],0
       je    CheckForSameName
       mov   dx,[FolderEntrysNumberFdd]
 ;----------------------------------------------------;
 ; CheckForSameName.                                  ;
 ;----------------------------------------------------;
CheckForSameName:	    
	mov   ecx,11
CheckForSameNameLoop:	    
	cmp   byte [es:edi],ch
	je    CheckForSameNameNotFoundinRootDir 			  
	pushad					       
	repe  cmpsb
	popad					       
	je    CheckForSameNameFoundinRootDir
	add   edi, 32
	dec   dx
	jnz   CheckForSameNameLoop
 ;----------------------------------------------------;
 ; CheckForSameNameNotFoundinRootDir.                 ;
 ;----------------------------------------------------;                           
CheckForSameNameNotFoundinRootDir:
	popad
	stc
	ret

CheckForSameNameFoundinRootDir:
	mov   dword[RootFileAddress],edi
	popad
	clc 
	ret    

;====================================================;
; ReleaseClusterChain.                               ;
;====================================================;
ReleaseClusterChain:
	pushad
	mov   word [clusterUP],ax
ReleaseClusterChainLoop:
	mov   ax,word [clusterUP]
	mov   bx,0x00
	call  UpdateClusterValue
	mov   dx,[ClustOrigValue] 
	mov   word [clusterUP],dx			  
	cmp   dx,0x0FF0 				
	jb    ReleaseClusterChainLoop
 ;----------------------------------------------------;
 ; Exit.                                              ;
 ;----------------------------------------------------;   
ReleaseClusterChainExit:
	popad
	ret
;1
;====================================================;
; FILL BPB & FAT,INTO MEMORY.                        ;
;====================================================;
WriteCommand:
	pushad
	push  es
	push  ds
	mov   [ErrorCode],0
	mov   [FddSectorsWriteCount],0
	mov   [FileLoadCountUP],dword 0
	mov   dword[NameOfFileToMake],esi
	cmp   byte[ds:esi],' '
	je    writeCommandNameError
	cmp   byte[ds:esi],0
	je    writeCommandNameError
	mov   dword[LoadFileFromAddress],edi
	mov   dword[FileSizeInBytes],eax
	call  GetFileSizeInSectors
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	mov   edi,FileEntry			    ; Point edi to file entry address.
	mov   ecx,8				    ; Move 8 into count reg.
	mov   eax,0x00000000			    ; Make sure EAX is 0.
	cld					    ; L to R
	rep   stosd				    ; Fill dir entry with 0.
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	cmp   [RootYesNoA],0
	je    @f
	call  WriteCommandFolder
	jc    writeCommandError
	jmp    writeCommandSucessFdd
@@:
	call  DirFillRootUSB
	jc    writeCommandError
	call  UsedSectorsFddWrite
	mov   [ErrorCode],5
	xor   eax,eax
	mov   ax,word[FreeSectors]
	cmp   [FileSizeInSectors],eax
	ja    writeCommandError
	mov   [ErrorCode],0
	call  FindNextFreeRootEntry
	jc    writeCommandError
	mov   esi,dword[NameOfFileToMake]
	call  MakeNewFile
	jc    writeCommandError
	call  FillOutRootEntry
	call  UpdateClusterChain
	jc    writeCommandError
	call  WriteSectors
	jc    writeCommandError
	call  DirFatRootUpdate
	jc    writeCommandError
writeCommandSucessFdd:
	call  Fdd_motor_off
	pop   ds
	pop   es
	popad
	mov   ebx,dword[FddSectorsWriteCount]
	mov   edx,NameOfFileToLoadBuffer
	mov   ah,0
	mov   [USBcount],0
	clc
	ret

writeCommandError:
	call  Fdd_motor_off
	mov   [USBcount],0
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCode]
	stc
	ret

writeCommandNameError:
	call  Fdd_motor_off
	pop   ds
	pop   es
	popad
	mov   ah,8
	stc
	ret

;====================================================;
; WriteCommandFolder.                                ;
;====================================================;
WriteCommandFolder:
	mov   eax,dword[FolderSizeSectorsFdd]
	shl   eax,9
	shr   eax,5
	mov   [FolderEntrysNumberFdd],ax
	call  DirFillRootUSB
	jc    WriteCommandFolderError
	cmp   [FddChangeYesNo],1
	je    WriteCommandFolderError
	call  UsedSectorsFddWrite
	mov   [ErrorCode],5
	xor   eax,eax
	mov   ax,word[FreeSectors]
	cmp   [FileSizeInSectors],eax
	ja    WriteCommandFolderError
	mov   [ErrorCode],0
	mov   [RootDirBufferVar],0x100000
	call  FindNextFreeRootEntry
	jc    WriteCommandFolderError
	mov   esi,dword[NameOfFileToMake]
	call  MakeNewFile
	jc    WriteCommandFolderError
	call  FillOutRootEntry
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	call  UpdateClusterChain
	jc    WriteCommandFolderError
	call  WriteSectors
	jc    WriteCommandFolderError
	call  DirFatRootUpdate
	jc    WriteCommandFolderError
	mov   ax,[FirstFolderClusterAfdd]
	mov   [StartCluster],ax
	mov   dword[LoadFileFromAddress],0x100000
	call  WriteSectors
	jc    WriteCommandFolderError
	clc
	ret
WriteCommandFolderError:
	stc
	ret

;====================================================;
; DirFatRootUpdate.                                  ;
;====================================================;
DirFatRootUpdate:
	mov   [BpbCount],0
	mov   [number],0
	mov   ecx,11
UpdateBpbLoop:
	mov   [FddErrCount],0
	push  ecx
	mov   ecx,512
	mov   ax,sys_data  
	mov   ds,ax
	mov   es,ax  
	mov   edi,OffsetDma2Buffer1 
	mov   esi,BpbFat12
	add   esi,[BpbCount]
	rep   movsb
	inc   [number]
TryWriteFloppyAgainABC:
	mov   cl,[number]
	mov   ch,00
	mov   dh,00					 
	mov   dl,00					 
	call  [FddWrite]
	jnc   FloppyWriteOK1
	inc   [FddErrCount]
	cmp   [FddErrCount],4
	je    @f
	pushad
	call  FddRecalibrate
	popad
	jmp   TryWriteFloppyAgainABC
FloppyWriteOK1:
	add   [BpbCount],512
	jmp   DoAnotherLoopFatUpdate  
@@:
;====================================================;
; We come here if floppy error.                      ;
;====================================================;
	mov   byte[ErrorCode],1
	pop   ecx
	jmp   DirFatError
DoAnotherLoopFatUpdate:
	pop   ecx
	loop  UpdateBpbLoop
;====================================================;
; FILL ROOT DIR INTO MEMORY.                         ;
;====================================================;
	cmp   [RootYesNoA],0
	jne   GoodThatWorked
	mov   [RdirCount],0
	mov   [number],1
	mov   ecx,14
UpdateRootDirLoop:
	mov   [FddErrCount],0
	push  ecx
	mov   ecx,512
	mov   ax,sys_data  
	mov   ds,ax
	mov   es,ax  
	mov   edi,OffsetDma2Buffer1
	mov   esi,RootDirBuffer 	       
	add   esi,[RdirCount]
	rep   movsb
	inc   [number]
WriteFddRootUuDateLoop:
	mov   cl,[number]
	mov   ch,00
	mov   dh,01					   
	mov   dl,00					   
	call  [FddWrite]
	jnc   FddWriteOK
	inc   [FddErrCount]
	cmp   [FddErrCount],4
	je    @f
	pushad
	call  FddRecalibrate
	popad
	jmp   WriteFddRootUuDateLoop
FddWriteOK:
	add   [RdirCount],512
	jmp   DoAnotherLoopRootUpdate  
;====================================================;
; We come here if floppy error.                      ;
;====================================================;
@@:
	mov   byte[ErrorCode],1
	pop   ecx
	jmp   DirFatError
DoAnotherLoopRootUpdate:
	pop   ecx
	loop  UpdateRootDirLoop

GoodThatWorked:
	ret

DirFatError:
	stc
	ret 

;====================================================;
; AmountFreeSpace.                                   ;
;====================================================;
AmountFreeSpace:
	pushad
	mov   [MaxClusters],1534
	mov   esi,BpbFat12
	add   esi,515
	mov   [AmountFreeSpaceCount],0
	mov   cx,[MaxClusters]					      
AmountFreeSpaceLoop:
	lodsw
	and   ax,0x0FFF
	jz    @f
	inc   [AmountFreeSpaceCount] 
@@:
	dec   esi
	lodsw
	shr   ax,4
	or    ax,ax
	jz    @f
	inc   [AmountFreeSpaceCount]
@@:	   
	loop  AmountFreeSpaceLoop
	popad
	ret

;====================================================;
; UpdateClusterValue.                                ;
;====================================================;
UpdateClusterValue:
	pushad
	mov   word[Cluster],ax
	mov   word[UpdateValue],bx
	xor   ecx,ecx
	mov   cx,ax					
	mov   dx,ax					
	shr   dx,0x0001 				
	add   cx,dx					
	mov   esi,BpbFat12				
	add   esi,512	
	add   esi,ecx 
	mov   dx,word [ds:esi]
	;mov   [ClustOrigValue ],dx
	test  ax,0x0001
	jnz   OddUpdateClusterValue	     
EvenUpdateClusterValue:
	mov   bx,dx
	and   bx,0000111111111111b
	mov   [ClustOrigValue ],bx  
	and   dx,1111000000000000b
	mov   bx,word[UpdateValue]
	and   bx,0000111111111111b
	add   dx,bx
	mov   word [ds:esi],dx			 
	jmp   DoneUpdateClusterValue
OddUpdateClusterValue:
	mov   bx,dx
	shr   bx,4
	mov   [ClustOrigValue ],bx 
	and   dx,0000000000001111b
	mov   bx,word[UpdateValue]
	shl   bx,4
	add   dx,bx
	mov   word [ds:esi],dx 
DoneUpdateClusterValue:
	popad			     
	ret

;====================================================;
; FindNextFreeRootEntry                              ;
;====================================================;
FindNextFreeRootEntry:
	pushad
	push  es
	mov   ax,18h				   
	mov   es,ax
	mov   edi,[RootDirBufferVar]
	mov   dx,[bpbRootEntries]
	cmp   [RootYesNoA],0
	je    FindNextFreeRootEntryLoop
	mov   dx,[FolderEntrysNumberFdd]
 ;----------------------------------------------------;
 ; FindNextFreeRootEntryLoop.                         ;
 ;----------------------------------------------------;
FindNextFreeRootEntryLoop:
	cmp   byte[es:edi],byte 0
	je    FoundSpaceInRootdir  
	cmp   byte[es:edi],0xe5
	je    FoundSpaceInRootdir
	add   edi, 32
	dec   dx
	jnz   FindNextFreeRootEntryLoop
	jmp   FindNextFreeRootEntryError
FoundSpaceInRootdir:
	mov   dword[RootDirEntryAddress],edi
FindNextFreeRootEntrySucsess:
	pop   es
	popad
	clc
	ret	    

FindNextFreeRootEntryError: 
	mov   [ErrorCode],3	  
	pop   es
	popad
	stc
	ret		      

;====================================================;
; FillOutRootEntry.                                  ;
;====================================================;
FillOutRootEntry:
       pushad
       push  es
       push  ds
       mov   ax,18h 
       mov   ds,ax			       
       mov   es,ax
       mov   edi,[RootDirEntryAddress]
       mov   esi,FileEntry
       mov   ecx,8
       rep   movsd
       pop   ds
       pop   es
       popad
       ret

;====================================================;
; MakeNewFile                                        ;
;====================================================;
MakeNewFile:
	pushad
	push  es
	push  ds
	call  FindFileName
	jnc   CheckForSameNameFound
 ;----------------------------------------------------;
 ; CheckForSameNameNotFound.                          ;
 ;----------------------------------------------------;                           
CheckForSameNameNotFound:
	mov   edi,FileEntry
	mov   esi,NameOfFileToLoadBuffer
	mov   ecx,11
	rep   movsb
 ;----------------------------------------------------;
 ; GetNextCluster.                                    ;
 ;----------------------------------------------------;   
	call  GetNextCluster
	jc    CheckForSameNameFound
 ;----------------------------------------------------;
 ; FileCluster.                                       ;
 ;----------------------------------------------------; 
	mov   edi,FileCluster
	mov   ax,[ClusterCount]
	mov   word [StartCluster],ax
	stosw
	mov   edi,FileAttr
	mov   al,[FileAttrFdd]
	stosb
 ;----------------------------------------------------;
 ; FileSize.                                          ;
 ;----------------------------------------------------; 
	mov   edi,FileSize
	mov   eax,dword[FileSizeInBytes]
	stosd
 ;----------------------------------------------------;
 ; FileTime.                                          ;
 ;----------------------------------------------------; 
	call  FloppyTime
	mov   ax,[FddTime]
	mov   edi,FileTime
	stosw
 ;----------------------------------------------------;
 ; FileDate.                                          ;
 ;----------------------------------------------------;
	call  FloppyDate
	mov   ax,[FddDate]
	mov   edi,FileDate
	stosw
 ;----------------------------------------------------;
 ; End.                                               ;
 ;----------------------------------------------------;
	pop   ds
	pop   es
	popad
	clc
	ret

 ;----------------------------------------------------;
 ; Error CheckForSameName Founded                     ;
 ;----------------------------------------------------;   
CheckForSameNameFound:
	pop   ds
	pop   es
	popad
	mov   [ErrorCode],0x04
	stc
	ret

;====================================================;
; WriteSectors.                                      ;
;====================================================;
WriteSectors:
	pushad
	push  es
	push  ds
	mov   [FileLoadCountUP],0
	mov   ax,word [StartCluster]
	mov   word[ClusterCount],ax
	mov   ax,18h 
	mov   ds,ax				
	mov   es,ax
	xor   ecx, ecx					
	mov   ax,[bpbRootEntries]			
	mov   cx, 32					
	mul   cx					
	div   word [bpbBytesPerSector]			
	mov   [RootSizeWrite],ax			
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	xor   ax,ax			
	mov   al, byte [bpbNumberOfFATs]		
	mul   word [bpbSectorsPerFAT]			
	add   ax, word [bpbReservedSectors]		
	mov   [RootStartWrite],ax			     
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSizeWrite]			   
	add   ax,cx					
	mov   [DataStartWrite],ax		    
 ;----------------------------------------------------;
 ; WriteSectors.                                      ;
 ;----------------------------------------------------;
WriteSectorsLoop:
	mov   ax,[ClusterCount] 			     
	mov   [FloppyTest],0				
ReadNextClusterWriteSectors:
	call  ClusterLBAWrite 
	call  WriteSectorsUP
	jc    WriteSectorsError
 ;----------------------------------------------------;
 ; compute next cluster.                              ;
 ;----------------------------------------------------;
	mov   ax,word[ClusterCount]			      
	mov   cx,ax					
	mov   dx,ax					
	shr   dx,0x0001 				
	add   cx,dx					
	mov   esi,BpbFat12				
	add   esi,512	
	add   esi,ecx					
	mov   dx,word [ds:esi]				
	test  ax,0x0001
	jnz   OddClusterWriteSectors	      
EvenClusterWriteSectors: 
	and   dx,0000111111111111b			
	jmp   DoneWriteSectors
OddClusterWriteSectors:
	shr   dx,0x0004 				
DoneWriteSectors:
	mov   word [ClusterCount],dx			     
	cmp   dx,0x0FF0 				
	jb    WriteSectorsLoop
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
ExitWriteSectorsSucsess:
	pop   ds
	pop   es
	popad
	clc
	ret
	
 ;----------------------------------------------------;
 ; ErrorFind.                                         ;
 ;----------------------------------------------------;        
WriteSectorsError:
	pop   ds
	pop   es
	popad
	stc
	ret

;====================================================;
; ClusterLBAWrite                                    ;
;====================================================;
ClusterLBAWrite:
	sub   ax,2					
	xor   cx,cx					
	mov   cl,byte [bpbSectorsPerCluster]		
	mul   cx					
	add   ax, word [DataStartWrite] 	       
	ret	     

;====================================================;
; WriteSectorsUP                                     ;
;====================================================;
WriteSectorsUP:
	pushad
	push  ds
	push  es
	call  LBAcHsWrite
 ;----------------------------------------------------;
 ; Move more data to Dma buffer.                      ;
 ;----------------------------------------------------;  
	pushad
	mov   ecx,512
	mov   ax,18h  
	mov   ds,ax
	mov   es,ax  
	mov   edi,OffsetDma2Buffer1
	mov   esi,[LoadFileFromAddress]       
	add   esi,[FileLoadCountUP]  
	rep   movsb
	add   [FileLoadCountUP],512 
	add   [FddSectorsWriteCount],1
	popad
	mov   [FddErrCount],0
TryWriteFloppyAgain: 
	mov   ch,byte [absoluteTrackUP] 		  
	mov   cl,byte [absoluteSectorUP]		  
	mov   dh,byte [absoluteHeadUP]			  
	mov   dl,byte [bsDriveNumber]  
	call  [FddWrite]
	jnc   FloppyWriteOK
	inc   [FddErrCount]
	cmp   [FddErrCount],4
	je    @f
	pushad
	call  FddRecalibrate
	popad
	jmp   TryWriteFloppyAgain
FloppyWriteOK:
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
	pop   es
	pop   ds
	popad
	clc
	ret 
 ;----------------------------------------------------;
 ; Error.                                             ;
 ;----------------------------------------------------;
@@:
	mov   word[RealModeErrorCode],ax
	pop   es
	pop   ds
	popad
	mov  ax,word[RealModeErrorCode]
	stc
	ret 

;====================================================;
; LBAcHsWrite.                                       ;
;====================================================;
LBAcHsWrite:
	xor   dx,dx					
	div   word [bpbSectorsPerTrack] 		
	inc   dl					
	mov   byte [absoluteSectorUP],dl
	xor   dx,dx					
	div   word [bpbHeadsPerCylinder]		
	mov   byte [absoluteHeadUP],dl
	mov   byte [absoluteTrackUP],al
	ret

;====================================================;
; FloppyDate.                                        ;
;====================================================;
GetFileSizeInSectors:
	pushad
	push  es
	push  ds
	push  eax
	mov   ax,18h 
	mov   ds,ax				
	mov   es,ax
	pop   eax
	xor   edx,edx
	mov   dword[FileSizeInSectors],eax
	cmp   dword[FileSizeInSectors],511
	ja    @f
	mov   [FileSizeInSectors],1
	jmp   ExitFileSizeInSectors
@@:
 ;----------------------------------------------------;
 ; Div by 512.                                        ;
 ;----------------------------------------------------;
	mov   eax,dword[FileSizeInSectors]
	mov   ecx,512  
	div   ecx
	mov   dword[FileSizeInSectors],eax
	cmp   edx,0
	je    ExitFileSizeInSectors
	add   dword[FileSizeInSectors],1
 ;----------------------------------------------------;
 ; Exit.                                              ;
 ;----------------------------------------------------;        
ExitFileSizeInSectors:
	pop   ds
	pop   es
	popad
	ret


;====================================================;
; UsedSectorsFddWrite.                               ;
;====================================================;
UsedSectorsFddWrite:
	pushad
	push  es
	push  ds
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	mov   esi,BpbFat12
	add   esi,515
	mov   [FreeSectors],0
	mov   [UsedSectorCountFW],0
	mov   ecx,1534
UsedSectorsLoopFW:
	lodsw
	and   ax,0x0FFF
	jz    @f
	inc   [UsedSectorCountFW] 
@@:
	dec   esi
	lodsw
	shr   ax,4
	or    ax,ax
	jz    @f
	inc   [UsedSectorCountFW]
@@:	   
	loop  UsedSectorsLoopFW
	xor   eax,eax
	mov   ax,[bpbTotalSectors]
	sub   ax,33
	sub   ax,[UsedSectorCountFW]
	mov   word[FreeSectors],ax
	pop   ds
	pop   es
	popad
	ret
;3
 ;----------------------------------------------------;
 ; FloppyfolderLoad.                                  ;
 ;----------------------------------------------------;
FloppyfolderLoad:
	call  FloppyfolderLoad2
	jc    FloppyfolderLoadN
	mov   [FolderSizeSectorsFdd],ebx
	push  dx
	mov   dx,[FirstFolderClusterfdd]
	mov   [FirstFolderClusterAfdd],dx
	pop   dx
FloppyfolderLoadY:
	clc
	ret

FloppyfolderLoadN:
	stc
	ret
 ;----------------------------------------------------;
 ; FloppyfolderLoad2.                                 ;
 ;----------------------------------------------------;
FloppyfolderLoad2:
	pushad				  
	push  es
	push  ds
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	mov   [FirstFolderClusterfdd],0
	mov   [FddSectorsLoadedCount],0 		
	mov   dword[LoadFileToAddress],edi
	mov   dword[NameOfFileToLoad],esi
	mov   ax,sys_data				
	mov   es,ax
	call  ConevertFolderName
	mov   edi,NameOfFileToLoadBuffer
	call  UpperCase
	mov   [FileLoadCountUP],0			
	call  DirFillRootUSB				     
	jc    ErrorFloppyUP 
	xor   ecx,ecx				       
	mov   ax,[bpbRootEntries]			
	mov   cx, 32					
	mul   cx					
	div   word [bpbBytesPerSector]			
	mov   [RootSizeUP],ax				
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	xor   eax,eax			
	mov   al, byte [bpbNumberOfFATs]		
	mul   word [bpbSectorsPerFAT]			
	add   ax, word [bpbReservedSectors]		
	mov   [RootStartUP],ax				  
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSizeUP]				
	add   ax,cx					
	mov   [DataStartUP],ax				
	mov   ax,sys_data				
	mov   es,ax
	mov   ds,ax
	mov   edi,[RootDirBufferVar] 
	mov   esi,NameOfFileToLoadBuffer 
	mov   dx,[bpbRootEntries]
 ;----------------------------------------------------;
 ; FindFolderName.                                    ;
 ;----------------------------------------------------;
	mov   ecx,11 ;8
	jmp   FindNameCycleFLUP
 ;----------------------------------------------------;
 ; Jump into FloppyfileLoad code.                     ;
 ;----------------------------------------------------;
crig rb 50
 ;----------------------------------------------------;
 ; FloppyfileLoad.                                    ;
 ;----------------------------------------------------;
FloppyfileLoad:
	pushad				  
	push  es
	push  ds

	mov   [FirstFolderClusterfdd],0
	mov   [FileReadBytesFdd],0
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	cmp   [RootYesNoA],0
	je    @f
	mov   [RootDirBufferVar],0x100000
@@:

	mov   [FddSectorsLoadedCount],0
	mov   dword[LoadFileToAddress],edi
	mov   dword[NameOfFileToLoad],esi
	mov   ax,18h
	mov   es,ax
	call  ConevertFileName
	mov   edi,NameOfFileToLoadBuffer
	call  UpperCase

	mov   [FileLoadCountUP],0			
	call  DirFillRootUSB				     
	jc    ErrorFloppyUP
	cmp   [FddChangeYesNo],1
	jne   FddChangeOk
	cmp   [RootYesNoA],0
	je    FddChangeOk
	push  eax
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	pop   eax
	mov   [RootYesNoA],0
FddChangeOk:

	xor   ecx,ecx
	mov   ax,[bpbRootEntries]			
	mov   cx, 32					
	mul   cx					
	div   word [bpbBytesPerSector]			
	mov   [RootSizeUP],ax				
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	xor   eax,eax			
	mov   al, byte [bpbNumberOfFATs]		
	mul   word [bpbSectorsPerFAT]			
	add   ax, word [bpbReservedSectors]		
	mov   [RootStartUP],ax				  
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSizeUP]				
	add   ax,cx					
	mov   [DataStartUP],ax				
	mov   ax,sys_data				
	mov   es,ax
	mov   ds,ax
	mov   edi,[RootDirBufferVar] 
	mov   esi,NameOfFileToLoadBuffer 
	;add   esi,4
	mov   dx,[bpbRootEntries]

 ;----------------------------------------------------;
 ; FindName.                                          ;
 ;----------------------------------------------------;
FindNameUP:
	mov   ecx,11
FindNameCycleFLUP:
	cmp   byte [es:edi],ch
	je    FindNameFailedFLUP			   
	pushad					       
	repe  cmpsb
	popad					       
	je    FindNameFoundFLUP
	add   edi, 32
	dec   dx
	jnz   FindNameCycleFLUP 			   
FindNameFailedFLUP:
	jmp   ErrorFindUP
FindNameFoundFLUP:
	mov   dx,word[es:edi+1Ah]		       
	mov   word [clusterUP],dx
	mov   [FirstFolderClusterfdd],dx
	mov   eax,dword[es:edi+1Ch]
	mov   [FileReadBytesFdd],eax
	xor   eax,eax
	mov   ax,word [bpbSectorsPerFAT]
	shl   eax,9
	shr   eax,1
	cmp   eax,4086
	jae   LoadImageFat16UP
 ;----------------------------------------------------;
 ; Load entire a program.                             ;
 ;----------------------------------------------------;
LoadImageUP:
	mov   ax,[clusterUP]				  
	mov   [FloppyTest],0				
ReadNextClusterUP:
	call  ClusterLBAUP
	call  ReadSectorsUP
	jc    ErrorFloppyUP
 ;----------------------------------------------------;
 ; compute next cluster.                              ;
 ;----------------------------------------------------;
	mov   ax,word[clusterUP]			
	mov   cx,ax					
	mov   dx,ax					
	shr   dx,0x0001 				
	add   cx,dx					
	mov   esi,BpbFat12				
	add   esi,512	
	add   esi,ecx					
	mov   dx,word [ds:esi]				
	test  ax,0x0001
	jnz   OddClusterUP	    
EvenClusterUP: 
	and   dx,0000111111111111b			
	jmp   DoneUP
OddClusterUP:
	shr   dx,0x0004 				
DoneUP:
	mov   word [clusterUP],dx			  
	cmp   dx,0x0FF0 				
	jb    LoadImageUP
	jmp   ExitSucsessUP
 ;----------------------------------------------------;
 ; Fat16.                                             ;
 ;----------------------------------------------------;
LoadImageFat16UP:
	mov   ax,[clusterUP]
	mov   [FloppyTest],0
ReadNextClusterFat16UP:
	call  ClusterLBAUP
	mov   [clusterSPCUP],ax
	xor   ecx,ecx
	mov   cl,byte [bpbSectorsPerCluster]
ReadNextClusterFat16loopUP:
	push  ecx
	mov   [FloppyTest],0
	call  ReadSectorsUP
	jc    ErrorFloppyPopUP
	inc   [clusterSPCUP]
	mov   ax,[clusterSPCUP]
	pop   ecx
	loop  ReadNextClusterFat16loopUP
 ;----------------------------------------------------;
 ; compute next cluster.                              ;
 ;----------------------------------------------------;
	xor   eax,eax
	xor   ecx,ecx
	mov   ax,word[clusterUP]
	mov   cx,ax
	add   ecx,eax
	mov   esi,Fat
	add   esi,ecx
	mov   dx,word [ds:esi]
	mov   word [clusterUP],dx
	cmp   dx,0xFFF0
	jb    LoadImageFat16UP
	
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
ExitSucsessUP:
	call  Fdd_motor_off
	mov   [ErrorCode],0
	pop   ds
	pop   es
	popad
	mov   ebx,dword[FddSectorsLoadedCount]
	mov   ecx,[FileReadBytesFdd]
	mov   ah,0
	clc
	ret 
 ;----------------------------------------------------;
 ; ErrorFind.                                         ;
 ;----------------------------------------------------;  
ErrorFloppyPopUP:
	pop   ecx      
ErrorFindUP:
	call  Fdd_motor_off
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCode]
	mov   [USBcount],0
	stc
	ret
 ;----------------------------------------------------;
 ; ErrorFloppy.                                       ;
 ;----------------------------------------------------;  
ErrorFloppyUP:
	call  Fdd_motor_off
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCode]
	mov   [USBcount],0
	stc
	ret

 ;----------------------------------------------------;
 ; ReadSectors.                                       ;
 ;----------------------------------------------------;
ReadSectorsUP:
	pushad
	push  es
	push  ds
	call  LBAcHsUP
	mov   [FddErrCount],0
TryReadFloppyAgainUP: 
	mov   ch,byte [absoluteTrackUP]
	mov   cl,byte [absoluteSectorUP]		  
	mov   dh,byte [absoluteHeadUP]			  
	mov   dl,byte [bsDriveNumber]
	call  [FddRead]
	jnc   FloppyReadOKUP
	inc   [FddErrCount]
	cmp   [FddErrCount],4
	je    @f
	pushad
	call  FddRecalibrate
	popad
	jmp   TryReadFloppyAgainUP
FloppyReadOKUP:
	mov   cx,512	    
	mov   ax,sys_data  
	mov   ds,ax
	mov   es,ax  
	mov   esi,OffsetDma2Buffer
	mov   edi,[LoadFileToAddress]	    
	add   edi,[FileLoadCountUP]  
	rep   movsb
	add   [FileLoadCountUP],512
	add   [FddSectorsLoadedCount],1
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
	pop   ds
	pop   es
	popad
	clc
	ret 
 ;----------------------------------------------------;
 ; Error.                                             ;
 ;----------------------------------------------------;
@@:
	mov   [RealModeErrorCode],ax
	pop   ds
	pop   es
	popad
	mov   ax,[RealModeErrorCode]
	stc
	ret 
       
 ;----------------------------------------------------;
 ; LBAcHs.                                            ;
 ;----------------------------------------------------;

LBAcHsUP:
	;xor   dx,dx                                     
	div   word [bpbSectorsPerTrack] 		
	inc   dl					
	mov   byte [absoluteSectorUP],dl
	xor   dx,dx					
	div   word [bpbHeadsPerCylinder]		
	mov   byte [absoluteHeadUP],dl
	mov   byte [absoluteTrackUP],al
	ret

 ;----------------------------------------------------;
 ; ClusterLBA.                                        ;
 ;----------------------------------------------------;

ClusterLBAUP:
	sub   ax,2					
	xor   cx,cx					
	mov   cl,byte [bpbSectorsPerCluster]		
	mul   cx					
	add   ax, word [DataStartUP]		       
	ret	

 ;----------------------------------------------------;
 ; ConevertFileName.                                  ;
 ;----------------------------------------------------;
ConevertFileName:
	pushad

	mov   esi,[NameOfFileToLoad]
	mov   edi,NameOfFileToLoadBuffer
	mov   ecx,8

ConvertCliFileNameU:
	cmp   byte [ds:esi],'.'
	je    @f
	cld
	movsb 
	dec   ecx
	jnz  ConvertCliFileNameU
	jmp   FinConertCliFnameU
@@:

	mov   al,0x20
	cld
	rep   stosb
FinConertCliFnameU:

	cmp   byte [ds:esi],'.'
	jne   @f
	inc   esi
@@:

	mov   ecx,3
	cld
	rep   movsb
	mov   al,0
	stosb


	popad
	ret					

 ;----------------------------------------------------;
 ; ConevertFolderName.                                ;
 ;----------------------------------------------------;
ConevertFolderName:
	pushad	 
	mov   esi,[NameOfFileToLoad]
	mov   edi,NameOfFileToLoadBuffer
	mov   ecx,11 ;8
ConvertCliFolderNameU:
	cmp   byte [ds:esi],0
	je    @f
	cld
	movsb 
	dec   cx
	jnz  ConvertCliFolderNameU
@@:
	cld
	movsb 
	popad
	ret


;4
;====================================================;
; FILL BPB & FAT,INTO MEMORY.                        ;
;====================================================;

DirCommand:
	call  DirFillRootUSB 
	jc    DirCommandError
	mov   [DirBufferA],RootDirBuffer  
	call  DirPrintFileNS
	mov   [ErrorCode],0
	mov   ah,0
	clc
	ret
DirCommandError:
	mov   ah,byte[ErrorCode]
	stc
	ret

DirFolderCommand:
	mov   [DirBufferA],0x100000
	call  DirFillRootUSB
	jc    DirFolderError
	cmp   [FddChangeYesNo],0
	je    @f
	mov   [DirBufferA],RootDirBuffer
@@:
	call  DirPrintFileNS
	mov   [ErrorCode],0
	mov   ah,0
	clc
	ret
DirFolderError:
	mov   ah,byte[ErrorCode]
	stc
	ret

;====================================================;
; DirCommandGui.                                     ;
;====================================================;
DirCommandGui:
	pushad
	push  es
	push  ds
	mov   word[FileExt1],0
	mov   word[FileExt2],0
	mov   word[FileExt3],0
	mov   word[FileExt],ax
	cmp   word[FileExt],0
	je    @f
	shr   eax,16
	mov   word[FileExt1],ax
	mov   word[FileExt2],cx
	shr   ecx,16
	mov   word[FileExt3],cx
@@:
	call  DirFillRootUSB	
	jc    DirCommandErrorGui
	call  DirPrintFileGui
	mov   [ErrorCode],0
	pop   ds
	pop   es
	popad
	mov   ah,0
	mov   esi,Fdd_FilesForMenu
	mov   edi,FddFilesForMenu
	mov   ebx,[FileNumberCount]
	call  Fdd_motor_off
	clc
	ret
DirCommandErrorGui:
	pop   ds
	pop   es
	popad
	mov   ah,byte[ErrorCode]
	call  Fdd_motor_off
	stc
	ret

;====================================================;
; DirFillRootUSB.                                    ;
;====================================================;
DirFillRootUSB:
	pushad
	mov   [FddChangeYesNo],0
	call  Changed
	jnc   Test4FirstTime
       ; cmp   ah,0xab
       ; je    DirFillRootUSBgo
	cmp   ah,80h
	je    DirErrorUSB
	cmp   ah,00
	je    Test4FirstTime
	cmp   ah,0x06
	jne   DirFillRootUSBgo
	mov   [RootYesNoA],0
	mov   [FddChangeYesNo],1
	jmp   DirFillRootUSBgo
Test4FirstTime:
	cmp   [USBcount],1
	je    DirFillRootUSBSuccsess
DirFillRootUSBgo:
	call  FddReSet
	call  FddRecalibrate
ReadSectorRetryUSB:
	call  TestFloppy
	jc   DirErrorUSB
DirFillRootFddUSB:
	mov   ax,word[bpbHiddenSectors]
	mov   dx,word[bpbHiddenSectors+2]
	add   ax,word [bpbReservedSectors]
	mov   [FatStartDxUSB],dx
	mov   [FatStartUSB],ax
	xor   eax,eax
	mov   ecx,eax			
	mov   al, byte [bpbNumberOfFATs]		
	mul   word [bpbSectorsPerFAT]  
	mov   [FatSize2USB],ax
	xor   eax,eax	
	mov   ax,word [bpbSectorsPerFAT]
	mov   [FatSize1USB],ax
	mov   ax,[bpbRootEntries]			
	mov   cx, 32					
	mul   cx					
	div   word [bpbBytesPerSector]			
	mov   [RootSizeUSB],ax				
 ;----------------------------------------------------;
 ; Root Dir Location - Reserved sectors + Fat sectors ;
 ;----------------------------------------------------;
	xor   eax,eax
	mov   edx,eax			
	mov   al, byte [bpbNumberOfFATs]		
	mul   word [bpbSectorsPerFAT]			
	add   ax, word [bpbReservedSectors] 
	mov   [RootStartDxUSB],dx	     
	mov   [RootStartUSB],ax 			   
 ;----------------------------------------------------;
 ; Data start Reserved sectors + FAT sectors + Root   ;
 ;----------------------------------------------------;
	mov   cx,[RootSizeUSB]				 
	add   ax,cx					
	mov   [DataStartUSB],ax  
	mov   [FloppyTestUSB],0
	mov   [FileLoadCountUSB],0
	mov   [USBSectorsLoadedCount],0
	mov   edi,Fat
	mov   [LoadFileToAddressUSB],edi 
	xor   eax,eax
	mov   ecx,eax
	mov   dx,[FatStartDxUSB]
	mov   ax,[FatStartUSB] 
	mov   cx,[FatSize1USB]
ReadSectorsLoopUSB1:
	mov   [FloppyTestUSB],0
	call  ReadSectorsUSB
	jc    DirErrorUSB  
	inc   ax
	loop  ReadSectorsLoopUSB1
	mov   [FloppyTestUSB],0
	mov   [FileLoadCountUSB],0
	mov   [USBSectorsLoadedCount],0
	mov   edi,RootDirBuffer
	mov   [LoadFileToAddressUSB],edi 
	xor   eax,eax
	mov   dx,[RootStartDxUSB]
	mov   ax,[RootStartUSB] 
	mov   cx,[RootSizeUSB]	;14
ReadSectorsLoopUSB2:
	mov   [FloppyTestUSB],0
	call  ReadSectorsUSB
	jc    DirErrorUSB 
	inc   ax
	loop  ReadSectorsLoopUSB2
	xor   eax,eax
	mov   [USBcount],0
	mov   ax,word [bpbSectorsPerFAT]
	shl   eax,9
	shr   eax,1
	cmp   eax,4086
	jb    DirFillRootUSBSuccsess
DirFillRootUSBSuccsess:
	mov   [USBcount],1
	popad
	clc
	ret 

DirErrorUSB:
	popad
	stc
	ret

;====================================================;
; DirPrintFileNS.                                    ;
;====================================================;
DirPrintFileNS:
	mov   esi,nextline
	call  print_string
	call  PrintDirA 
	mov   [RdirFileCount],0
	mov   ax,sys_data 
	mov   es,ax  
	mov   ds,ax 
FileNamePrintLoop: 
	mov   esi,[DirBufferA]
	add   esi,[RdirFileCount]
	add   [RdirFileCount],32
	cmp   byte [ds:esi],0xe5
	je    FileNamePrintLoop
	cmp   byte [ds:esi],0x00
	je    DirSuccsess
	mov   edi,DirEntry
	mov   ecx,32
	rep   movsb
	cmp   word[dirCluster],0x0000
	je    FileNamePrintLoop
	cmp   word[dirAttr],0x00
	je    FileDirOkToPrint
	cmp   word[dirAttr],0x10
	je    FileDirOkToPrint
	cmp   word[dirAttr],0x01
	je    FileDirOkToPrint
	cmp   word[dirAttr],0x20
	je    FileDirOkToPrint
	jmp   FileNamePrintLoop
;====================================================;
; Print file/dir name.                               ;
;====================================================;
FileDirOkToPrint:
	mov   esi,DirEntry
	mov   ecx,8
;====================================================;
; Set font color.                         ;0x05 =RED ;
;====================================================;  
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x02
FilePrintLoop:
	lodsb
	call  print_char
	loop  FilePrintLoop
	mov   [textcolor],0x03	     
	mov   al,0x20
	call  print_char
;====================================================;
; Print file exten.                                  ;
;====================================================;
	mov   esi,dirExten
	mov   ecx,3
FileExtenPrintLoop:
	lodsb
	call  print_char
	loop  FileExtenPrintLoop
	mov   al,[textcolorsave]
	mov   [textcolor],al
	test  byte[dirAttr],0x10
	jz    @f
	mov   esi,LabelDir
	call  print_string
	jmp   FileNamePrintLoop
@@:
;====================================================;
; Print files size in bytes.                         ;
;====================================================;
	mov   esi,dirSize
	add   esi,2
	lodsw
	shl   eax,16
	mov   esi,dirSize
	lodsw
	mov   [hex_val],eax
	call  testhex
	mov   esi,SpaceDir		 
	call  print_string
	mov   esi,numbuff2		 
	call  print_string
	mov   esi,nextline
	call  print_string
	jmp   FileNamePrintLoop
DirSuccsess:
	clc
	ret

DirError:
	stc
	ret 

;====================================================;
; Used sectors.                                      ;
;====================================================;
UsedSectors:
	mov   esi,BpbFat12
	add   esi,515
	mov   [UsedSectorCount],0
	mov   cx,1534					      
UsedSectorsLoop:
	lodsw
	and   ax,0x0FFF
	jz    @f
	inc   [UsedSectorCount] 
@@:
	dec   esi
	lodsw
	shr   ax,4
	or    ax,ax
	jz    @f
	inc   [UsedSectorCount]
@@:	   
	loop  UsedSectorsLoop
;====================================================;
; deplay bar graph.                                  ;
;====================================================;
	mov   esi,nextline
	call  print_string
	call  PrintUsedBar
	mov   [screen_x],0 
	xor   eax,eax
	mov   ax,[UsedSectorCount]
	shl   eax,9
	mov   [UsedSectorBytes],eax
BlockLOOP:
	cmp   eax,0
	je    @f
	call  PrintUsedBlock
	cmp   eax,91104
	jbe   @f
	sub   eax,91104
	jmp   BlockLOOP 
@@:
;====================================================;
; Print free bytes.                                  ;
;====================================================;
	mov   [screen_x],20  
	mov   esi,nextline
	call  print_string  
	xor   eax,eax
	mov   ax,[bpbTotalSectors]
	sub   ax,33
	sub   ax,[UsedSectorCount]
	shl   eax,9
	mov   [hex_val],eax
	call  testhex
	mov   esi,nextline
	call  print_string
	call  Printfreeblock 
	mov   esi,numbuff2		 
	call  print_string
	mov   esi,DriveFspace		    
	call  print_string
	mov   esi,nextline
	call  print_string
;====================================================;
; Print used bytes.                                  ;
;====================================================;
	call PrintUsedBlock
	mov   eax,[UsedSectorBytes]
	mov   [hex_val],eax
	call  testhex
	mov   esi,numbuff2		 
	call  print_string
	mov   esi,DriveUsed		  
	call  print_string
;====================================================;
; Print drive capacity.                              ;
;====================================================;
	xor   eax,eax
	mov   ax,[bpbTotalSectors]
	sub   ax,33
	shl   eax,9
	mov   [hex_val],eax
	call  testhex
	mov   esi,nextline
	call  print_string
	mov   al,0x20
	call  print_char
	mov   esi,numbuff2		 
	call  print_string
	mov   esi,DriveCap		 
	call  print_string
	ret

;====================================================;
; PrintDirA.                                         ;
;====================================================;
PrintDirA:
	pushad
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x09
	mov   esi,DirA
	call  print_string
	cmp   [RootYesNoA],0  
	je    @f
	mov   esi,FolderNameA
	call  print_string
@@:	 
	mov   esi,nextline
	call  print_string
	mov   esi,nextline
	call  print_string		 
	mov   al,[textcolorsave]
	mov   [textcolor],al
	popad
	ret

;====================================================;
; PrintUsedBar.                                      ;
;====================================================;
PrintUsedBar:
	pushad
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x09
	mov   esi,DriveFbar
	call  print_string
	mov   al,[textcolorsave]
	mov   [textcolor],al
	popad
	ret

;====================================================;
; PrintUsedBlock.                                    ;
;====================================================;
PrintUsedBlock:
	pushad
	mov   al,177
	call  print_char
	popad
	ret

;====================================================;
; Printfreeblock.                                    ;
;====================================================;
Printfreeblock:
	pushad
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x09
	mov   al,177
	call  print_char
	mov   al,[textcolorsave]
	mov   [textcolor],al
	popad
	ret

;====================================================;
; DirPrintFileGui.                                   ;
;====================================================;
DirPrintFileGui:
	mov   [RdirFileCount],0
	mov   [FddFileListCount],0
	mov   [Fdd_FileListCount],0
	mov   [FileNumberCount],0
	mov   ax,sys_data 
	mov   es,ax  
	mov   ds,ax 
	mov   edi,FddFilesForMenu 
	mov   ecx,630
	mov   al,0
	rep   stosb
	mov   eax,RootDirBuffer
	mov   [RootDirBufferVar],eax
	cmp   [RootYesNoA],0
	je    @f
	mov   [RootDirBufferVar],0x100000
@@: 
FileNamePrintLoopGui:
	mov   esi,[RootDirBufferVar]
	add   esi,[RdirFileCount]
	add   [RdirFileCount],32
	cmp   byte [ds:esi],0xe5
	je    FileNamePrintLoopGui
	cmp   byte [ds:esi],0x00
	je    DirSuccsessGui
	mov   edi,DirEntry
	mov   ecx,32
	rep   movsb
	cmp   word[dirCluster],0x0000
	je    FileNamePrintLoopGui
	mov   cx,word[FileExt]
	cmp   cx,0
	je    @f
	cmp   word[dirExten],cx ;'GE'
	je    @f
	mov   cx,[FileExt1]
	cmp   word[dirExten],cx
	je    @f
	mov   cx,[FileExt2]
	cmp   word[dirExten],cx
	je    @f
	mov   cx,[FileExt3]
	cmp   word[dirExten],cx
	jne   FileNamePrintLoopGui
@@:
;====================================================;
; Print file/dir name.                               ;
;====================================================;   
	inc   [FileNumberCount] 
	mov   esi,DirEntry
	mov   ecx,8
	push  edi
	mov   edi,FddFilesForMenu
	add   edi,[FddFileListCount]
	rep movsb
;====================================================;
; Print file exten.                                  ;
;====================================================;
	mov   esi,dirExten
	mov   ecx,3
	rep   movsb
	mov   al,0
	stosb
	add   [FddFileListCount],12
	mov   esi,DirEntry
	mov   cx,8
	mov   edi,Fdd_FilesForMenu
	add   edi,[Fdd_FileListCount]
	rep movsb
	add   [Fdd_FileListCount],9
	mov   al,0
	stosb
	pop   edi
	cmp   [FileNumberCount],20
	jae    DirSuccsessGui  
	jmp   FileNamePrintLoopGui
DirSuccsessGui:
	clc
	ret
DirErrorGui:
	stc
	ret 

 ;----------------------------------------------------;
 ; ReadSectorsUSB.                                    ;
 ;----------------------------------------------------;
ReadSectorsUSB:
	pushad
	push  es
	push  ds
	call  LBAcHsUSB
	mov   [FddErrCount],0
TryReadFloppyAgainUSB: 
	mov   ch,byte [absoluteTrackUSB]		   
	mov   cl,byte [absoluteSectorUSB]		   
	mov   dh,byte [absoluteHeadUSB] 		   
	mov   dl,byte [bsDriveNumber]
	call  [FddRead]
	jnc   FloppyReadOkUSB
	inc   [FddErrCount]
	cmp   [FddErrCount],4
	je    @f
	pushad
	call  FddRecalibrate
	popad
	jmp   TryReadFloppyAgainUSB
 ;----------------------------------------------------;
 ; Move data from DMA buffer, to image address.       ;
 ;----------------------------------------------------;
FloppyReadOkUSB:
	mov   ecx,512
	mov   ax,sys_data  
	mov   ds,ax
	mov   es,ax  
	mov   esi,OffsetDma2Buffer
	mov   edi,[LoadFileToAddressUSB]       
	add   edi,[FileLoadCountUSB]  
	rep   movsb
	mov   byte[es:edi],0
	add   [FileLoadCountUSB],512
	add   [USBSectorsLoadedCount],1 		
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
	pop   ds
	pop   es
	popad
	clc
	ret 
 ;----------------------------------------------------;
 ; Error.                                             ;
 ;----------------------------------------------------;
@@:	mov   [RealModeErrorCode],ax
	pop   ds
	pop   es
	popad
	mov   ax,[RealModeErrorCode]
	stc
	ret 
       
 ;----------------------------------------------------;
 ; LBAcHs.                                            ;
 ;----------------------------------------------------;
LBAcHsUSB:
	;xor   dx,dx
	div   word [bpbSectorsPerTrack] 		
	inc   dl					
	mov   byte [absoluteSectorUSB],dl
	xor   dx,dx					
	div   word [bpbHeadsPerCylinder]		
	mov   byte [absoluteHeadUSB],dl
	mov   byte [absoluteTrackUSB],al
	ret

 ;----------------------------------------------------;
 ; ClusterLBA.                                        ;
 ;----------------------------------------------------;
ClusterLBAUSB:
	sub   ax,2					
	xor   cx,cx					
	mov   cl,byte [bpbSectorsPerCluster]		
	mul   cx					
	add   ax, word [DataStartUSB]		       
	ret	

 ;----------------------------------------------------;
 ; DATA.                                              ;
 ;----------------------------------------------------;
FddErrCount		 db   0
NameOfFileToLoadBuffer	 rb   16


