;=========================================================;
; Fat32                                          11/12/06 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
 ;====================================================;
 ; Max Root buffer size.                              ;
 ;====================================================;
MaxRootBufferSize = 0x100000
 ;====================================================;
 ; Device primary/secondary.                          ;
 ;====================================================;
hdbase	 equ  0x1f0					; 0x1f0 for primary device
							; 0x170 for secondary device
hdid	 equ  0x00					; 0x00 for master hd
							; 0x10 for slave hd
 ;====================================================;
 ; LoadMBR.                                           ;
 ;====================================================;
LoadMBR:
	pushad
	push  es
	push  ds
	mov   ax,18h					
	mov   ds,ax					
	mov   es,ax					
	cmp   byte[MBRloadRun],0
	jne   LoadMBRSuccsess
	mov   [countHdd],0
int13hloop:
	mov   cl,1
	mov   ch,00
	mov   dh,00					 
	mov   dl,0x80					   
	call  FddReadB
	jc    HddTryAgain
 ;----------------------------------------------------;
 ; Load MBR.                                          ;
 ;----------------------------------------------------;
	mov   dword[buff],esi
	mov   ecx,512
	mov   esi,dword[buff]
	mov   edi,MBRFat16n32
	rep   movsb
 ;----------------------------------------------------;
 ; Test for FAT16/32.                                 ;
 ;----------------------------------------------------;
	mov   esi,MBRFat16n32
	add   esi,450
	mov   al,byte[ds:esi]	
	mov   byte[SysID],al
	mov   byte[FatID],16
	cmp   al,0x04					; Fat16
	je    SysIdOk
	cmp   al,0x06
	je    SysIdOk
	cmp   al,0x0E
	je    SysIdOk
	mov   byte[FatID],32
	cmp   al,0x0B					; Fat32
	je    SysIdOk
	cmp   al,0x0C
	jne   LoadMbrErrorID
SysIdOk:
 ;----------------------------------------------------;
 ; Find first partion.                                ;
 ;----------------------------------------------------;        
	mov   esi,MBRFat16n32
	add   esi,446
	mov   al,byte[ds:esi]	
	cmp   al,80h
	jne   LoadMbrError
	mov   dx,word[ds:esi]				 
	mov   cx,word[ds:esi+2] 			 
 ;----------------------------------------------------;
 ; Store partition start cluster.                     ;
 ;----------------------------------------------------;     
	push  eax
	mov   esi,MBRFat16n32
	add   esi,454
	mov   eax,dword[ds:esi]       
	mov   [partition_start_cluster],eax
	pop   eax
	mov   [countHdd],0
int13hloop1:
	call  FddReadB
	jc    HddTryAgain1
	mov   ecx,512
	mov   esi,dword[buff]
	mov   edi,BpbFat16
	rep   movsb
	jmp   LoadMBRSuccsess
 ;----------------------------------------------------;
 ; Hdd read error.                                    ;
 ;----------------------------------------------------; 
HddTryAgain:
	inc   [countHdd]
	cmp   [countHdd],5
	jbe   int13hloop
	jmp   LoadMbrError
HddTryAgain1:
	inc   [countHdd]
	cmp   [countHdd],5
	jbe   int13hloop1
	jmp   LoadMbrError
 ;----------------------------------------------------;
 ; Hdd MBR Succsess.                                  ;
 ;----------------------------------------------------; 
LoadMBRSuccsess:
	mov   byte[MBRloadRun],1
	pop   ds
	pop   es
	popad
	clc
	ret 
 ;----------------------------------------------------;
 ; Hdd MBR Error.                                     ;
 ;----------------------------------------------------;
LoadMbrErrorID: 
	mov   byte[FatID],0xff
LoadMbrError:
	pop   ds
	pop   es
	popad
	stc
	ret

 ;====================================================;
 ; ReadOneSector.                                     ;
 ;====================================================;
ReadOneSector:
	call  LoadMBR
	jc    ReadOneSectorError
	cmp   byte[FatID],16
	jne   TryFat32
	call  DirFillRootFat16
	jc    ReadOneSectorError
	jmp   ReadOneSectorExit
TryFat32:
	cmp   byte[FatID],32
	jne   ReadOneSectorError
	call  ReadOneSectorFat32
	jc    ReadOneSectorError
ReadOneSectorExit: 
	clc
	ret

ReadOneSectorError:
	stc
	ret

 ;====================================================;
 ; ReadOneSector.                                     ;
 ;====================================================;
ReadOneSectorFat32:
	pushad
	cmp   [ReadOneSectorFatVar],0
	jne   ExitSucsessHdd
	mov   [hdbase1],0x1f0				 
	mov   [hdid1],0x00
	movzx ecx,word[bpbReservedSectors1]
	mov   [fat_start_cluster],ecx
	movzx ecx,byte[bpbNumberOfFATs1]		 
	mov   [number_of_fats],ecx
	mov   ecx,[bpb32SectorsPerFAT]			 
	mov   [fat_size],ecx
	mov   eax,[number_of_fats]			 
	imul  eax,[fat_size]				 
	add   eax,[fat_start_cluster]			 
	mov   [block_start_cluster],eax
	movzx ecx,byte[bpbSectorsPerCluster1]		  
	mov   [sectors_per_cluster],ecx
	mov   eax,[block_start_cluster] 		
	add   eax,[partition_start_cluster]		 
	mov   [RootDirBufferAddOn],0
	mov   [RootDirSizeVar],0
	mov   eax,dword[bpb32RootCluster]
	mov   dword [cluster32],eax
	sub   eax,2
new_cluster_of_RootHdd:
	push  eax
	imul  eax,[sectors_per_cluster]
	add   eax,[block_start_cluster]
	add   eax,[partition_start_cluster]
	mov   ecx,[sectors_per_cluster]
newbrRootHdd:
	call HddRead
	pushad
	mov   ecx,512	     
	mov   esi,HddBuffer
	mov   edi,RootDirBufferHdd
	add   edi,[RootDirBufferAddOn]
	rep   movsb
	add   [RootDirBufferAddOn],512
	add   [RootDirSizeVar],512
	popad
	inc   eax
	dec   ecx
	jnz   newbrRootHdd
	pop   eax
	call  FindNextCluster
	cmp   [RootDirSizeVar],MaxRootBufferSize
	jae   ExitSucsessHdd
	cmp   [ClusterTest],0xFFFFFF8
	jb    new_cluster_of_RootHdd
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
ExitSucsessHdd:
	mov   [ReadOneSectorFatVar],1
	popad
	clc
	ret 
 ;----------------------------------------------------;
 ; ErrorFloppy.                                       ;
 ;----------------------------------------------------; 
ErrorFloppyHdd:
	popad
	stc
	ret

 ;====================================================;
 ; hd_read.                    ; eax = block to read  ;
 ;====================================================;
HddRead:						 
	pushad 
	push  eax
newhdread:
	mov edx,[hdbase1]
	inc   edx
	mov   al,0
	out   dx,al

	inc   edx
	mov   al,1
	out   dx,al

	inc   edx
	pop   ax
	out   dx,al

	inc   edx
	shr   ax,8
	out   dx,al

	inc   edx
	pop   ax
	out   dx,al

	inc   edx
	shr   ax,8
	and   al,1+2+4+8
	add   al,[hdid1]	      
	add   al,128+64+32
	out   dx,al

	inc   edx
	mov   al,20h
	out   dx,al
hddwait:
	in    al,dx
	test  al,128
	jnz   hddwait

	mov   edi,HddBuffer 
	mov   ecx,256
	mov edx,[hdbase1]
	cld
	rep   insw

	popad
	ret

 ;====================================================;
 ; hd_read2.                      ; eax block to read ;
 ;====================================================;
HddRead2:						  
	pushad 
	push  eax
newhdread2:
	mov edx,[hdbase1]
	inc   edx
	mov   al,0
	out   dx,al
	inc   edx
	mov   al,1
	out   dx,al
	inc   edx
	pop   ax
	out   dx,al
	inc   edx
	shr   ax,8
	out   dx,al
	inc   edx
	pop   ax
	out   dx,al
	inc   edx
	shr   ax,8
	and   al,1+2+4+8
	add   al,[hdid1]	      
	add   al,128+64+32
	out   dx,al
	inc   edx
	mov   al,20h
	out   dx,al
hddwait2:
	in    al,dx
	test  al,128
	jnz   hddwait2
	mov   edi,HddBuffer2 
	mov   ecx,256
	mov edx,[hdbase1]
	cld
	rep   insw
	popad
	ret

 ;====================================================;
 ; RunCommandHdd.                                     ;
 ;====================================================;
RunCommandHdd:
	pushad
	push  es
	push  ds
	mov   ax,18h					
	mov   ds,ax					
	mov   es,ax
	call  LoadMBR
	call  ReadOneSector
	cmp   byte[FatID],16
	jne   TryFat32RunCommandHdd
	pushad
	mov   dword[NameOfFileToLoadFat16],edi
	call  ConvertFileNameFat16
	mov   edi,NameOfFileToLoadBufferFat16
	call  UpperCaseFat16
	popad
	mov   edi,NameOfFileToLoadBufferFat16
	call  RunCommandHddFat16
	jc    RunCommandHddError
	jmp   RunCommandHddExit
TryFat32RunCommandHdd:
	cmp   byte[FatID],32
	jne   RunCommandHddError
	pushad
	mov   dword[NameOfFileToLoadFat16],edi
	call  ConvertFileNameFat16
	mov   edi,NameOfFileToLoadBufferFat16
	call  UpperCaseFat16
	popad
	mov   edi,NameOfFileToLoadBufferFat16
	call  RunCommandHddFat32
	jc    RunCommandHddError
RunCommandHddExit:
	mov  [FddSectorsLoadedCountHddTmp],ebx
	mov  [FileReadBytesTmp],ecx
	pop   ds
	pop   es
	popad
	mov   ebx,[FddSectorsLoadedCountHddTmp]
	mov   ecx,[FileReadBytesTmp]
	clc
	ret
RunCommandHddError:
	pop   ds
	pop   es
	popad
	stc
	ret

 ;====================================================;
 ; LoadFolderHdd.                                     ;
 ;====================================================;
LoadFolderHdd:
	mov   [FddSectorsLoadedCountHdd],0
	call  LoadMBR
	jc    LoadFolderHddError
	call  ReadOneSector
	jc    LoadFolderHddError
	cmp   byte[FatID],16
	jne   TryFat32Sys
	call  LoadFolderHddFat16
	jc    LoadFolderHddError
	mov   dword[FolderSizeSectors],ebx
	shl   ebx,9
	shr   ebx,5
	mov   [FolderEntrysNumber],bx
	mov   bx,word [FirstFolderCluster]
	mov   word [FirstFolderClusterA],bx
	mov   ebx,dword[FolderSizeSectors]
	jmp   LoadFolderHddExit
TryFat32Sys:
	cmp   byte[FatID],32
	jne   LoadFolderHddError
	call  LoadFolderHddFat32
	jc    LoadFolderHddError
	mov   dword[FolderSizeSectors],ebx
	shl   ebx,9
	shr   ebx,5
	mov   [FolderEntrysNumber],bx
	mov   bx,word [FirstFolderCluster]
	mov   word [FirstFolderClusterA],bx
	mov   ebx,dword[FolderSizeSectors]
LoadFolderHddExit:
	clc
	ret

LoadFolderHddError:
	stc
	ret

 ;====================================================;
 ; LoadFolderHddFat32.                                ;
 ;====================================================;
LoadFolderHddFat32:
	pushad				  
	push  es
	push  ds 
	mov   ax,18h
	mov   ds,ax
	mov   es,ax 
	mov   [in_cache],0 
	mov   [HddFileName],edi
	mov   [FileLoadAddress],edx 
	mov   [FileLoadCountHdd],0
	mov   edi,RootDirBufferHdd 
	mov   [RootDirBufferVarC],edi
	mov   edi,[RootDirBufferVarC]
	mov   esi,[HddFileName] 			    
	mov   edx,[RootDirSizeVar]
	shr   edx,4
 ;----------------------------------------------------;
 ; FindName.                                          ;
 ;----------------------------------------------------;
FindFolderNameHdd:
	mov   cx,11 ;8
	jmp   FindNameCycleFLHdd
 ;----------------------------------------------------;
 ; jump into RunCommandHdd                            ;
 ;----------------------------------------------------;

 ;====================================================;
 ; RunCommand.                                        ;
 ;====================================================;
RunCommandHddFat32:
	pushad				  
	push  es
	push  ds 
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	mov   [FddSectorsLoadedCountHdd],0
	mov   [FileReadBytes],0
	mov   [in_cache],0 
	mov   [HddFileName],edi
	mov   [FileLoadAddress],edx 
	mov   [FileLoadCountHdd],0
	mov   edi,RootDirBufferHdd 
	mov   [RootDirBufferVarC],edi
	cmp   [RootYesNoC],0
	je    @f
	mov   [RootDirBufferVarC],0x110000
@@:
	mov   edi,[RootDirBufferVarC]
	mov   esi,[HddFileName]
	mov   edx,[RootDirSizeVar]
	shr   edx,4
 ;----------------------------------------------------;
 ; FindName.                                          ;
 ;----------------------------------------------------;
FindNameHdd:
	mov   cx,11
FindNameCycleFLHdd:
	cmp   byte [es:edi],ch
	je    FindNameFailedFLHdd				   
	pushad					       
	repe  cmpsb
	popad					       
	je    FindNameFoundFLHdd
	add   edi, 32
	dec   edx
	jnz   FindNameCycleFLHdd				   
FindNameFailedFLHdd:
	jmp   ErrorFindHdd
FindNameFoundFLHdd:
	mov   eax,dword[es:edi+1Ch]
	mov   [FileReadBytes],eax
	xor   eax,eax
	mov   ax,[es:edi+20]
	shl   eax,16
	mov   ax,[es:edi+26]
	mov   dword [cluster32],eax			    
	sub  eax,2
new_cluster_of_fileHdd:
	push eax
	imul eax,[sectors_per_cluster]
	add  eax,[block_start_cluster]
	add  eax,[partition_start_cluster]
	mov  ecx,[sectors_per_cluster]
newbrHdd:
	call HddRead
	pushad
	mov   ecx,512	     
	mov   esi,HddBuffer
	mov   edi,[FileLoadAddress]
	add   edi,[FileLoadCountHdd]
	rep   movsb
	add   [FileLoadCountHdd],512
	add   [FddSectorsLoadedCountHdd],1 
	popad
	inc   eax
	dec   ecx
	jnz   newbrHdd
	pop   eax
	call  FindNextCluster
	cmp   [ClusterTest],0xFFFFFF8
	jb    new_cluster_of_fileHdd
 ;----------------------------------------------------;
 ; ExitSucsess.                                       ;
 ;----------------------------------------------------;
ExitSucsessRCHdd:
	pop   ds
	pop   es
	popad
	mov   ebx,[FddSectorsLoadedCountHdd]
	mov   ecx,[FileReadBytes]
	clc
	ret 
 ;----------------------------------------------------;
 ; ErrorFind.                                         ;
 ;----------------------------------------------------;        
ErrorFindHdd:
	pop   ds
	pop   es
	popad
	stc
	ret

 ;====================================================;
 ; FindNextCluster.                                   ;
 ;====================================================;
FindNextCluster:
	add   eax,2
	shl   eax,2
	mov   ecx,eax
	shr   eax,9				       
	add   eax,[fat_start_cluster]
	add   eax,[partition_start_cluster]
	call  HddRead2
NoNeedToRead:
	and   ecx,511				       
	mov   edi,HddBuffer2
	add   edi,ecx
	mov   eax,[es:edi]
	mov   [ClusterTest],eax
	sub   eax,2
	ret

;====================================================;
; DirFolderCommandC.                                 ;
;====================================================;
DirFolderCommandC:
	mov   [DirBufferC],0x110000
	call  DirPrintFileFolderHdd
	mov   [ErrorCode],0
	mov   ah,0
	clc
	ret

;====================================================;
; DirPrintFileHdd.                                   ;
;====================================================;
DirPrintFileHdd:
	mov   [DirBufferC],RootDirBufferHdd
DirPrintFileFolderHdd:
	pushad
	mov   [HddFileCount],0
	mov   esi,nextline
	call  print_string
	call  PrintDirC 	
	mov   [RdirFileCountHdd],0
	mov   ax,18h 
	mov   es,ax  
	mov   ds,ax 
FileNamePrintLoopHdd: 
	mov   esi,[DirBufferC]
	add   esi,[RdirFileCountHdd]
	add   [RdirFileCountHdd],32
	cmp   byte [ds:esi],0xe5
	je    FileNamePrintLoopHdd
	cmp   byte [ds:esi],0x00
	je    DirSuccsessHdd
	mov   edi,DirEntry
	mov   cx,32
	rep   movsb
	cmp   word[dirCluster],0x0000
	je    FileNamePrintLoopHdd
 ;----------------------------------------------------;
 ; Have we filled the screen ?.                       ;
 ;----------------------------------------------------;    
	inc   [HddFileCount]
	cmp   [HddFileCount],40
	jb    @f
	call  HoldFileDirPrint
@@:
 ;----------------------------------------------------;
 ; Print file/dir name.                               ;
 ;----------------------------------------------------;      
	mov   esi,DirEntry
	mov   cx,8
 ;----------------------------------------------------;
 ; Set font color.                                    ;
 ;----------------------------------------------------; 
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x02
FilePrintLoopHdd:
	lodsb
	call  print_char
	loop  FilePrintLoopHdd
	mov   [textcolor],0x03	     
	mov   al,0x20
	call  print_char
;----------------------------------------------------;
; Print file exten.                                  ;
;----------------------------------------------------;
	mov   esi,dirExten
	mov   cx,3
FileExtenPrintLoopHdd:
	lodsb
	call  print_char
	loop  FileExtenPrintLoopHdd
	mov   al,[textcolorsave]
	mov   [textcolor],al
	test  byte[dirAttr],0x10
	jz    @f
	mov   esi,LabelDir
	call  print_string
	jmp   FileNamePrintLoopHdd
@@:
;----------------------------------------------------;
; Print files size in bytes.                         ;
;----------------------------------------------------;
	mov   esi,dirSize
	add   esi,2
	lodsw
	shl   eax,16
	mov   esi,dirSize
	lodsw
	mov   [hex_val],eax
	call  testhex
	mov   esi,SpaceDir1  
	call  print_string
	mov   esi,numbuff2 
	call  print_string
	mov   esi,nextline
	call  print_string
	jmp   FileNamePrintLoopHdd
DirSuccsessHdd:
	popad
	clc
	ret

DirErrorHdd:
	popad
	stc
	ret 

;====================================================;
; PrintDirA.                                         ;
;====================================================;
PrintDirC:
	pushad
	mov   esi,DirC
	call  print_string
	cmp   [RootYesNoC],0  
	je    @f
	mov   esi,FolderNameC
	call  print_string
@@:	 
	mov   esi,NextlineHdd
	call  print_string
	popad
	ret

;====================================================;
; PrintDirA.                                         ;
;====================================================;
HoldFileDirPrint:
	pushad
	mov   esi,HoldMessage
	call  print_string
	call  WaitForKeyPressInt46OOH
	mov   [HddFileCount],0
	popad
	ret

;====================================================;
; DirCommandGui.                                     ;
;====================================================;
DirCommandGuiHdd32:
	pushad
	mov   word[FileExt1],0
	mov   word[FileExt2],0
	mov   word[FileExt3],0
	mov   word[FileExt],ax
	cmp   word[FileExt],0
	je    @f
	shr   eax,16
	mov   word[FileExt1],ax
	mov   word[FileExt2],cx
	shr   ecx,16
	mov   word[FileExt3],cx
@@:
	call  LoadMBR
	call  ReadOneSector
	;jc    DirCommandErrorGuiHdd32
	call  DirPrintFileGuiHdd32
	mov   [ErrorCode],0
	popad
	mov   ah,0
	mov   esi,Hdd_FilesForMenu
	mov   edi,HddFilesForMenu
	mov   ebx,[FileNumberCount]
	clc
	ret
DirCommandErrorGuiHdd32:
	popad
	stc
	ret
;====================================================;
; DirPrintFileGuiHdd32.                              ;
;====================================================;
DirPrintFileGuiHdd32:
	mov   [RdirFileCountHdd],0
	mov   [Hdd32FileListCount],0
	mov   [Hdd32_FileListCount],0
	mov   [FileNumberCount],0
	mov   ax,sys_data 
	mov   es,ax  
	mov   ds,ax 
	mov   edi,HddFilesForMenu
	mov   cx,630
	mov   al,0
	rep   stosb
	mov   esi,RootDirBufferHdd
	mov   [RootDirBufferVarC],esi
	cmp   [RootYesNoC],0
	je    @f
	mov   [RootDirBufferVarC],0x110000
@@:
FileNamePrintLoopGuiHdd32: 
	mov   esi,[RootDirBufferVarC]
	add   esi,[RdirFileCountHdd]
	add   [RdirFileCountHdd],32
	cmp   byte [ds:esi],0xe5
	je    FileNamePrintLoopGuiHdd32
	cmp   byte [ds:esi],0x00
	je    DirSuccsessGuiHdd32
	mov   edi,DirEntry
	mov   cx,32
	rep   movsb
	cmp   word[dirCluster],0x0000
	je    FileNamePrintLoopGuiHdd32
	;mov   cx,word[FileExt]
	;cmp   cx,0
	;je    @f
	mov   cx,word[FileExt]
	cmp   cx,0
	je    @f
	cmp   word[dirExten],cx ;'GE'
	je    @f
	mov   cx,[FileExt1]
	cmp   word[dirExten],cx
	je    @f
	mov   cx,[FileExt2]
	cmp   word[dirExten],cx
	je    @f
	mov   cx,[FileExt3]
	cmp   word[dirExten],cx
	jne   FileNamePrintLoopGuiHdd32
@@:
;====================================================;
; Print file/dir name.                               ;
;====================================================;   
	inc   [FileNumberCount] 
	mov   esi,DirEntry
	mov   cx,8
	push  edi
	mov   edi,HddFilesForMenu
	add   edi,[Hdd32FileListCount]
	rep movsb
;====================================================;
; Print file exten.                                  ;
;====================================================;
	mov   esi,dirExten
	mov   cx,3
	rep   movsb
	mov   al,0
	stosb
	add   [Hdd32FileListCount],12
	mov   esi,DirEntry
	mov   cx,8
	mov   edi,Hdd_FilesForMenu
	add   edi,[Hdd32_FileListCount]
	rep   movsb
	add   [Hdd32_FileListCount],9
	mov   al,0
	stosb
	pop   edi
	cmp   [FileNumberCount],20 
	jae   DirSuccsessGuiHdd32 
	jmp   FileNamePrintLoopGuiHdd32
DirSuccsessGuiHdd32:
	clc
	ret
DirErrorGuiHdd32:
	stc
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; HddFat32WriteFolder.                                                             ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HddFat32WriteFolder:
	mov byte[ErrorCodeFat16],0xab
	stc
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; HddFat32WriteRoot.                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HddFat32WriteRoot:
	mov byte[ErrorCodeFat16],0xab
	stc
	ret

;====================================================;
; Data                                               ;
;====================================================;
SpaceDir1:		 db "    " ,0
DirC:			 db 0xd2,0x09, "Directory of C:\",0
NextlineHdd:		 db " ",0xd2,0x07,0x0d,0x0d,0
HoldMessage:		 db 13,0xd2,0x09, "Press any key to continue. ",0xd2,0x07,13,13,0

