;=========================================================;
; IntFunctions                                   11/12/06 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ;  GetRmPalette  ;Returns pointer to stanard palette ;
 ;----------------------------------------------------;
GetRmPalette:
	mov   edx,StPalette
	ret
 ;----------------------------------------------------;
 ;  SetDex4uFonts  ;goes to realmode sets 50x80 fonts ;
 ;----------------------------------------------------;
SetDex4uFonts:
	call  SetDex4uFontsInt
	call  ReadyPrompt
	ret
 ;----------------------------------------------------;
 ; Wait Key Pressed   wait's for any key to bepressed.;
 ;----------------------------------------------------;
WaitForKeyPress:
	mov   [WaitKPressed],0
@@:
	hlt
	cmp   [WaitKPressed],1
	jne   @b
	mov   [WaitKPressed],0
	ret

 ;----------------------------------------------------;
 ; Wait Key Pressed   wait's for any key to bepressed.;
 ;----------------------------------------------------;
SetKeyBuffer:
	cli
	mov   [keybuffer],0
	sti
	ret

 ;----------------------------------------------------;
 ; WaitKeyPressed INT46      wait's key to bepressed. ;
 ;----------------------------------------------------;
WaitForKeyPressInt46OOH:
@@:
	call  WaitForKeyPress
	cmp   [keybuffer],-1
	je    @b
	mov   al,[keybuffer]
	mov   ah,[ScanCode]
	mov   byte[KeyCode],al
	mov   [keybuffer],0
	mov   [ScanCode],0
	ret

 ;----------------------------------------------------;
 ; KeyPressedNoWait.                                  ;
 ;----------------------------------------------------;

KeyPressedNoWait:
	cmp   [WaitKPressed],1
	je    YkeyExit 
NkeyExit:
	mov   byte[KeyCode],0
	xor   ax,ax
	ret
YkeyExit:
	xor   ax,ax
	mov   byte[KeyCode],1
	mov   al,byte[KeyCode]
	mov   [WaitKPressed],0
	ret

 ;----------------------------------------------------;
 ; KeyPressedNoWaitScanCodes.                         ;
 ;----------------------------------------------------;
KeyPressedNoWaitScanCodes:
	cmp   [WaitKPressed],1
	je    YkeyExitScanCodes 
NkeyExitScanCodes:
	mov   byte[KeyCode],0
	xor   ax,ax
	ret
YkeyExitScanCodes:
	mov   [WaitKPressed],0
	xor   ax,ax
	cmp   [keybuffer],-1
	je    NkeyExitScanCodes
	mov   al,[keybuffer]
	mov   ah,[ScanCode]
	mov   [keybuffer],0
	mov   [ScanCode],0
	ret

;====================================================;
; SetTimer.                 delay for a number of ms ;
;====================================================;
SetTimer:
	cmp   ax,0
	jbe   Time2Exit
	mov   word[Timer],ax 
	mov   [TimerOn],1			       
	call  Wait_Timer
Time2Exit:
	ret

;====================================================;
; Wait Timer.            ;waits for timer to finish. ;
;====================================================;
Wait_Timer:
	push  eax
Wait_Timer_Loop:
	mov   al,[TimerOn]
	or    al,al
	jnz   Wait_Timer_Loop
	pop   eax
	ret

 ;----------------------------------------------------;
 ; TimerNoWait                                        ;
 ;----------------------------------------------------;
TimerNoWait:
	cmp   ax,0
	je    @f
	mov   word[TimerNw],ax 
	mov   [TimerOnNw],1  
@@:	   
	mov   al,[TimerOnNw]
	or    al,al
	jnz   NotReadyYet
	mov   al,0
	ret

NotReadyYet:
	mov   al,1
	ret

 ;----------------------------------------------------;
 ; Conventional Memory   ;puts conmemory in kb in eax ;
 ;----------------------------------------------------;
ConventionalMemory:
	mov   eax,dword[ConvMemorySize]
	ret

 ;----------------------------------------------------;
 ; ExtMemory       ;puts extended memory in kb in eax ;
 ;----------------------------------------------------;
ExtMemory:
       mov    eax,dword[ExtMemorySize]
       mov    ebx,dword[TotalMemoryMB]
       cmp    eax,0
       jne    @f
       stc
@@:
       ret

 ;----------------------------------------------------;
 ; DetectPciBus1           ;Detect if Pci bus present ;
 ;----------------------------------------------------;
DetectPciBus1:
       clc
       cmp    byte[PciBusPresent],1
       je    @f
       stc
@@:
       ret
 ;----------------------------------------------------;
 ; Empty Function                                     ;
 ;----------------------------------------------------;
LoadVesaInfo:
	mov   esi,VESA_Info  
	mov   dword[EsiPointer],esi
	ret

 ;----------------------------------------------------;
 ; ProgramInterruptTimer                              ;
 ;----------------------------------------------------;
InterruptTimer:
	pushad
	mov   [DivNumber],cx
	cmp   [DivNumber],0
	jne   IntTimerNot0
	mov   [ClockTiKs],18
	jmp   @f
IntTimerNot0:
	mov   dx,0x0012
	cmp   dx,[DivNumber]
	jnb   ExitPitError
	mov   ax,0x34dd
	mov   cx,[DivNumber]
	mov   [ClockTiKs],cx
	div   cx
	mov   [DivNumber],ax
@@:
	cli
	mov   al,00110100b
	mov   dx,0x43
	out   dx,al
	mov   ax,[DivNumber]
	mov   dx,0x40
	out   dx,al
	mov   al,ah
	out   dx,al
	sti
	popad
	ret

ExitPitError:
	popad
	mov   al,1
	ret

 ;----------------------------------------------------;
 ; GameKeyBoardOn                                     ;
 ;----------------------------------------------------;
GameKeyBoardOn2:
	mov   [GameKeyBoardOn],1 
	mov   esi,KeyDown
	ret 
 ;----------------------------------------------------;
 ; GameKeyBoardOff                                    ;
 ;----------------------------------------------------;
GameKeyBoardOff:
	pushad
	push  es
	mov   ax,18h
	mov   es,ax
	mov   [GameKeyBoardOn],0
	mov   edi,KeyDown
	mov   al,0
	mov   cx,128
	rep   stosb
	pop   es 
	popad
	ret  

 ;----------------------------------------------------;
 ; DriveLetter.                                       ;
 ;----------------------------------------------------;
DriveLetter:
	mov  al,[PromptLetter]
	ret

 ;----------------------------------------------------;
 ; CurrutDir.                                         ;
 ;----------------------------------------------------;
CurrutDir:
	pushad
	push  es
	push  ds
	mov   ax,18h
	mov   ds,ax
	cmp   [PromptLetter],'A'
	jne   CurrutDirTryC
	cmp   [RootYesNoA],0
	je    CurrutDirTryD
	mov   cx,16
	mov   esi,FolderNameA
	cld
	rep   movsb
	jmp   CurrutDirTryE
CurrutDirTryC:
	cmp   [PromptLetter],'C'
	jne   CurrutDirTryD
	cmp   [RootYesNoC],0
	je    CurrutDirTryD
	mov   cx,16
	mov   esi,FolderNameC
	cld
	rep   movsb
	jmp   CurrutDirTryE
CurrutDirTryD:
	mov   cx,64
	mov   esi,ABCDir
	rep   movsb
CurrutDirTryE:
	pop   ds
	pop   es
	popad
	ret

 ;----------------------------------------------------;
 ; GetParams                                          ;
 ;----------------------------------------------------;
GetParams:
	push  ds
	push  eax
	mov   ax,18h
	mov   ds,ax
	mov   esi,CommandBuffer2
	pop   eax
	pop   ds
	ret

;====================================================;
; GetTime.                                           ;
;====================================================;
GetTime:
	pushad
	push  es
	push  ds
	mov   ax,18h 
	mov   ds,ax				
	mov   es,ax
	call  time
	xor   eax,eax
	mov   al,[hour]
	shl   eax,16
	mov   ch,[minute]
	mov   cl,[second]
	mov   ax,cx
	mov   [TimeVar],eax
	pop   ds
	pop   es
	popad
	mov   eax,[TimeVar]
	ret

;====================================================;
; GetTime.                                           ;
;====================================================;
GetDate:
	pushad
	push  es
	push  ds
	mov   ax,18h 
	mov   ds,ax				
	mov   es,ax
	call  date
	xor   eax,eax
	mov   ah,[century] 
	mov   al,[year]
	shl   eax,16
	mov   ch,[month]
	mov   cl,[day]
	mov   ax,cx
	mov   [DateVar],eax
	pop   ds
	pop   es
	popad
	mov   eax,[DateVar]
	ret

 ;----------------------------------------------------;
 ; GetClockTicks                                      ;
 ;----------------------------------------------------;
GetClockTicks:
	cmp  ecx,1
	jne  GetTimePast
	mov  [TimerProgOn],1
	mov  [TimerProg],0
	ret
GetTimePast:
	mov  [TimerProgOn],0
	mov  eax,[TimerProg]
	ret 

;====================================================;
; ModService.                                        ;
;====================================================;
ModService:
	pushad
	push  es
	push  ds
	mov   ax,18h
	mov   ds,ax				
	mov   es,ax
	mov   [ModServiceErrorCode],1
	mov   [ModID123],esi
	mov   ebx,[ModListNumbers]
	cmp   ebx,1
	jbe   ModServiceError
	mov   edi,ModListStruct
	add   edi,32
	mov   esi,[ModID123]
	dec   ebx
MachModIDLoop1:
	mov   ecx,8 
	call  CompearString
	jnc   FoundMod
	add   edi,32
	dec   ebx
	cmp   ebx,0
	jne   MachModIDLoop1
	jmp   ModServiceError
FoundMod:
	mov   [ModAddress],edi
	mov   eax,dword[es:edi+8]
	mov   [SizeOfModule],eax
	mov   eax,dword[es:edi+12]
	mov   [ModLoad],eax
	mov   eax,dword[es:edi+16]
	mov   [ModunLoad],eax
	mov   eax,dword[es:edi+20]
	mov   [NumberOfModFunctions],eax
	mov   eax,dword[es:edi+24]
	mov   [AbsolModAddress],eax
	pop   ds
	pop   es
	popad
	mov   eax,[ModLoad]
	clc
	ret

ModServiceError:
	pop   ds
	pop   es
	popad
	mov   ah,[ModServiceErrorCode]
	stc
	ret

 ;----------------------------------------------------;
 ; GetIntVector                                       ;
 ;----------------------------------------------------;
GetIntVector:
	pushad
	push  es
	push  ds
	mov   cx,18h
	mov   ds,cx
	movzx eax,al
	shl   eax,3
	add   eax,idt
	cli
	mov   cx,word [ds:eax+2]
	mov   [CXbackup],cx
	mov   dx,word [ds:eax+6]
	shl   edx,16
	mov   dx,word [ds:eax]
	mov   [EDXbackup],edx
	sti
	pop   ds
	pop   es
	popad
	mov   cx,[CXbackup]
	mov   edx,[EDXbackup]
	clc
	ret

 ;----------------------------------------------------;
 ; SetIntVector                                       ;
 ;----------------------------------------------------;
SetIntVector:
	pushad
	push  es
	push  ds
	push  ecx
	mov   cx,18h
	mov   ds,cx
	pop   ecx
	movzx eax,al
	shl   eax,3
	add   eax,idt
	cli					      ; if  selector is needed
       ;mov   word [ds:eax+2],cx
	mov   word [ds:eax],dx
	shr   edx,16
	mov   word [ds:eax+6],dx
	sti
	pop   ds
	pop   es
	popad
	clc
	ret

 ;----------------------------------------------------;
 ; Top of memory                                      ;
 ;----------------------------------------------------;
TopOfMemory:
	mov   eax,dword[TopOfFreeMemoryWithBase]
	ret

 ;----------------------------------------------------;
 ; Get Dex4u add on                                   ;
 ;----------------------------------------------------;
GetBaseAddOn:
	mov   eax,[BaseAddOn]
	ret

 ;----------------------------------------------------;
 ; CountTicks.                                        ;
 ;----------------------------------------------------;
CountTicks:
	cmp  [Tick18],1
	jne  Waiting4tick
	mov  [Tick18],0
	stc
	ret
Waiting4tick:
	clc
	ret

 ;----------------------------------------------------;
 ; TimerSecondCount.                                  ;
 ;----------------------------------------------------;
TimerSecondCount:
	mov   eax,[NumberOfTicks]
	ret



 ;----------------------------------------------------;
 ; Gets the Dma floppy buffers address                ;
 ;----------------------------------------------------;
GetDMAbufferaddress:
	mov   esi,OffsetDma2Buffer	       ;Read
	mov   edi,OffsetDma2Buffer1	       ;write
	ret

 ;----------------------------------------------------;
 ; Empty Function                                     ;
 ;----------------------------------------------------;

EmptyFunction:
	nop
	call  WaitForKeyPressInt46OOH
	ret

 ;----------------------------------------------------;
 ; Data.                                              ;
 ;----------------------------------------------------;
CXbackup	     dw 0
EDXbackup	     dd 0
ModServiceErrorCode  db 0
ModServiceTable1     dd 0
NumberOfModFunctions dd 0
ModLoad 	     dd 0
ModunLoad	     dd 0
AbsolModAddress      dd 0
ModAddress	     dd 0
ModID123	     dd 0
ModfunctionN	     db 0
SizeOfModule	     dd 0

ClockTiKs	     dw 18
TimerBU 	     dw 0
TimeVar 	     dd 0
DateVar 	     dd 0
KeyCode 	     db 0
DivNumber	     dw 0
TempStore	     dd 0
ABCDir: times	128  db 0
SomeSpair: times 32  db 0