;=========================================================;
; ReadCd                                         07/28/06 ;
;---------------------------------------------------------;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ; Read Cd Dir                                        ;
 ;----------------------------------------------------;
ReadCdDir:
	mov   eax,dword[ImageLoadAddrVar]
	mov   dword[LoadAdress],eax
	mov   byte [command],Atapi_Packet_Command
	call  ListFilesOnCd
	jnc   @f
	mov   [Timer],15				
	mov   [TimerOn],1			       
	call  WaitTimer 				
	call  ListFilesOnCd
	jnc   @f
	mov   [Timer],20				
	mov   [TimerOn],1				
	call  WaitTimer 				
	call  ListFilesOnCd
	jnc   @f
	mov   [Timer],30				
	mov   [TimerOn],1				
	call  WaitTimer 				
	call  ListFilesOnCd
	jc    CdReadError
@@:
	mov   ah,0
	ret
CdReadError:
	mov   byte[ErrorCode],1
	mov   ah,byte[ErrorCode]
	stc
	ret

 ;----------------------------------------------------;
 ; Print Cd File Name                                 ;
 ;----------------------------------------------------;
PrintCdFileName:
	pushad
	push  es
	mov   esi,TmpFileName1
	xor   cx,cx
	mov   cl,byte[CdNameLen]
FindNameCycle1:
	lodsb
	call  print_char
	loop  FindNameCycle1
	mov   esi,nextline
	call  print_string
	pop   es
	popad
	ret

 ;----------------------------------------------------;
 ; List file on cd                         (LFOC)     ;
 ;----------------------------------------------------;
ListFilesOnCd:
	call  Read_toc
	jc   TocErrorLFOC
	call  Read_disk_info
	mov   esi,dword[LoadAdress]			  
	mov   ebx,dword[ds:esi+140]
	mov   dword[SectorAdress],ebx
	call  Read_disk
	jc    TocErrorLFOC 
	xor   eax,eax
	mov   dword[RootDirSector],eax	      
	mov   esi,dword[LoadAdress]			  
	xor   ecx,ecx
	mov   ecx,1
GetOtherPathNameLFOC:
	mov   bl,byte[ds:esi] 
	cmp   bl,0
	je    PathNameDoneLFOC 
	cmp   bl,1
	jne   NotRootDirLFOC
	mov   eax,dword[ds:esi+2]
	mov   dword[RootDirSector],eax	      
NotRootDirLFOC:
	mov   bl,byte[ds:esi]
	mov   dl,bl
	movzx edx,dl
	add   esi,edx
	add   esi,8
	and   edx,1
	add   esi,edx
	jmp   GetOtherPathNameLFOC     
PathNameDoneLFOC:
	mov   ebx,dword[RootDirSector]
	mov   dword[SectorAdress],ebx		 
	call  Read_disk
	jc    TocErrorLFOC
 ;---------------------------------;
 ; Scan for filename               ;
 ;---------------------------------;
	mov   esi,dword[LoadAdress]			    
	xor   ecx,ecx
	mov   ecx,1
GetOtherFileNameLFOC:
	mov   al,1
	mov   bl,byte[ds:esi]
	cmp   bl,0
	je    TocErrorLFOC1
	mov   bl,byte[ds:esi]
	mov   dl,bl
	mov   ebx,dword[ds:esi+2]
	mov   ebx,dword[ds:esi+10]
	mov   bl,byte[ds:esi+25]		 
	shr   bl,1
       ;and   bl,1
	test  bl,1
	jnz   NotThisFileLFOC
	mov   bl,byte[ds:esi+32]
	mov   byte[CdNameLen],bl
	sub   [CdNameLen],2
	push  es
	mov   ax,sys_data
	mov   es,ax
	mov   edi,TmpFileName1
	xor   al,al
	mov   byte[es:edi],al
	push  esi
	push  edi
	push  ecx
	push  edx
	mov   dl,byte[ds:esi+32]
	xor   cl,cl
	add   esi,33
CopyMoreTmpNameLFOC:
	mov   al,byte[ds:esi]
	cmp   al,0
	je    EndOfTmpNameCopyLFOC
	cmp   al,1
	je    EndOfTmpNameCopyLFOC
	cmp   al,';'
	je    EndOfTmpNameCopyLFOC
	mov   byte[es:edi],al
	xor   al,al
	mov   byte[es:edi+1],al
	inc   esi
	inc   edi
	inc   cl
	cmp   cl,dl
	jae   EndOfTmpNameCopyLFOC
	jmp   CopyMoreTmpNameLFOC
EndOfTmpNameCopyLFOC:
	pop   edx
	pop   ecx
	pop   edi
	pop   esi
	pop   es
	call  PrintCdFileName 
NotThisFileLFOC:
	movzx edx,dl
	add   esi,edx
	and   edx,1
	add   esi,edx
	jmp   GetOtherFileNameLFOC	   
TocErrorLFOC:
	stc
	ret 
TocErrorLFOC1:
	clc
	ret
 ;---------------------------------;
 ; Prints CD dir string            ;
 ;---------------------------------;
PrintCdDir:
	pushad
	mov   al,[textcolor]
	mov   [textcolorsave],al 
	mov   [textcolor],0x09
	mov   esi,DirD
	call  print_string
	mov   al,[textcolorsave]
	mov   [textcolor],al
	popad
	ret

 ;----------------------------------------------------;
 ; Read Cd Dir                                        ;
 ;----------------------------------------------------;
ReadCdDirGui:
	pushad
	push  es
	push  eax
	push  ecx
	mov   ax,18h
	mov   es,ax
	mov   edi,CdFilesForMenu 
	mov   cx,600
	mov   al,0
	rep   stosb
	pop   ecx
	pop   eax
	pop   es
	mov   word[FileExt1],0
	mov   word[FileExt2],0
	mov   word[FileExt3],0
	mov   word[FileExt],ax
	cmp   word[FileExt],0
	je    @f
	shr   eax,16
	mov   word[FileExt1],ax
	mov   word[FileExt2],cx
	shr   ecx,16
	mov   word[FileExt3],cx
@@:
	mov   [CdGuiFileCount],dword 0
	mov   [FileNumberCountCd],dword 0
	mov   dword[LoadAdress],0x800000
	mov   byte [command],Atapi_Packet_Command
	call  ListFilesOnCdGui ;ListFilesOnCd
	jnc   @f
	mov   [Timer],15				
	mov   [TimerOn],1			       
	call  WaitTimer 				
	call  ListFilesOnCdGui ;ListFilesOnCd
	jnc   @f
	mov   [Timer],20				
	mov   [TimerOn],1				
	call  WaitTimer 				
	call  ListFilesOnCdGui ;ListFilesOnCd
	jnc   @f
	mov   [Timer],30				
	mov   [TimerOn],1				
	call  WaitTimer 				
	call  ListFilesOnCdGui ;ListFilesOnCd
	jc    CdReadErrorGui
@@:
	popad
	mov   esi,CdFilesForMenu
	mov   edi,[CdGuiFileCount]
	mov   ebx,[FileNumberCountCd]
	mov   ah,0
	ret

CdReadErrorGui:
	popad
	mov   byte[ErrorCode],1
	mov   ah,byte[ErrorCode]
	stc
	ret

 ;----------------------------------------------------;
 ; Print Cd File Name                                 ;
 ;----------------------------------------------------;
PrintCdFileNameGui:
	pushad
	push  es
	push  ds
	mov   ax,18h
	mov   es,ax
	mov   ds,ax
	mov   edi,CdFilesForMenu
	add   edi,[CdGuiFileCount]
	mov   esi,TmpFileName1
	xor   ecx,ecx
	mov   cl,byte[CdNameLen]
	add   esi,ecx
	sub   esi,3
	push  ecx
	mov   cx,word[FileExt]
	cmp   cx,0
	je    CdPrintIt
	cmp   word [ds:esi],cx ;'GE'
	je    CdPrintIt
	mov   cx,[FileExt1]
	cmp   word [ds:esi],cx
	je    CdPrintIt
	mov   cx,[FileExt2]
	cmp   word [ds:esi],cx
	je    CdPrintIt
	mov   cx,[FileExt3]
	cmp   word [ds:esi],cx
	je    CdPrintIt
	pop   ecx
	jmp   @f
CdPrintIt:
	pop   ecx
	mov   esi,TmpFileName1
FindNameCycle11:
	movsb
	loop  FindNameCycle11
	cmp   [CdGuiFileCount],400
	jae   @f
	mov   edi,CdFilesForMenu
	add   edi,[CdGuiFileCount]
	add   edi,18
	xor   ax,ax
	mov   al,byte[CdNameLen]
	stosw
	add   [CdGuiFileCount],20
	add   [FileNumberCountCd],1
@@:
	pop   ds
	pop   es
	popad
	ret

 ;----------------------------------------------------;
 ; List file on cd                         (LFOC)     ;
 ;----------------------------------------------------;
ListFilesOnCdGui:
	call  Read_toc
	jc   TocErrorLFOC
	call  Read_disk_info
	mov   esi,dword[LoadAdress]			  
	mov   ebx,dword[ds:esi+140]
	mov   dword[SectorAdress],ebx
	call  Read_disk
	jc    TocErrorLFOCGui 
	xor   eax,eax
	mov   dword[RootDirSector],eax	      
	mov   esi,dword[LoadAdress]			  
	xor   ecx,ecx
	mov   ecx,1
GetOtherPathNameLFOCGui:
	mov   bl,byte[ds:esi] 
	cmp   bl,0
	je    PathNameDoneLFOCGui	 ;cc
	cmp   bl,1
	jne   NotRootDirLFOCGui 	 ;NotRootDirLFOC
	mov   eax,dword[ds:esi+2]
	mov   dword[RootDirSector],eax	      
NotRootDirLFOCGui:
	mov   bl,byte[ds:esi]
	mov   dl,bl
	movzx edx,dl
	add   esi,edx
	add   esi,8
	and   edx,1
	add   esi,edx
	jmp   GetOtherPathNameLFOCGui  ;GetOtherPathNameLFOC     
PathNameDoneLFOCGui:
	mov   ebx,dword[RootDirSector]
	mov   dword[SectorAdress],ebx		 
	call  Read_disk
	jc    TocErrorLFOCGui
 ;---------------------------------;
 ; Scan for filename               ;
 ;---------------------------------;
	mov   esi,dword[LoadAdress]			    
	xor   ecx,ecx
	mov   ecx,1
GetOtherFileNameLFOCGui:
	mov   al,1
	mov   bl,byte[ds:esi]
	cmp   bl,0
	je    TocErrorLFOC1Gui
	mov   bl,byte[ds:esi]
	mov   dl,bl
	mov   ebx,dword[ds:esi+2]			    ; Data start
	mov   ebx,dword[ds:esi+10]			    ; Bytes
	mov   bl,byte[ds:esi+25]		 
	shr   bl,1
       ;and   bl,1                                          ; File/Dir
	test  bl,1
	jnz   NotThisFileLFOCGui
	mov   bl,byte[ds:esi+32]			    ; NameLen
	mov   byte[CdNameLen],bl
	sub   [CdNameLen],2
	push  es
	mov   ax,sys_data				    ; Move how data base,into ax
	mov   es,ax					    ; move ax into es
	mov   edi,TmpFileName1
	xor   al,al
	mov   byte[es:edi],al
	push  esi
	push  edi
	push  ecx
	push  edx
	mov   dl,byte[ds:esi+32]
	xor   cl,cl
	add   esi,33
CopyMoreTmpNameLFOCGui:
	mov   al,byte[ds:esi]
	cmp   al,0
	je    EndOfTmpNameCopyLFOCGui
	cmp   al,1
	je    EndOfTmpNameCopyLFOCGui
	cmp   al,';'
	je    EndOfTmpNameCopyLFOCGui
	mov   byte[es:edi],al
	xor   al,al
	mov   byte[es:edi+1],al
	inc   esi
	inc   edi
	inc   cl
	cmp   cl,dl
	jae   EndOfTmpNameCopyLFOCGui
	jmp   CopyMoreTmpNameLFOCGui
EndOfTmpNameCopyLFOCGui:
	pop   edx
	pop   ecx
	pop   edi
	pop   esi
	pop   es
	call  PrintCdFileNameGui 
NotThisFileLFOCGui:
	movzx edx,dl
	add   esi,edx
	and   edx,1
	add   esi,edx
	jmp   GetOtherFileNameLFOCGui	      
TocErrorLFOCGui:
	stc
	ret 
TocErrorLFOC1Gui:
	clc
	ret

 ;----------------------------------------------------;
 ; CdfileLoad.                                        ;
 ;----------------------------------------------------;
CdfileLoad:
	pushad				  
	push  es
	mov   byte[CliOrUser],1
	mov   word[CdFileNameLen],cx
	mov   dword[LoadFileToAddressCd],edi
	mov   dword[NameOfFileToLoadCd],esi
	mov   ax,sys_data			       
	mov   es,ax
	mov   esi,[NameOfFileToLoadCd]
	mov   edi,NameOfFileToLoadBufferCd
	mov   cx,word[CdFileNameLen]
	cld
	rep   movsb
	mov   al,0
	stosb
	mov   edi,NameOfFileToLoadBufferCd
	call  UpperCase
	mov   byte [command],Atapi_Packet_Command
	mov   edx,dword[LoadFileToAddressCd]
	mov   dword[LoadAdress],edx
	call  Get_file_on_cd_info 
	jnc   @f
	mov   [Timer],5 				
	mov   [TimerOn],1			       
	call  WaitTimer 			       
	call  Get_file_on_cd_info 
	jnc   @f
	mov   [Timer],5 				
	mov   [TimerOn],1				
	call  WaitTimer 				
	call  Get_file_on_cd_info 
	jc    ErrorCdUser
@@:  
	mov   ecx,dword[FileSizeBytes]
	shr   ecx,11
	add   ecx,1
	mov   word[counter],cx
	call  Read_cd
	jc    ErrorCdUser
CdUserSuccess:
	mov   byte[CliOrUser],0
	pop   es
	popad
	mov   ecx,dword[FileSizeBytes]
	mov   ebx,ecx
	shr   ebx,8
	cmp   ebx,1
	jae   @f
	inc   ebx
@@:
	clc
	ret 
ErrorCdUser:
	mov   byte[CliOrUser],0
	pop   es
	popad
	stc
	ret

 ;----------------------------------------------------;
 ; Compear_String                                     ;
 ;----------------------------------------------------;
CompearStringUser:
	pushad
	push  es
	mov   ax,sys_data				    
	mov   es,ax					   
	mov   edi,TmpFileName1
	mov   esi,NameOfFileToLoadBufferCd		  
	mov   cx,word[CdFileNameLen]	   
FindNameCycleUser:
	cmp   byte [es:edi],ch
	je    FindNameFailedUser	  
	pusha
	repe  cmpsb
	popa
	je    FindNameFoundUser
FindNameFailedUser:
	stc
FindNameFoundUser:
	pop   es
	popad
	ret

 ;----------------------------------------------------;
 ; Data                                               ;
 ;----------------------------------------------------;
CdNameLen		    db	0
FileNumberCountCd	    dd	0
CdGuiFileCount		    dd	0
LoadFileToAddressCd	    dd	0
NameOfFileToLoadCd	    dd	0
CdFileNameLen		    dw	0
NameOfFileToLoadBufferCd    rb	 16