;=========================================================;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ; FloppyMenu.                                        ;
 ;----------------------------------------------------;
FloppyMenu:
	pushad
 ;----------------------------------------------------;
 ; load image to screen buffer.                       ;
 ;----------------------------------------------------; 
ReStoreAmenu:
	call  PutBmp
	call  SaveBack
	xor   eax,eax
	mov   edx,eax
	mov   ecx,eax
	mov   ebx,eax
	mov   [MenuList],0
	mov   [MenuListCount],0
	mov   [LineCount],1
	mov   [testcount2],0
	mov   [DrawHighLightAddOn],0
	call  DrawCoverUP
	call  print_date			       ; print date 
	call  PrintTimeGui			       ; print time
	call  DrawAmenu
	call  DrawHighLight
	call  PrintAMsg
	call  BuffToScreen
 ;----------------------------------------------------;
 ; Main A: drive menu loop.                           ;
 ;----------------------------------------------------; 
AdriveMenuLoop:
	call  PutBackSave
	call  PrintDateGui  
	call  PrintTimeGui
	call  PrintAMsg
	call  BuffToScreen
	hlt
	call  [KeyPressedScanNW]
	cmp   ax,0
	je    AdriveMenuLoop
	cmp   ah,0x50
	jne   @F
	mov   ecx,[FileNumberCount]
	dec   ecx
	cmp   ecx,13
	jbe   NotOver15
	mov   ecx,13
NotOver15:
	cmp   [MenuListCount],ecx 
	jae   AdriveMenuLoop
	add   [DrawHighLightAddOn],15
	inc   [MenuListCount]
	call  PutBmp
	call  DrawCoverUP
	call  DrawAmenu
	call  DrawHighLight
	call  PrintDateGui  
	call  PrintTimeGui
	call  PrintAMsg
	call  BuffToScreen
	jmp   AdriveMenuLoop
@@:
	cmp   ah,0x48
	jne   @F
	cmp   [MenuListCount],0
	jbe   AdriveMenuLoop
	sub   [DrawHighLightAddOn],15
	dec   [MenuListCount]
	call  PutBmp
	call  DrawCoverUP
	call  DrawAmenu
	call  DrawHighLight
	call  PrintDateGui 
	call  PrintTimeGui 
	call  PrintAMsg 
	call  BuffToScreen
	jmp   AdriveMenuLoop
@@:
	cmp   ah,0x1c
	jne   @F
	cmp   [MenuListCount],0
	jne   A1
 ;----------------------------------------------------;
 ; Load program from floppy.                          ;
 ;----------------------------------------------------;
	mov   esi,[FddFilesForMenu]
	mov   edi,0x800000
	call  [FloppyfileLoad]
	jc    GuiFddError
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  0x800000					
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
       ;mov   [keybuffer],0               
	jmp    AdriveMenuLoop
A1:
 ;----------------------------------------------------;
 ; Load program from floppy.                          ;
 ;----------------------------------------------------;
	mov   eax,[MenuListCount]
	mov   esi,[MenuListCount]
	inc   eax
	inc   esi 
	shl   esi,2
	shl   eax,3
	add   esi,eax
	sub   esi,12
	add   esi,[FddFilesForMenu]
	mov   edi,0x800000
	call  [FloppyfileLoad]
	jc    GuiFddError
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  0x800000					
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	;mov   [keybuffer],0               
	jmp   AdriveMenuLoop
 ;----------------------------------------------------;
 ; GuiFddError.                                       ;
 ;----------------------------------------------------;
GuiFddError:
	call  GuiCdError1
	jmp   ReStoreAmenu
@@:
	cmp   ah,0x01
	jne   AdriveMenuLoop
 ;----------------------------------------------------;
 ; Exit A: drive menu.                                ;
 ;----------------------------------------------------;
	popad
	ret


 ;----------------------------------------------------;
 ; DrawAmenu.                                         ;
 ;----------------------------------------------------;
DrawAmenu:
	pushad
	mov   [testcount2],0
	mov   [vesa_fontsmall_x],100
	mov   [vesa_fontsmall_y],135
nextFdd:				 
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	mov   [vesa_fontsmall_y],150
nextFdd1:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd2:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd3:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd4:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9
	call  print_vesa_string_small16  
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd5:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd6:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd7:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd8:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd9:				  
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd10:				   
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd11:				   
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd12:				   
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd13:				   
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	add   [testcount2],9  
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],100
	add   [vesa_fontsmall_y],15
nextFdd14:				   
	mov   esi,[progMenu1]
	add   esi,[testcount2] 
	call  print_vesa_string_small16
	popad
	ret

 ;----------------------------------------------------;
 ; GuiCdError1.                                       ;
 ;----------------------------------------------------;
GuiAErrorNoFiles:
	pushad
	mov   [MenuList],0
	mov   [DrawHighLightAddOn],0	  
	call  PutBmp
	call  DrawCoverUP
	call  PrintDateGui
	call  PrintTimeGui			       ; print time
	mov   [vesa_fontsmall_x],84
	mov   [vesa_fontsmall_y],135
	mov   esi,MsgAErrorNoFiles1
	call  print_vesa_string_small16
	mov   [vesa_fontsmall_x],84
	mov   [vesa_fontsmall_y],150
	mov   esi,MsgGuiCdError2
	call  print_vesa_string_small16
	call  DrawHighLight
	call  PrintEMsg
	call  BuffToScreen
 ;----------------------------------------------------;
 ; Main A: drive menu loop.                           ;
 ;----------------------------------------------------; 
GuiAErrorNoFilesLoop:
	call  PutBackSave
	call  PrintDateGui
	call  PrintTimeGui
	call  PrintEMsg
	call  BuffToScreen
	hlt
	call  [KeyPressedScanNW]
	cmp   ax,0
	je    GuiAErrorNoFilesLoop
	popad
	ret

 ;----------------------------------------------------;
 ; DrawHighLight.                                     ;
 ;----------------------------------------------------;
DrawHighLight:
	pushad
	mov   eax,44				       ; Menu high light start X
	mov   ebx,134				       ; Menu high light start Y
	add   ebx,[DrawHighLightAddOn]
	mov   ecx,16				       ; Menu high light H
	mov   edx,250				       ; Menu high light W
	call  DrawWindow			       ; Draw high light
	popad
	ret

 ;----------------------------------------------------;
 ; DrawCoverUP.                                       ;
 ;----------------------------------------------------;
DrawCoverUP:
	pushad
	mov   esi,[CoverUpColor] 
	mov   eax,80 
	mov   ebx,128
	mov   ecx,240
	mov   edx,180
	call  DrawFilledBoxVesa
	popad
	ret

 ;----------------------------------------------------;
 ; SaveBack.                                          ;
 ;----------------------------------------------------;
SaveBack:
	pushad
	mov   eax,420 ;500
	mov   ebx,150 ;160
	mov   ecx,195 ;16
	mov   edx,150 ;74
	call  SaveFilledBoxVesa
	popad
	ret

 ;----------------------------------------------------;
 ; SaveBack.                                          ;
 ;----------------------------------------------------;
PutBackSave:
	pushad
	mov   eax,420 ;500
	mov   ebx,150 ;160
	mov   ecx,195 ;16
	mov   edx,150 ;74
	call  PutSaveFilledBoxVesa
	popad
	ret
 ;----------------------------------------------------;
 ; PrintAMsg.                                      ;
 ;----------------------------------------------------;
PrintEMsg:
	pushad
	mov   [vesa_fontsmall_x],445 ;404
	mov   [vesa_fontsmall_y],200 ;160
	mov   esi,EMsg
	call  print_vesa_string_small16  
	popad
	ret
 ;----------------------------------------------------;
 ; PrintAMsg.                                      ;
 ;----------------------------------------------------;
PrintAMsg:
	pushad
	mov   [vesa_fontsmall_x],445 ;404
	mov   [vesa_fontsmall_y],200 ;160
	mov   esi,FddMsg
	call  print_vesa_string_small16  
	popad
	ret
 ;----------------------------------------------------;
 ; Data.                                              ;
 ;----------------------------------------------------;
MsgAErrorNoFiles1:   db "N0 GEX FILES ON DISK",0
FddMsg		     db ' Drive A:',0

progMenu1	      dd 0
FddFilesForMenu       dd 0
FileNumberCount       dd 0
testcount2	      dd 0
LineCount	      db 0
DrawHighLightAddOn    dd 0
