;=========================================================;
; Graphic3Functions                              05/04/06 ;
;---------------------------------------------------------;
; DexOS Lib's                                             ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
 ;'''''''''''''''''''''''''''''''''''''''''''''''''''';
 ; DrawFilledBoxTranVesaNoCorners                     ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;  Input:                                            ;
 ;       EAX = START X                                ;
 ;       EBX = START Y                                ;
 ;       ECX = BOX Y SIZE                             ;
 ;       EDX = BOX X SIZE                             ;
 ;       ESI = COLOR                                  ;
 ;                                                    ;
 ; Output:                                            ;
 ;                                                    ;
 ;....................................................;
DrawFilledBoxTranVesaNoCorners:
	pushad
	mov   [VesaStartX],eax
	mov   [VesaStartY],ebx
	mov   [VesaLineY],ecx
	sub   [VesaLineY],10	 
	mov   [VesaLineX],edx
	call  GetVesaScreenPointer
	mov   [VesaLineStart],edi
	mov   [VesaLineStartTotal],edi
	mov   edi,[VesaLineStartTotal]
	mov   esi,[VesaLineStartTotal]
	xor   edx,edx
	mov   dx,[ModeInfo_XResolution] 
	shl   edx,2
 ;----------------------------------------------------;
 ; Row 1.                                             ;
 ;----------------------------------------------------;
	add   edi,5*4
	add   esi,5*4
	mov   ecx,[VesaLineX]
	sub   ecx,10
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 2.                                             ;
 ;----------------------------------------------------;
	sub   edi,2*4
	add   edi,edx
	sub   esi,2*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,6
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 3.                                             ;
 ;----------------------------------------------------;
	sub   edi,1*4
	add   edi,edx
	sub   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,4
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 4.                                             ;
 ;----------------------------------------------------; 
	sub   edi,1*4
	add   edi,edx
	sub   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 5.                                             ;
 ;----------------------------------------------------;
	add   edi,edx
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransNoCorners
	mov   ecx,[VesaLineY]
	sub   edi,1*4
	add   edi,edx
	sub   esi,1*4
	add   esi,edx
	mov   [VesaLineStartTotal],edi
 ;----------------------------------------------------;
 ; Main box                                           ;
 ;----------------------------------------------------;
LineT32NoCorners:
	call  DrawLineTrans32BPP
	add   [VesaLineStartTotal],edx 
	mov   edi,[VesaLineStartTotal]
	mov   esi,[VesaLineStartTotal]
	loop  LineT32NoCorners 
 ;----------------------------------------------------;
 ; Row 1.                                             ;
 ;----------------------------------------------------;
	add   edi,1*4
	add   esi,1*4
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 2.                                             ;
 ;----------------------------------------------------;
	add   edi,edx
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 3.                                             ;
 ;----------------------------------------------------;
	add   edi,1*4
	add   edi,edx
	add   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,4
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 4.                                             ;
 ;----------------------------------------------------; 
	add   edi,1*4
	add   edi,edx
	add   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,6
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Row 5.                                             ;
 ;----------------------------------------------------;
	add   edi,2*4
	add   edi,edx
	add   esi,2*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,10
	call  DrawLineTransNoCorners
 ;----------------------------------------------------;
 ; Exit                                               ;
 ;----------------------------------------------------;
DrawFilledBoxTranVesaNoCornersExit:
	popad
	ret    

 ;'''''''''''''''''''''''''''''''''''''''''''''''''''';
 ; DrawFilledBoxTranLVesaNoCorners.                   ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;  Input:                                            ;
 ;       EAX = START X                                ;
 ;       EBX = START Y                                ;
 ;       ECX = BOX Y SIZE                             ;
 ;       EDX = BOX X SIZE                             ;
 ;       ESI = COLOR                                  ;
 ;                                                    ;
 ; Output:                                            ;
 ;                                                    ;
 ;....................................................;
DrawFilledBoxTranLVesaNoCorners:
	pushad
	mov   [VesaStartX],eax
	mov   [VesaStartY],ebx
	mov   [VesaLineY],ecx
	sub   [VesaLineY],10	 
	mov   [VesaLineX],edx
	call  GetVesaScreenPointer
	mov   [VesaLineStart],edi
	mov   [VesaLineStartTotal],edi
	mov   edi,[VesaLineStartTotal]
	mov   esi,[VesaLineStartTotal]
	xor   edx,edx
	mov   dx,[ModeInfo_XResolution] 
	shl   edx,2
 ;----------------------------------------------------;
 ; Row 1.                                             ;
 ;----------------------------------------------------;
	add   edi,5*4
	add   esi,5*4
	mov   ecx,[VesaLineX]
	sub   ecx,10
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 2.                                             ;
 ;----------------------------------------------------;
	sub   edi,2*4
	add   edi,edx
	sub   esi,2*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,6
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 3.                                             ;
 ;----------------------------------------------------;
	sub   edi,1*4
	add   edi,edx
	sub   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,4
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 4.                                             ;
 ;----------------------------------------------------; 
	sub   edi,1*4
	add   edi,edx
	sub   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 5.                                             ;
 ;----------------------------------------------------;
	add   edi,edx
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransLNoCorners
	mov   ecx,[VesaLineY]
	sub   edi,1*4
	add   edi,edx
	sub   esi,1*4
	add   esi,edx
	mov   [VesaLineStartTotal],edi
 ;----------------------------------------------------;
 ; Main box                                           ;
 ;----------------------------------------------------;
LineT32LNoCorners:
	call  DrawLineTransL32BPP
	add   [VesaLineStartTotal],edx 
	mov   edi,[VesaLineStartTotal]
	mov   esi,[VesaLineStartTotal]
	loop  LineT32LNoCorners 
 ;----------------------------------------------------;
 ; Row 1.                                             ;
 ;----------------------------------------------------;
	add   edi,1*4
	add   esi,1*4
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 2.                                             ;
 ;----------------------------------------------------;
	add   edi,edx
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,2
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 3.                                             ;
 ;----------------------------------------------------;
	add   edi,1*4
	add   edi,edx
	add   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,4
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 4.                                             ;
 ;----------------------------------------------------; 
	add   edi,1*4
	add   edi,edx
	add   esi,1*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,6
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Row 5.                                             ;
 ;----------------------------------------------------;
	add   edi,2*4
	add   edi,edx
	add   esi,2*4
	add   esi,edx
	mov   ecx,[VesaLineX]
	sub   ecx,10
	call  DrawLineTransLNoCorners
 ;----------------------------------------------------;
 ; Exit                                               ;
 ;----------------------------------------------------;
DrawFilledBoxTranLVesaNoCornersExit:
	popad
	ret    

 ;----------------------------------------------------;
 ; DrawLineTransNoCorners                             ;
 ;----------------------------------------------------;
DrawLineTransNoCorners:
	pushad	      
@@:
	lodsd
	shr   eax,1 
	and   eax,0x7f7f7f
	stosd
	loop  @b 
	popad
	ret

 ;----------------------------------------------------;
 ; DrawLineTransLNoCorners.                           ;
 ;----------------------------------------------------;
DrawLineTransLNoCorners:
	pushad
	mov   ebx,[os_light_add_32]
	and   ebx,0fefefeh
DrawLineTransLNoCornersLoop:
	lodsd
	and   eax,0fefefeh
	add   eax,ebx
 ;----------------------------------------------------;
 ; test red saturation.                               ;
 ;----------------------------------------------------; 
	test  eax,1000000h
	jz   @f
	or    eax,0ff0000h
@@:
 ;----------------------------------------------------;
 ; test green saturation.                             ;
 ;----------------------------------------------------;
	test  eax,010000h
	jz   @f
	or    eax,00ff00h
@@:
 ;----------------------------------------------------;
 ; test blue saturation.                              ;
 ;----------------------------------------------------; 
	test  eax,0100h
	jz   @f
	or    eax,0ffh
@@:	
	stosd
	loop DrawLineTransLNoCornersLoop
	popad
	ret

 ;'''''''''''''''''''''''''''''''''''''''''''''''''''';
 ; SaveFilledBoxVesa                    ;Draws a line ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;  Input:                                            ;
 ;       EAX = START X                                ;
 ;       EBX = START Y                                ;
 ;       ECX = BOX Y SIZE                             ;
 ;       EDX = BOX X SIZE                             ;
 ;                                                    ;
 ; Output:                                            ;
 ;                                                    ;
 ;....................................................;
SaveFilledBoxVesa:
	pushad
	mov   [VesaStartX],eax
	mov   [VesaStartY],ebx
	mov   [VesaLineY],ecx
	mov   [VesaLineX],edx
	call  GetVesaScreenPointer
	mov   [VesaLineStart],edi
	mov   [VesaLineStartTotal],edi
	mov   ecx,[VesaLineY]
	mov   edi,SaveBackBuffer
	mov   esi,[VesaLineStartTotal]
	xor   edx,edx
	mov   dx,[ModeInfo_XResolution] 
	shl   edx,2 
LineSave32:
	call  SaveLine32BPP
	add   [VesaLineStartTotal],edx
	mov   esi,[VesaLineStartTotal]
	loop  LineSave32
	popad
	ret 

 ;'''''''''''''''''''''''''''''''''''''''''''''''''''';
 ; PutSaveFilledBoxVesa                 ;Draws a line ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;  Input:                                            ;
 ;       EAX = START X                                ;
 ;       EBX = START Y                                ;
 ;       ECX = BOX Y SIZE                             ;
 ;       EDX = BOX X SIZE                             ;
 ;                                                    ;
 ; Output:                                            ;
 ;                                                    ;
 ;....................................................;
PutSaveFilledBoxVesa:
	pushad
	mov   [SaveBuffer],esi
	mov   [VesaStartX],eax
	mov   [VesaStartY],ebx
	mov   [VesaLineY],ecx
	mov   [VesaLineX],edx
	call  GetVesaScreenPointer
	
	mov   [VesaLineStart],edi
	mov   [VesaLineStartTotal],edi

	mov   ecx,[VesaLineY]
	mov   esi,SaveBackBuffer
	mov   edi,[VesaLineStartTotal]
	xor   edx,edx
	mov   dx,[ModeInfo_XResolution] 
	shl   edx,2 
LinePut32:
	call  SaveLine32BPP
	add   [VesaLineStartTotal],edx
	mov   edi,[VesaLineStartTotal]
	loop  LinePut32
	popad
	ret 


 ;----------------------------------------------------;
 ; DrawLineTrans32BPP.                                ;
 ;----------------------------------------------------;

SaveLine32BPP:
	push  eax
	push  edx
	push  ecx
	mov   ecx,[VesaLineX]
	cld
	rep   movsd
	pop   ecx
	pop   edx
	pop   eax
	ret



os_light_add_32   dd	003f3f3fh	; add 3eh on each RGB 8:8:8 channel
SaveBuffer	  dd 0
