;=========================================================;
; GUI                                            11/04/06 ;
;---------------------------------------------------------;
; Skinable Dashboard (gui) for DexOS.                     ;
;                                                         ;
; NOTE: This is not part of DexOS, But is a program       ;
; that run's on DexOS, as such it license is differant    ;
; from DexOS. See each .inc or .asm, that make up this    ;
; program, for the Copyright of the included code.        ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
use32
	ORG   0x400000				       ; where our program is loaded to
	jmp   start				       ; jump to the start of program.
	db    'DEX2'				       ; We check for this, to make shore it a valid Dex4u file.
	ColorOrder equ Dex4U
include 'Gif.inc' 
include 'Bmp.inc' 
msg1:	db " Vesa mode not supported",13
	db " Press any key to exit. ",13,0 
msg2:	db " Error!, file not found. ",13
	db " Press any key to exit. ",13,0 
msg3:	db " Error!, No comandline, BMP or GIF file found. ",13
	db " Press any key to exit. ",13,0 
msg4:	db " Error!, Not a valid BMP or GIF file. ",13
	db " Press any key to exit. ",13,0 

 ;----------------------------------------------------;
 ; Start of program.                                  ;
 ;----------------------------------------------------;

start:
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
 ;----------------------------------------------------;
 ; Get calltable address.                             ;
 ;----------------------------------------------------;
	mov   edi,Functions			      ; this is the interrupt
	mov   al,0				      ; we use to load the DexFunction.inc
	mov   ah,0x0a				      ; with the address to dex4u functions.
	int   40h 
 ;----------------------------------------------------;
 ; Do realmode int (vesa).                            ;
 ;----------------------------------------------------;
	mov   cx,0x4112
	call  [SetVesaMode]
	cmp   ah,1
	je    VesaError1
 ;----------------------------------------------------;
 ; Load vesa info.                                    ;
 ;----------------------------------------------------;
	call [LoadVesaInfo]
	mov   edi,VESA_Info
	mov   ecx,193
	cld
	cli
	rep   movsd
	sti
 ;----------------------------------------------------;
 ; uncompress.                                        ;
 ;----------------------------------------------------;        
uncompress:
	cmp   dword[file_area],'GIF8'
	jnz   ext2
	giftoimg file_area,header
	jmp   DrawImage
ext2:
	cmp   word[file_area],'BM'
	jnz   ImageError
	bmptoimg file_area,header
DrawImage:
 ;----------------------------------------------------;
 ; load image to screen buffer.                       ;
 ;----------------------------------------------------; 
	mov   [CoverUpColor],0x00031a6a
	mov   [HeaderAddOn],0
	call  PutBmp
	call  SaveBack
	xor   eax,eax
	mov   edx,eax
	mov   ecx,eax
	mov   ebx,eax
 ;----------------------------------------------------;
 ; Menu XY and size, color.                           ;
 ;----------------------------------------------------; 
	mov   [MenuList],0
	mov   [MenuListCount],0
	mov   eax,44				       ; Menu high light start X
	mov   ebx,131				       ; Menu high light start Y
	mov   ecx,26				       ; Menu high light H
	mov   edx,250				       ; Menu high light W
	call  DrawWindow			       ; Draw high light
	call  print_date			       ; print date & time
	call  PrintTimeGui 
	call  PrintMenuMsg
	call  BuffToScreen			       ; Send back buffer to screen.
 ;----------------------------------------------------;
 ; Main loop.                                         ;
 ;----------------------------------------------------; 
MouseLoop:
	call  PutBackSave
	call  PrintDateGui  
	call  PrintTimeGui
	call  PrintMenuMsg
	call  BuffToScreen
	hlt
	call  [KeyPressedScanNW]
	cmp   ax,0
	je    MouseLoop
	cmp   ah,0x50
	jne   @F
	cmp   [MenuList],210
	jae   MouseLoop
	add   [MenuList],30
	inc   [MenuListCount]
	call  PutBmp
	call  DrawWindow1 
	call  PrintDateGui  
	call  PrintTimeGui
	call  PrintMenuMsg
	call  BuffToScreen
	jmp   MouseLoop
@@:
	cmp   ah,0x48
	jne   @F
	cmp   [MenuList],0
	jbe   @F
	sub   [MenuList],30
	dec   [MenuListCount]
	call  PutBmp
	call  DrawWindow1
	call  PrintDateGui 
	call  PrintTimeGui 
	call  PrintMenuMsg 
	call  BuffToScreen
	jmp   MouseLoop
@@:
	cmp   ah,0x1c
	jne   @F
 ;----------------------------------------------------;
 ; Mplayer.                                           ;
 ;----------------------------------------------------; 
	cmp   [MenuListCount],0
	jne   NotMplayer
	call  MediaPlayerMenu
	jmp   DrawImage
NotMplayer:
	cmp   [MenuListCount],1
	jne   NotAdrive
 ;----------------------------------------------------;
 ; Adrive.                                            ;
 ;----------------------------------------------------; 
	mov   eax,'RRGE'
	xor   ecx,ecx
	call  [DirCommandGui]
	call  [FddMotorOff]
	jc    CdError0no
	mov   dword[progMenu1],esi
	mov   dword[FddFilesForMenu],edi
	mov   dword[FileNumberCount],ebx
	cmp   ebx,0
	je    AErrorNoFiles
	call  FloppyMenu 
	jc    CdError0no
	jmp   DrawImage 
CdError0no:
	call  GuiCdError1
	jmp   DrawImage
AErrorNoFiles:
	call  GuiAErrorNoFiles 
	jmp   DrawImage 
NotAdrive:
	cmp   [MenuListCount],2
	jne   NotHdrive
	mov   eax,'RRGE'
	xor   ecx,ecx
	call  [DirCommandGuiHdd32]
	jc    CdError0no
	mov   dword[progMenu1],esi
	mov   dword[FddFilesForMenu],edi
	mov   dword[FileNumberCount],ebx
	cmp   ebx,0
	je    AErrorNoFiles
	call  HddMenuGui 
	jc    CdError0no
	jmp   DrawImage
NotHdrive:
	cmp   [MenuListCount],3
	jne   NotCDdrive
 ;----------------------------------------------------;
 ; Fill in whats in cd root dir.                      ;
 ;----------------------------------------------------;
	mov   eax,'RRGE'
	xor   ecx,ecx
	call  [ReadCdDirGui]
	jc    CdError0no
 ;----------------------------------------------------;
 ; Fill in the returned vars.                         ;
 ;----------------------------------------------------;
	mov   dword[CdFilesForMenu],esi
	mov   dword[CdGuiFileCount],edi
	mov   dword[FileNumberCountCd],ebx
	cmp   ebx,0
	je    AErrorNoFiles
	call  CdMenu 
	jc    CdError0no
	jmp   DrawImage 
NotCDdrive:
	cmp   [MenuListCount],6
	je    DemoEnd
	cmp   [MenuListCount],7
	jne   NotReBoot
	call  [RebootSystem]
NotReBoot:	  
	jmp   MouseLoop
@@:
	jmp   MouseLoop
 ;----------------------------------------------------;
 ; Exit Menu.                                         ;
 ;----------------------------------------------------; 
DemoEnd:
	call  [SetDex4uFonts]
@@:
	ret
 ;----------------------------------------------------;
 ; Display Vesa Error message.                        ;
 ;----------------------------------------------------;
VesaError1:
	call  [SetDex4uFonts]
	mov   esi,msg1
	call  [PrintString]
	call  [WaitForKeyPress]
	jmp   @b
 ;----------------------------------------------------;
 ; Load file error.                                   ;
 ;----------------------------------------------------;
LoadfileError:
	mov   esi,msg2
	call  [PrintString]
	call  [WaitForKeyPress]
	jmp   @b
 ;----------------------------------------------------;
 ; information.                                       ;
 ;----------------------------------------------------; 
information: 
	mov   esi,msg3
	call  [PrintString]
	call  [WaitForKeyPress]
	jmp   @b
 ;----------------------------------------------------;
 ; Display Vesa Error message.                        ;
 ;----------------------------------------------------;
ImageError:
	call  [SetDex4uFonts]
	mov   esi,msg4
	call  [PrintString]
	call  [WaitForKeyPress]
	jmp   @b

 ;----------------------------------------------------;
 ; PutBmp                    ;put a bmp pic on screen ;
 ;----------------------------------------------------;
PutBmp:
	cmp   [ModeInfo_BitsPerPixel],24
	jne   Try32bits
	call  PutBmp32	;call  PutBmp24
	jmp   wehavedone1
Try32bits:
	cmp   [ModeInfo_BitsPerPixel],32
	jne   wehavedone1
	call  PutBmp32 
wehavedone1:
	ret 

 ;----------------------------------------------------;
 ; PutBmp32                                     32bpp ;
 ;----------------------------------------------------;
PutBmp32 :
	 pushad
	 push  es
	 mov   edi,VesaBuffer 
	 xor   eax,eax
	 mov   ecx,eax	
	 mov   ax,[ModeInfo_XResolution]
	 mov   cx,[ModeInfo_YResolution]
	 mul   ecx
	 mov   ecx,eax	
	 mov   eax,0xcfffffff
	 cld
	 cli
	 rep   stosd
	 sti
	 mov   esi,header
	 lodsd
	 mov   word[ImageX],ax
	 mov   ax,[ModeInfo_XResolution]
	 sub   ax,word[ImageX]
	 shl   eax,2
	 mov   dword[ImageXaddOn],eax
	 mov   esi,header
	 add   esi,4
	 lodsd
	 mov   word[ImageY],ax
	 mov   ax,[ModeInfo_YResolution]
	 sub   ax,word[ImageY]
	 mov   dword[ImageYaddOn],eax
	 mov   esi,header+8
	 add   esi,[HeaderAddOn]
	 mov   edi,VesaBuffer 
	 xor   ecx,ecx
	 mov   cx,word[ImageY]
PutImageLoop1:
	 push  ecx
	 mov   cx,word[ImageX]
@@:
	 lodsd
	 dec   esi
	 stosd
	 loop  @b
	 add   edi,[ImageXaddOn]
	 pop   ecx
	 loop  PutImageLoop1
	 pop   es
	 popad
	 ret

 ;----------------------------------------------------;
 ; PutBmp24                                     24bpp ;
 ;----------------------------------------------------;
PutBmp24:
	 pushad
	 push  es
	 mov   edi,VesaBuffer 
	 xor   eax,eax
	 mov   ecx,eax	
	 mov   ax,[ModeInfo_XResolution]
	 mov   cx,[ModeInfo_YResolution]
	 mul   ecx
	 mov   ecx,eax	
	 mov   eax,0xffffffff
	 cld
@@:	    
	 stosd
	 dec   edi
	 loop  @b
	 mov   esi,header
	 lodsd
	 mov   word[ImageX],ax
	 mov   ax,[ModeInfo_XResolution]
	 sub   ax,word[ImageX]
	 mov   dword[ImageXaddOn24],eax
	 shl   eax,2
	 sub   eax,dword[ImageXaddOn24]
	 mov   dword[ImageXaddOn],eax
	 mov   esi,header
	 add   esi,4
	 lodsd
	 mov   word[ImageY],ax
	 mov   ax,[ModeInfo_YResolution]
	 sub   ax,word[ImageY]
	 mov   dword[ImageYaddOn],eax
	 mov   esi,header+8
	 mov   edi,VesaBuffer 
	 xor   ecx,ecx
	 mov   cx,word[ImageY]
PutImageLoop2:
	 push  ecx
	 mov   cx,word[ImageX]
@@:
	 lodsd
	 dec   esi
	 stosd
	 dec   edi
	 loop  @b
	 add   edi,[ImageXaddOn]
	 pop   ecx
	 loop  PutImageLoop2
	 pop   es
	 popad
	 ret
 ;----------------------------------------------------;
 ; PrintMenuMsg.                                      ;
 ;----------------------------------------------------;
PrintMenuMsg:
	pushad
	mov   [vesa_fontsmall_x],434 ;404
	mov   [vesa_fontsmall_y],200 ;160
	mov   esi,MenuMsg
	call  print_vesa_string_small16  
	popad
	ret

 ;----------------------------------------------------;
 ; get_params.                                        ;
 ;----------------------------------------------------;
get_params:
	mov   esi,[command_line]
	mov   edi,FileToLoad
	lodsb
	cmp   al,' '
	jne   bad_params
	lodsb
	cmp   al,0x1f
	jbe   bad_params
	cmp   al,0x80
	jae   bad_params
	cmp   al,' '
	je    bad_params
	stosb
	mov   cx,7
Cliloop: 
	lodsb
	cmp   al,'.'
	je    DoExt1
	stosb
	loop  Cliloop
	lodsb
	cmp   al,'.'
	jne   bad_params
DoExt1:
	stosb
	mov   cx,3
	rep   movsb
	mov   al,0
	stosb
	mov   ax,word[es:edi-4]
	cmp   ax,'bm'
	je    get_params_ok
	cmp   ax,'BM'
	je    get_params_ok
	cmp   ax,'GI'
	je    get_params_ok
	cmp   ax,'gi'
	jne   bad_params
get_params_ok:
	clc
	ret
bad_params:
	stc
	ret
include 'Graphic.inc'
include 'Graphic3.inc'
include 'Time.inc'
include 'AdMenu.inc'
include 'HddMenu.inc'
include 'CdMenu.inc'
include 'MediaPlayer.inc'
include 'VesaText.inc'
include 'Font16.inc'
include 'Font8.inc'
include 'Images/buttons.inc'
include 'Images/Eqlize.inc'
include 'Images/Eqlize2.inc'


 ;----------------------------------------------------;
 ; Data.                                              ;
 ;----------------------------------------------------;
VERSION_STRING equ "0.01"
MenuMsg 	   db 'Version ',VERSION_STRING,0
EMsg		   db '  Error!',0
_logo		   db ' Dex4U Gif/Bmp Viewer, version ',VERSION_STRING,13,13
		   db ' Press any key to display image. ',13,0 
ImageX		   dw	0
ImageY		   dw	0
ImageXaddOn	   dd	0
ImageYaddOn	   dd	0
ImageXaddOn24	   dd	0
MenuList	   dd	0
HeaderAddOn	   dd	0
CoverUpColor	   dd	0
MenuListCount	   dd	0
command_line	   dd	0
FileToLoad:	   rb	80
file_area:
file  'Gui.gif'
kkk rd 10000
IM_END:
align 4 
header:
rd  800*600
align 4
SaveBackBuffer	   rd	   29250
save1		   rd	   1500
gif_hash_offset:
rd 4096+1						  ; hash area size for unpacking
include 'Dex.inc'					  ; Here is where we include our "Dex.inc" file

align 4 
VesaBuffer:

