;=========================================================;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ; FloppyMenu.                                        ;
 ;----------------------------------------------------;
HddMenuGui:
	pushad
 ;----------------------------------------------------;
 ; load image to screen buffer.                       ;
 ;----------------------------------------------------; 
ReStoreCmenu:
	call  PutBmp
	call  SaveBack
	xor   eax,eax
	mov   edx,eax
	mov   ecx,eax
	mov   ebx,eax
	mov   [MenuList],0
	mov   [MenuListCount],0
	mov   [LineCount],1
	mov   [testcount2],0
	mov   [DrawHighLightAddOn],0
	call  DrawCoverUP
	call  print_date			       ; print date 
	call  PrintTimeGui			       ; print time
	call  DrawAmenu
	call  DrawHighLight
	call  PrintHddMsg
	call  BuffToScreen
 ;----------------------------------------------------;
 ; Main A: drive menu loop.                           ;
 ;----------------------------------------------------; 
CdriveMenuLoop:
	call  PutBackSave
	call  PrintDateGui  
	call  PrintTimeGui
	call  PrintHddMsg
	call  BuffToScreen
	hlt
	call  [KeyPressedScanNW]
	cmp   ax,0
	je    CdriveMenuLoop
	cmp   ah,0x50
	jne   @F
	mov   ecx,[FileNumberCount]
	dec   ecx
	cmp   ecx,13
	jbe   NotOver15Hdd
	mov   ecx,13
NotOver15Hdd:
	cmp   [MenuListCount],ecx 
	jae   CdriveMenuLoop
	add   [DrawHighLightAddOn],15
	inc   [MenuListCount]
	call  PutBmp
	call  DrawCoverUP
	call  DrawAmenu
	call  DrawHighLight
	call  PrintDateGui  
	call  PrintTimeGui
	call  PrintHddMsg
	call  BuffToScreen
	jmp   CdriveMenuLoop
@@:
	cmp   ah,0x48
	jne   @F
	cmp   [MenuListCount],0
	jbe   CdriveMenuLoop
	sub   [DrawHighLightAddOn],15
	dec   [MenuListCount]
	call  PutBmp
	call  DrawCoverUP
	call  DrawAmenu
	call  DrawHighLight
	call  PrintDateGui 
	call  PrintTimeGui  
	call  PrintHddMsg
	call  BuffToScreen
	jmp   CdriveMenuLoop
@@:
	cmp   ah,0x1c
	jne   @F
	cmp   [MenuListCount],0
	jne   A1Hdd
 ;----------------------------------------------------;
 ; Load program from floppy.                          ;
 ;----------------------------------------------------;
	mov   edi,[FddFilesForMenu]
	mov   edx,0x800000
	call  [HddfileLoad]
	jc    GuiHddError
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  0x800000					
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
       ;mov   [keybuffer],0               
	jmp   CdriveMenuLoop
A1Hdd:
 ;----------------------------------------------------;
 ; Load program from floppy.                          ;
 ;----------------------------------------------------;
	mov   eax,[MenuListCount]
	mov   edi,[MenuListCount]
	inc   eax
	inc   edi 
	shl   edi,2
	shl   eax,3
	add   edi,eax
	sub   edi,12
	add   edi,[FddFilesForMenu]
	mov   edx,0x800000
	call  [HddfileLoad]
	jc    GuiHddError
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  0x800000					
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	;mov   [keybuffer],0               
	jmp   CdriveMenuLoop
 ;----------------------------------------------------;
 ; GuiHddError.                                       ;
 ;----------------------------------------------------;
GuiHddError:
	call  GuiCdError1
	jmp   ReStoreCmenu
@@:
	cmp   ah,0x01
	jne   CdriveMenuLoop
 ;----------------------------------------------------;
 ; Exit A: drive menu.                                ;
 ;----------------------------------------------------;
	popad
	ret

 ;----------------------------------------------------;
 ; PrintMpMsg.                                        ;
 ;----------------------------------------------------;
PrintHddMsg:
	pushad
	mov   [vesa_fontsmall_x],445 ;404
	mov   [vesa_fontsmall_y],200 ;160
	mov   esi,HddMsg
	call  print_vesa_string_small16  
	popad
	ret


HddMsg		  db ' Drive C:',0