;=========================================================;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

DrawMouse:
	pushad
	push  es
	push  ds
	push  eax
	mov   ax,8h
	mov   es,ax
	pop   eax
	call  [VesaRes]
	pop  ds
	pop  es
	popad
	ret

; eax = x
; ebx = y
DrawMouse24:
	xor   edx,edx
	mov   dx,[ModeInfo_BytesPerScanLine]
	imul  ebx,edx				  ; ebx = y * y multiplier MouseBack
	lea   edi,[eax+eax*2]			  ; edi = x*3
	add   edi,[ModeInfo_PhysBasePtr]
	add   edi,ebx				   ; ebx = where to put pixel in memory
	mov   [SaveEdi],edi
	mov   esi,MouseBack
	mov   ecx,24
DrawMouse24Loop1S:
	push  ecx
	mov   ecx,16
	xor   eax,eax
DrawMouse24Loop2S:
	mov   al,byte[es:edi+2]
	shl   eax, 16
	mov   ax,word[es:edi]
	mov   dword[ds:esi],eax
	inc   edi
	inc   edi
	inc   edi
	inc   esi
	inc   esi
	inc   esi
	inc   esi
	loop  DrawMouse24Loop2S
	pop   ecx
	sub   edi,16*3
	add   edi,edx
	loop  DrawMouse24Loop1S
	mov   edi,[SaveEdi]
	mov   esi,mouse3_bmp32
	mov   ecx,24
DrawMouse24Loop1:
	push  ecx
	mov   ecx,16
DrawMouse24Loop2:
	lodsd
	cmp   eax,0
	je    NoPixel
	mov   [es:edi], ax
	shr   eax, 16
	mov   [es:edi+2], al
NoPixel:
	inc   edi
	inc   edi
	inc   edi
	loop  DrawMouse24Loop2
	pop   ecx
	sub   edi,16*3
	add   edi,edx
	loop  DrawMouse24Loop1
	ret


   
; eax = x
; ebx = y
DrawMouse32:  
	xor   edx,edx
	mov   dx,[ModeInfo_BytesPerScanLine]
	imul  ebx,edx  
	lea   edi,[ebx+eax*4]  
	add   edi,[ModeInfo_PhysBasePtr]   
	mov   [SaveEdi],edi
	mov   esi,MouseBack
	mov   ecx,24
DrawMouse32Loop1S:
	push  ecx
	mov   ecx,16
DrawMouse32Loop2S:
	mov   eax,dword[es:edi]
	mov   dword[ds:esi],eax
	inc   edi
	inc   edi
	inc   edi
	inc   edi
	inc   esi
	inc   esi
	inc   esi
	inc   esi
	loop  DrawMouse32Loop2S
	pop   ecx
	sub   edi,16*4
	add   edi,edx
	loop  DrawMouse32Loop1S
	mov   esi,mouse3_bmp32
	mov   edi,[SaveEdi]
	mov   ecx,24
DrawMouse32Loop1:
	push  ecx
	mov   ecx,16
DrawMouse32Loop2:
	lodsd
	cmp   eax,0
	je    NoPixel32
	mov   [es:edi],eax
NoPixel32:
	inc   edi
	inc   edi
	inc   edi
	inc   edi
	loop  DrawMouse32Loop2
	pop   ecx
	sub   edi,16*4
	add   edi,edx
	loop  DrawMouse32Loop1
	ret

ReStoreMouseBAackGround:
	pushad
	push  es
	push  ds
	push  eax
	mov   ax,8h
	mov   es,ax
	pop   eax
	call  [VesaResRMBG]
	pop  ds
	pop  es
	popad
	ret

ReStoreMouseBAackGround24:
	xor   edx,edx
	mov   dx,[ModeInfo_BytesPerScanLine]
	mov   edi,[SaveEdi]
	mov   esi,MouseBack
	mov   ecx,24
RsMouseBg24Loop1:
	push  ecx
	mov   ecx,16
RsMouseBg24Loop2:
	lodsd
	mov   [es:edi],ax
	shr   eax, 16
	mov   [es:edi+2],al
	inc   edi
	inc   edi
	inc   edi
	loop  RsMouseBg24Loop2
	pop   ecx
	sub   edi,16*3
	add   edi,edx
	loop  RsMouseBg24Loop1
	ret

ReStoreMouseBAackGround32:
	xor   edx,edx
	mov   dx,[ModeInfo_BytesPerScanLine]
	mov   esi,MouseBack
	mov   edi,[SaveEdi]
	mov   ecx,24
RsMouseBg32Loop1:
	push  ecx
	mov   ecx,16
RsMouseBg32Loop2: 
	lodsd
	mov   [es:edi],eax
	inc   edi
	inc   edi
	inc   edi
	inc   edi
	loop  RsMouseBg32Loop2
	pop   ecx
	sub   edi,16*4
	add   edi,edx
	loop  RsMouseBg32Loop1
	ret


