;=========================================================;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

 ;----------------------------------------------------;
 ; PrintTimeGui.      ; prints the time in text mode  ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;   Input:                                           ;
 ;          none.                                     ;
 ;  Output:                                           ;
 ;          prints the time in text mode.             ;
 ;                                             (100%) ;
 ;....................................................; 
PrintTimeGui:
	push  es
	pushad
	mov   [vesa_fontsmall_x],500
	mov   [vesa_fontsmall_y],160
	call  [GetTime]
	mov   [minute],ah
	mov   [second],al
	shr   eax,16
	mov   [hour],al
	mov   al,[hour]
	call  bcd_to_ASCII
	mov   bx,[val]
	mov   al,bl
	mov   edx,0x00007fde ;text color
	call  PrintVesaChar16
	mov   al,bh
	call  PrintVesaChar16
	mov   al,":"
	call  PrintVesaChar16
	mov   al,[minute]
	call  bcd_to_ASCII
	mov   bx,[val]
	mov   al,bl
	call  PrintVesaChar16
	mov   al,bh
	call  PrintVesaChar16
	mov   al,":"
	call  PrintVesaChar16
	mov   al,[second]
	call  bcd_to_ASCII
	mov   bx,[val]
	mov   al,bl
	call  PrintVesaChar16
	mov   al,bh
	call  PrintVesaChar16
	popad
	pop   es
	ret

 ;----------------------------------------------------;
 ; prints date        ; prints the date in text mode  ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;   Input:                                           ;
 ;          none.                                     ;
 ;  Output:                                           ;
 ;          prints the date in text mode.             ;
 ;                                             (100%) ;
 ;....................................................; 
print_date:
	push  es
	pushad
	call  [GetDate]  
	mov   [month],ah
	mov   [day],al
	shr   eax,16 
	mov   [century],ah
	mov   [year],al     
	popad
	pop   es
PrintDateGui:
	pushad
	mov   [vesa_fontsmall_x],404
	mov   [vesa_fontsmall_y],160
	mov   al,[day]
	call  bcd_to_ASCII
	mov   bx,[val]
	mov   al,bl
	mov   edx,0x00007fde ;text color
	call  PrintVesaChar16
	mov   al,bh
	call  PrintVesaChar16
	mov   al,":"
	call  PrintVesaChar16
	mov   al,[month]
	call  bcd_to_ASCII
	mov   bx,[val]
	mov   al,bl
	call  PrintVesaChar16
	mov   al,bh
	call  PrintVesaChar16
	mov   al,":"
	call  PrintVesaChar16
	mov   al,[century]
	call  bcd_to_ASCII
	mov   bx,[val]
	mov   bx,0x3032
	mov   al,bl
	call  PrintVesaChar16
	mov   al,bh
	call  PrintVesaChar16
	mov   al,[year]
	call  bcd_to_ASCII
	mov   bx,[val]
	mov   al,bl
	call  PrintVesaChar16
	mov   al,bh
	call  PrintVesaChar16
	popad
	ret


 ;----------------------------------------------------;
 ; bcd_to_ASCII         ;converts bcd number to ASCII ;
 ;----------------------------------------------------;
 ;                                                    ;
 ;   Input:                                           ;
 ;         Bcd number in al.                          ;
 ;  Output:                                           ;
 ;         ASCII number in val.                       ;
 ;                                             (100%) ;
 ;....................................................;
bcd_to_ASCII:
       pushad						;start of convert
       mov  ah,al					;copy AL to AH
       and  ax,0f00fh					;mask bits
       mov  cl,4					;CL=04 for shift
       shr  ah,cl					;shift right AH to get unpacked BCD
       or   ax, 3030h					;combine with 30 to get ASCII
       xchg ah,al					;swap for ASCII storage convention
       mov  [val],ax					;store the ASCII value in VAL
       popad 
       ret


 ;====================================================;
 ; Data.                                              ;
 ;====================================================;
val:	   dw 0,0

hour:	   db 0
minute:    db 0
second:    db 0

century:   db 0
year:	   db 0
month:	   db 0
day:	   db 0