;=========================================================;
; Mouse                                          11/12/03 ;
;---------------------------------------------------------;
; PS2MouseInit functions.                                 ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
;====================================================;
; PS2MouseInit.                                      ;
;====================================================;
PS2MouseInit:
	pusha
	cli
	mov   bl,0xa8				     ; enable mouse cmd
	call  keyboard_cmd
	call  keyboard_read			     ; read status return
	mov   bl,0x20				     ; get command byte
	call  keyboard_cmd
	call  keyboard_read
	or    al,3				     ; enable keyb. and mouse interrupt
	mov   bl,0x60				     ; write back command byte
	push  ax
	call  keyboard_cmd
	pop   ax
	call  keyboard_write
	mov   bl,0xd4				     ; next command is for mouse
	call  keyboard_cmd
	mov   al,0f4h				     ; enable mouse device
	call  keyboard_write
	call  keyboard_read			     ; read status return
	mov   bl,0xd4				     ; next command is for mouse
	call  keyboard_cmd
	mov   al,0E8h				     ; enable mouse device
	call  keyboard_write
	call  keyboard_read			     ; read status return
	mov   bl,0xd4				     ; next command is for mouse
	call  keyboard_cmd
	mov   al,03h				     ; enable mouse device
	call  keyboard_write
	call  keyboard_read			     ; read status return
	mov   bl,0xd4				     ; next command is for mouse
	call  keyboard_cmd
	mov   al,0E7h				     ; enable mouse device
	call  keyboard_write
	call  keyboard_read			     ; read status return
	mov   bl,0xa7				     ; disable mouse
	call  keyboard_cmd
	sti
;====================================================;
; enable irq 12 on pic2.                             ;
;====================================================;
	;mov   cl,4                                  ; enable irq 12 on pic2
	;mov   dx,0xa1
	;mov   bl,1
	;shl   bl,cl
	;not   bl
	;in    al,dx
	;and   al,bl
	;out   dx,al
;====================================================;
; enable irq 2.                                      ;
;====================================================;
	;in    al,0x21
	;and   al,11111011b                          ; enable irq 2 (cascaded to irq8+)
	;out   0x21,al                               ; just in case it isn't
	
	mov   [PS2Mouse],1 
	popa
	ret

;====================================================;
; keyboardRead.                                      ;
;====================================================;
keyboard_read:
	push  ecx
	push  edx
	mov   ecx,0xffff
key_read_loop:
	in    al,0x64
	test  al,1
	jnz   key_read_ready
	loop  key_read_loop
	mov   ah,1
	jmp   key_read_exit
key_read_ready:
	push  ecx
	mov   ecx,32
key_read_delay:
	loop  key_read_delay
	pop   ecx
	in    al,0x60
	xor   ah,ah
key_read_exit:
	pop   edx
	pop   ecx
	ret

;====================================================;
; keyboardWrite.                                     ;
;====================================================;
keyboard_write:
	push  ecx
	push  edx
	mov   dl,al
	mov   ecx,0ffffh
kbd_wrt_loop1:
	in    al,0x64
	test  al,0x20
	jz    kbd_wrt_ok1
	loop  kbd_wrt_loop1
	mov   ah,1
	jmp   kbd_wrt_exit
kbd_wrt_ok1:
	in    al,0x60
	mov   ecx,0xffff
kbd_wrt_loop:
	in    al,0x64
	test  al,2
	jz    kbd_wrt_ok
	loop  kbd_wrt_loop
	mov   ah,1
	jmp   kbd_wrt_exit
kbd_wrt_ok:
	mov   al,dl
	out   0x60,al
	mov   ecx,0ffffh
kbd_wrt_loop3:
	in    al,64h
	test  al,2
	jz    kbd_wrt_ok3
	loop  kbd_wrt_loop3
	mov   ah,1
	jmp   kbd_wrt_exit
kbd_wrt_ok3:
	mov   ah,8
kbd_wrt_loop4:
	mov   ecx,0xffff
kbd_wrt_loop5:
	in    al,64h
	test  al,1
	jnz   kbd_wrt_ok4
	loop  kbd_wrt_loop5
	dec   ah
	jnz   kbd_wrt_loop4
kbd_wrt_ok4:
	xor   ah,ah
kbd_wrt_exit:
	pop   edx
	pop   ecx
	ret

;====================================================;
; keyboard_cmd.                                      ;
;====================================================;
keyboard_cmd:
	xor   eax,eax
	mov   ecx,0xffff
cmd_wait:
	in    al,64h
	test  al,2
	jz    cmd_send
	loop  cmd_wait

	jmp   cmd_error
cmd_send:
	mov   al,bl
	out   64h,al
	mov   ecx,0xffff
cmd_accept:
	in    al,0x64
	test  al,2
	jz    cmd_ok
	loop  cmd_accept
cmd_error:
	mov   ah,1
	jmp   cmd_exit
cmd_ok:
	xor   ah,ah
cmd_exit:
	ret