;=========================================================;
; Video                                          11/12/03 ;
;---------------------------------------------------------;
; Re programs the text mode & fonts..                     ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;
 ;----------------------------------------------------;
 ; Test4dDos.                                         ;
 ;----------------------------------------------------;
Test4dDos:
	push ax
	cmp   [BootProTest],0xff
	je    NoDosFound
	mov   ah,19h
	int   21h
	add   al,41h
	mov   [BootNumber],al
	mov   [DosLoaded],1
NoDosFound:
	pop   ax
	ret

 ;----------------------------------------------------;
 ; Resizes text.                                      ;
 ;----------------------------------------------------;
TextReSize:
	pushad
	mov   ax,1112h					 ; Set 80x50 mode
	mov   bl,0
	int   10h
	call  ReProgamFonts  
	popad 
	ret

 ;----------------------------------------------------;
 ; Reprogram fonts.                                   ;
 ;----------------------------------------------------;
ReProgamFonts:
	push es
	mov   ax,ds
	mov   es,ax
	mov   bp,DexFont 
	mov   cx,00FFh
	xor   dx,dx
	mov   bx,0800h
	mov   ax,1100h
	int   10h					 ; ReProgams Fonts
	pop   es
	ret

 ;----------------------------------------------------;
 ; Test Boot Drive.                                   ;
 ;----------------------------------------------------;
TestBootDrive:
	push ds
	pusha
	mov   si,VESA_Info
	mov   dl,00h
	mov   ax,0x4b01
	int   13h
	jc    DtestError
	mov   si,VESA_Info
	add   si,2
	lodsb
	dec   si
	cmp   byte[ds:si],81h
	jae   NoEmeulation
	mov   byte[DriveNumber],1
NoEmeulation:
DtestError:
	popa
	pop   ds
	ret

 ;----------------------------------------------------;
 ; Get Ram Size.   ;conventional memory size (in KBs) ;
 ;----------------------------------------------------;
ConvMemory:
	int   12h
	movzx eax, ax		 
	mov   dword[ConvMemorySize],eax 	   
	ret

 ;----------------------------------------------------;
 ; Get Ram Size.                                      ;
 ;----------------------------------------------------;

GetRamSize:
	mov   ax,0xe801 			  
	int   15h
	jc    @f
	movzx ebx, bx
	shl   ebx,6
	movzx eax, ax
	add   ebx,eax
	mov   [ExtMemorySize],ebx
	call  TotalRam
@@:
	ret

 ;----------------------------------------------------;
 ; TotalRam.                                          ;
 ;----------------------------------------------------;
TotalRam:
	shr   ebx,10
	inc   ebx
	;test  ebx,1
	;jnz   @f
	mov   [TotalMemoryMB],ebx
	ret
@@:	inc   ebx
	mov   [TotalMemoryMB],ebx
	ret

 ;----------------------------------------------------;
 ; DetectPcIBus.                                      ;
 ;----------------------------------------------------;
DetectPcIBus:
	mov   ax,0xb101 		      
	int   1ah			       
	jc    NoPci 
	cmp   edx,0x20494350			 
	jne   NoPci
	mov   byte[PciBusPresent],1
NoPci:
	ret

 ;----------------------------------------------------;
 ; Hide cursor.                                       ;
 ;----------------------------------------------------;
HideCursor:
	push  cx
	push  ax
	mov   ch,0x20
	mov   cl,0x20
	mov   ah,1
	mov   ah,1
	int   10h
	pop   ax
	pop   cx
	ret

 ;----------------------------------------------------;
 ; ReadPalette.                                       ;
 ;----------------------------------------------------;
ReadPalette:
	pusha
	mov   dx,StPalette
	mov   ah,10h
	mov   al,9
	xor   bx,bx
	int   10h
	popa
	ret
 ;----------------------------------------------------;
 ; Data.                                              ;
 ;----------------------------------------------------;

StPalette rb 20