;=========================================================;
; Vesa2                                          11/12/03 ;
;---------------------------------------------------------;
; Tests and sets up vesa, (runs in realmode).             ;
; Add on for vesa3 85hz                                   ;
;                                                         ;
; (c) Craig Bamford, All rights reserved.                 ;
;=========================================================;

;====================================================;
; Vesa.                                              ;
;====================================================;
Vesa:
	mov  dword [VESAInfo_Signature],'VBE2'
	mov  ax,4f00h				  
	mov  di,VESA_Info		
	int  10h
 
	cmp  ax,004Fh
	jne  novesa	

	mov  ax,4f01h		   ; set vesa screen mode information
	mov  di,Mode_Info	
	mov  cx,0x4912					    
	and  cx,0xfff 
	int  10h 

	cmp  dword [VESAInfo_Signature], 'VESA'
	jne  novesa
	mov   byte[NoVesa],0
	clc 
	ret 

;====================================================;
; VesaModeSet.                                       ;
;====================================================;  
VesaModeSet:
	mov   ecx,[PIXCLOC]
	xor   eax, eax
	mov   ax, [CRTC]	       ; horizontal total
	xor   ebx, ebx
	mov   bx, [VERTOTA]	       ; vertikal total
	mul   ebx
	mov   ebx,eax
	mov   eax,ecx		       ; pixelclock
	;mov   esi,10
	;xor   edx, edx
	;div   esi
	xor   edx, edx
	div   ebx
	mov   [REFRATE], ax	       ; RefreshRate=Pixelclock/(HTotal*Vtotal)
	mov  ax,4f02h		       ; set vesa screen mode
	mov  bx,0x4912		       ; To program CRT we need to set bit 11 to 1,
				       ; so "0x4112" becomes "0x4912".
	mov  di,CRTcInfoBlock	       ; Point di to the CRT info block
	int  10h
	cmp ax,004Fh
	jne novesa
	mov   byte[NoVesa],0
	clc 
	ret

novesa:
	mov   byte[NoVesa],1
	stc
	ret


NoVesa	db  0

;These setings are for vesa3 640x480 32bpp 85Hz
CRTcInfoBlock:
CRTC	dw 832			; horizontal Total       in Pixel
HORIANF dw 700			; horizontal  Sync-Start in Pixel
HORIEND dw 64			; horizontal  Sync-End   in Pixel
VERTOTA dw 509			; vertical    Total       in Lines
VERTANF dw 480			; vertical    Sync-Start in Lines
VERTEND dw 25			; vertical    Sync-End   in Lines
DOIFLAG db 0ch			; Flag (interlaced,doubleScan,polarity)
PIXCLOC dd 35993000		; Pixel clock in hz
REFRATE dw 8499 		; Refresh-Rate in 0.01 hz
Reservd rb 40