;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Project          :   DexOS                                                       ;;
;; Ver              :   00.03                                                       ;;
;; Author           :   Dex (Craig Bamford)                                         ;;
;; Website          :   www.dex4u.com                                               ;;
;; Forum            :   http://dex.7.forumer.com                                    ;;
;; wiki             :   http://tonymac.asmhackers.net/Wiki/pmwiki.php               ;;
;; Date             :   April 28, 2008                                              ;;
;; Filename         :   Kernel32.asm                                                ;;
;; Assembler Command:   FASM kernel32.asm kernel32.exe                              ;;
;; Copy Right Owner :   Craig Bamford, will act on behalf of "Team DexOS"           ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Team DexOS       :   0x4e71, bubach, crc, Dex, hidnplayr, jas2o, roboman         ;;
;;                  :   Solidus, smiddy, tony(mac), viki.                           ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Disclaimer       :                                                               ;;
;; This software is provided "AS IS" without warranty of any kind, either           ;;
;; expressed or implied, including, but not limited to, the implied                 ;;
;; warranties of merchantability and fitness for a particular purpose. The          ;;
;; entire risk as to the quality and performance of this software is with           ;;
;; you.                                                                             ;;
;; In no event will the author's, distributor or any other party be liable to       ;;
;; you for damages, including any general, special, incidental or                   ;;
;; consequential damages arising out of the use, misuse or inability to use         ;;
;; this software (including but not limited to loss of data or losses               ;;
;; sustained by you or third parties or a failure of this software to operate       ;;
;; with any other software), even if such party has been advised of the             ;;
;; possibility of such damages.                                                     ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                                  ;;
;; Thanks to  0x4e71, bubach, crc, hidnplayr, jas2o, roboman, Solidus, smiddy       ;;
;;            tony(mac), viki.                                                      ;;
;;                                                                                  ;;
;; Also to    Alexei A. Frounze, Tomasz Grysztar, Ontanu Bogdan Valenti.            ;;
;;                                                                                  ;;
;; Also a thanks to  the many forums i am a member of, i would like to thank anyone ;;
;; who  has heled me, by answering my ? (too many too list).                        ;;
;;                                                                                  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	format MZ
	use16

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 16-bit real mode.                                                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	jmp   start
	include 'RealMode\DmaBuffer.inc'
	include 'RealMode\Vesa2_info.inc'  
	include 'RealMode\386.inc'
	include 'RealMode\RmodeInfo.inc'
	include 'RealMode\Ata_Atapi16.inc'
	include 'RealMode\A20.inc'
	include 'RealMode\Vesa2.inc'  
	include 'RealMode\DexFonts.inc'  
	include 'RealMode\RmFunctions.inc'
	include 'RealMode\Mouse.inc' 
	include 'RealMode\TurnOff.inc'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; End of realmode Include Files.                                                   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:
	push  cs
	pop   ds
	push  ds
	pop   es
	mov   [BootNumber],dl
	mov   [BootProTest],dh
	call  GetAtaPiDrive
	call  Atapi_Address
	call  TestBootDrive
	call  Test4dDos
	call  ConvMemory
	call  GetRamSize
	call  DetectPcIBus
	call  PS2MouseInit
	call  ReadPalette
	call  Enable_A20
	call  TextReSize
	call  HideCursor   
	call  Vesa
	xor   ebx,ebx
	mov   bx,ds						    
	shl   ebx,4						    
	mov   [BaseAddOn],ebx					     
	mov   eax,ebx
	mov   [sys_code_1 + 2],ax				     
	mov   [sys_data_1 + 2],ax
	mov   [Real_code_1 + 2],ax				     
	mov   [Real_data_1 + 2],ax
	shr   eax,16
	mov   [sys_code_1 + 4],al
	mov   [sys_data_1 + 4],al
	mov   [Real_code_1 + 4],al
	mov   [Real_data_1 + 4],al
	mov   [sys_code_1 + 7],ah
	mov   [sys_data_1 + 7],ah
	mov   [Real_code_1 + 7],ah
	mov   [Real_data_1 + 7],ah
	add   ebx,gdt						  
	mov   [gdtr + 2],ebx
	add   ebx,idt - gdt					  
	mov   [idtr + 2],ebx
	cli
	mov   ax,cs
	mov   [RealModeCS],ax
	lgdt  [gdtr]						   
	lidt  [idtr]
	mov   eax,cr0						  
	or    al,1
	mov   cr0,eax
	jmp   sys_code:do_pm	   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 32-bit protected mode.                                                           ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                                

	use32
do_pm:
	xor   edi,edi
	xor   esi,esi
	mov   ax,sys_data
	mov   ds,ax
	mov   ss,ax
	nop
	mov   es,ax
	mov   gs,ax
	mov   ax,8h
	mov   fs,ax
	jmp   inc_over2

RealModeIP:
	dw 0
RealModeCS:
	dw 0

ridtr:	dw 0xFFFF			  
	dd 0	
			  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; global descriptor table (GDT).                                                   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

gdtr:	dw gdt_end - gdt - 1		   
	dd gdt				   

include 'Kernel\Gdt.inc'       

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; interrupt descriptor table (IDT).                                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

idtr:	dw idt_end - idt - 1		   
	dd idt	

include 'Kernel\Idt.inc'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include Files.                                                                   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 

	include 'Functions\Info.inc'
	include 'Functions\Msg.inc'
	include 'Kernel\Pic.inc'
	include 'Kernel\Isr.inc'
	include 'Functions\RmInt.inc'
	include 'Drivers\Dma.inc'
	include 'Drivers\keyboard.inc'
	include 'Drivers\keymapUK.inc'
	include 'Drivers\Gameskey.inc' 
	include 'Functions\MouseFunction.inc' 
	include 'Functions\TextMode50.inc'
	include 'Functions\IntFunctions.inc'
	include 'Functions\KernelFunctions.inc'
	include 'Functions\Function.inc'
	include 'Functions\Fat32.inc'
	include 'Drivers\FddInfo.inc' 
	include 'Drivers\Fdd.inc'
	include 'Functions\Fat12.inc'
	include 'Functions\Fat16.inc'
	include 'Functions\FatData.inc'
	include 'Cli\Terminal.inc'
	include 'Functions\Convert.inc'
	include 'Cli\Run.inc' 
	include 'Cli\Del.inc'
	include 'Functions\ReadCd.inc'
	include 'Functions\Pci.inc'
	;include 'Functions\Menu.inc'
	include 'Functions\Vdrive.inc'
	include 'Functions\AutoDex.inc'
	include 'Functions\TimeDate.inc'
	include 'Ver\Ver.inc'
	include 'Cli\CommandLineCalls.inc'
	include 'Cli\Command.inc'

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Include File End.                                                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

inc_over2:	  
	call  remap_pic
	call  unmask_irqs
	call  Fdd_motor_off
	mov   [keyBoardStatus],0xb0	 ;this crashs some PC, If so try dehighlighting this.
	call  SetKeyBoardLeds		 ;and this
	mov   [ModListNumbers],1
	mov   [DescriptorsNumbers],6
	mov   eax,dword[TotalMemoryMB]
	mov   dword[TopOfFreeMemoryInMB],eax
	shl   eax,10
	shl   eax,10
	mov   dword[TopOfFreeMemoryWithBase],eax
	sub   eax,[BaseAddOn]
	mov   dword[TopOfFreeMemoryWithOutBase],eax
	mov   dword[TopOfFreeLowMemoryWithBase],0x200000
	mov   dword[TopOfFreeLowMemoryWithOutBase],0x200000
	mov   eax,dword[TopOfFreeLowMemoryWithBase]
	sub   eax,[BaseAddOn]
	mov   dword[TopOfFreeLowMemoryWithOutBase],eax
	mov   dword[ImageLoadAddrVar],0x400000
	mov   [GuiStartup],0
	mov   [textcolor],0x07
	mov   [PromptLetter],'A'
	cmp   [BootNumber],80h
	je    Hddloaded
	cmp   [BootNumber],'C'
	jne   @f
Hddloaded:
	call  LoadMBR
	cmp   [FatID],0xff
	je    @f
	mov   [PromptLetter],'C'
@@:
	cmp   [ModeInfo_BitsPerPixel],24
	jne   @f
	mov   [bpp],1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Zero uninitialized buffers.                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
@@:
	mov   edi, HddBuffer
	xor   eax,eax
	mov   ecx,1024*1024/2
	cld
	rep   stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Set default Fdd read/write function.                                             ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov   eax,FddReadB    ;FddReadPM          ; Change for this "mov   eax,"FddReadB" to use BIOS Fdd at bootup.
	mov   [FddRead],eax
	mov   eax,FddWriteB   ;FddWritePM         ; Change for this "mov   eax,"FddWriteB" to use BIOS Fdd at bootup.
	mov   [FddWrite],eax
	mov   [MissChangTest],1 		  ; Change this to 0 if you use FddReadPM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Ready the UI.                                                                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  cls_text
	call  SetPalette  
	call  ReadyPrompt
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Set cursor.                                                                      ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	push  ecx
	push  eax
	mov   ch,0x0b 
	mov   cl,0x0c 
	mov   ah,1
	call  RealModeInt10h
	pop   eax
	pop   eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; StartCommand.                                                                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  SetDex4uFonts
	call  cls_text
	call  SetPalette  
	call  ReadyPrompt
	call  InitTopBar
	call  StartUpPrompt
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Change to driver dir.                                                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       mov   esi,LoadDir
       mov   ecx,d_len-LoadDir
       call  FindDir
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Load Startup File.                                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call  LoadConfigFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Change to root dir.                                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov   esi,LoadRootDir
	mov   ecx,d_len1-LoadRootDir
	call  FindDir
	xor   ecx,ecx
	xor   edx,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Test for Gui Load at Startup.                                                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	cmp   [GuiStartup],0
	je    StartCLI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Start GUI.                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov   esi,LoadingGUImes
	call  print_string
	mov   esi,GuiProg
	mov   edi,dword[ImageLoadAddrVar]
	mov   ecx,h_len-GuiProg
	dec   ecx
	call  LoadFile
	jc    StartCLIerr
	call  Fdd_motor_off
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	call  dword[ImageLoadAddrVar]						  
	mov   ax,18h					
	mov   ds,ax
	mov   es,ax
	xor   eax,eax
	mov   ebx,eax
	mov   ecx,eax
	mov   edx,eax
	mov   [keybuffer],0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; StartCommand.                                                                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
StartCLI:
	mov   esi,StartCliNextLine
	call  print_string
StartCLI2:
	call  StartCommand2
@@:
	jmp   $
StartCLIerr:
	mov   esi,LoadingGUImesErr
	call  print_string
	jmp   StartCLI2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Data.                                                                            ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
StartCliNextLine: db 13,0
LoadRootDir: db '\ ',0
d_len1:
LoadDir: db '\DRIVERS',0
d_len:
GuiProg: db 'GUI.DEX',0
h_len:
include 'Drivers\Ata_Atapi32.inc'
include 'FileSys\ModList.inc'
include 'FileSys\MenuFileListGui.inc'
include 'FileSys\MenuFileListCdGui.inc'
include 'FileSys\MenuFileListHdd.inc'
include 'FileSys\Fat.inc'
include 'FileSys\Fat32Root.inc'
AddressTop:


